;=========================================================================
;
; Browser executable Application Programmer Interface (API)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     API_LoadLibFile
;Purpose  To load additional files for an executable.
;Input    A = ??
;         B = ??
;         C = ??
;         HL = Address of libraries to load.
;         DE = 
;In Vars  TBD
;Output   A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;Out Vars TBD
;Uses     None.
;Call by  TBD
;Calls    CPCB API (CPCB_C_LoadNewObj)
;Notes    TBD
;=========================================================================
API_LoadLibFile
   LD    C,(HL)			;Get Bank to load file to.
   INC   HL
   LD    DE,MEMORY_BANK2
   CALL  UTL_strcpy		;Download URL for external call
   PUSH  HL
   LD    A,C
   LD    DE,0			;Use load address of library
   LD    HL,MEMORY_BANK2
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_LoadNewObj
   POP   HL
   INC   HL			;point to start of next library file.
   LD    A,(HL)			;Get bank Number
   OR    A			;Invalid bank number?
   JR    NZ,API_LoadLibFile	;Yes (must be end of list)
   RET