;=========================================================================
;
; Browser executable Application Programmer Interface (API)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     API_CPCB_Init
;Purpose  To save the API initialisation setting.
;In Regs  A = ??
;         BC = start address of HTML Rom variables
;         DE = Address of parameter for the application.
;         HL = start address of CPCB web browser variables
;         IX = ??
;         IY = ??
;In Vars  CurrMemBank = variable in CPCB which indicates which bank the
;                       code is being run in.
;         PAR_Temp = version bytes (no date)
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         H = ??
;         L = ??
;         IX = ??
;         IY = ??
;Out Vars CPCB_VarsStart = start address of system variables.
;Uses     TBD
;Call By  TBD
;Calls    ??
;Notes    1. The parameter in DE is used to pass to the application the
;            path to a script (or other information).
;=========================================================================
API_CPCB_Init
   LD    (CPCB_Parameter),DE
;
   LD    A,(BASIC_START)
   CP    &C3			;Is call via CPCB browser?
   JR    NZ,API_CPCB_Init0	;No
;
   LD    A,(CurrMemBank)
   LD    (CPCB_ThisBank),A
   RET
;
API_CPCB_Init0
   POP   HL
   LD    HL,API_ErrMsg
API_CPCB_Init1
   LD    A,(HL)
   OR    A
   JR    Z,API_CPCB_Init2
   CALL  &bb5a
   INC   HL
   JR    API_CPCB_Init1
API_CPCB_Init2
   JR    API_CPCB_Init2
;=========================================================================
;
;  Variables/Constants for all applications
;
;=========================================================================
CPCB_Parameter	DEFW	0	;Specific parameter to App
;
CPCB_ThisBank	DEFB	0
;
API_Offset	DEFB	5
;
API_ErrMsg	DEFM	"No CPCB (reset CPC)"
		DEFB	13,10
		DEFB	0
