;=========================================================================
;
; Browser executable Application Programmer Interface (API)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     API_PrintChar
;Purpose  To display a character on the screen.
;In Regs  A = Stream Column (for new line)
;         B = End row
;         C = End column
;         D = ??
;         E = ASCII Character to show.
;         H = Start Column
;         L = Start Row
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = end row
;         C = end column
;         DE = ??
;         H = Column (updated)
;         L = Row (updated if new line)
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    API_AdjustRowCol
;         WIN_PrintChar (via CPCB_CPCAccess)
;Notes    1. If the cursor for the stream is outside then no output is
;            shown.
;=========================================================================
API_PrintChar
   EX    DE,HL
   CALL  API_AdjustRowCol
   EX    DE,HL
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_PrintChar
   RET
