;=========================================================================
;
; Browser executable Application Programmer Interface (API)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     API_ReqText
;Purpose  To request from the user a maximum of n character.
;In Regs  A = Echo back control
;         BC = ??
;         DE = ??
;         HL = Position offset within window.
;         IX = ??
;         IY = ??
;In Vars  Stream_Submenu = stream ID for sub-menu window (CPC window)
;         Window_ERow = bottom row of window
;         Window_ECol = right most column of window
;Out Regs AF = converted input.
;         BC = ??
;         DE = ??
;         HL = adress of entered text.
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer = corrupted with user input.
;         KB_KeyTested = corrupted
;         KB_printlen = setup
;         KB_MaxInpRC = setup
;Uses     TBD
;Call By  TBD
;Calls    VIY_CalcAddr
;         API_GetWinInput
;Notes    1. There are no checks to ensure that the user input does not
;            exceed the required digits for a number.
;=========================================================================
API_ReqText
   EX    DE,HL
   LD    HL,KB_Buffer
   LD    (HL),0
   LD    HL,Stream_Submenu
   LD    B,(HL)			;Stream number for display
   LD    C,0			;no existing input.
   LD    HL,KB_Buffer
;
   CALL  API_GetWinInput
;
   LD    HL,KB_Buffer
   RET
