;=====================================================================
;
; TCP/IP Application Program Interface (API) header - API.h
; Copyright (c) 2011 Ray Palmer
;
;=====================================================================
socket			EQU	0
bind			EQU	socket+3
connect			EQU	bind+3
listen			EQU	connect+3
accept			EQU	listen+3
send			EQU	accept+3
recv			EQU	send+3
swrite			EQU	recv+3
sread			EQU	swrite+3
recvfrom		EQU	sread+3
sendto			EQU	recvfrom+3
Sclose			EQU	sendto+3
gethostbyname		EQU	Sclose+3
gethostbyaddr		EQU	gethostbyname+3
select			EQU	gethostbyaddr+3
poll			EQU	select+3
shutdown		EQU	poll+3
;
Keyb_SetClientHand	EQU	shutdown+3
Keyb_SetLineHand	EQU	Keyb_SetClientHand+3
cons_init		EQU	Keyb_SetLineHand+3
cons_final		EQU	cons_init+3
cons_printchar		EQU	cons_final+3
cons_prompt		EQU	cons_printchar+3
;
Socket_GetStatus	EQU	cons_prompt+3
Socket_GetErrNo		EQU	Socket_GetStatus+3
Socket_Shutdown		EQU	Socket_GetErrNo+3
;
resolv_query		EQU	Socket_Shutdown+3
resolv_exit		EQU	resolv_query+3
;
parse_script		EQU	resolv_exit+3
;=====================================================================
MAX_SOCKETS		EQU	8
;=====================================================================
MAX_TIMEOUT		EQu	5000		;5 second timeout
;=====================================================================
;   Error codes for API's
;=====================================================================
NOERROR			EQU	0
GENERROR		EQU	255
;
EINVAL			EQU	1
EADDRINUSE		EQU	2
EADDRNOTAVAIL		EQU	3
EAFNOSUPPORT		EQU	4
EBADF			EQU	5
EINTR			EQU	6
ENOTSOCK		EQU	7
EOPNOTSUPP		EQU	8
EACCES			EQU	9
EDESTADDRREQ		EQU	10
EISDIR			EQU	11
EIO			EQU	12
ELOOP			EQU	13
ENAMETOOLONG		EQU	14
ENOENT			EQU	15
ENOTDIR			EQU	16
EROFS			EQU	17
EISCONN			EQU	18
ENOBUFS			EQU	19
EPROTONOSUPPORT		EQU	20
EMFILE			EQU	21
ENFILE			EQU	22
EPROTOTYPE		EQU	23
EAGAIN			EQU	24
ECONNREFUSED		EQU	25
EINPROGRESS		EQU	26
ETIMEDOUT		EQU	27
;=====================================================================
;  Socket types
;=====================================================================
SOCK_STREAM		EQU	1	;type for TCP (with OBD)
SOCK_DGRAM		EQU	2	;type for UDP
SOCK_SEQPACKET		EQU	3	;type for TCP
;
SOCK_TCP		EQU	1
SOCK_UDP		EQU	0
;=====================================================================
;  Socket item types
;=====================================================================
SKT_STATUS		EQU	0
SKT_FLAGS		EQU	1
SKT_STAT_FLAGS		EQU	2