;=====================================================================
;
; TCP/IP Equates (i.e compiler constants)
; Copyright (c) 2010 Ray Palmer
;
;=====================================================================
ROMWKSP			EQU 8
;=====================================================================
;
;  Fixed locations within AMSDOS for ROM work space vector.
;  &B8DA - Basic 1.1 (CPC6128)
;  &B1AC - Basic 1.0 (CPC464)
;
;=====================================================================
BaseROMMemLst0		EQU &B1AC   	;Address for Basic 1.0
BaseROMMemLst1		EQU &B8DA   	;Address for Basic 1.1
;=====================================================================
;FILE_ASCII		EQU &16
;=====================================================================
;
;  Miscellaneous
;
;=====================================================================
M_BIT0			EQU &01	;BIT 0
M_BIT1			EQU &02	;BIT 1
M_BIT2			EQU &03	;BIT 2
M_BIT3			EQU &08	;BIT 3
M_BIT4			EQU &10	;BIT 4
M_BIT5			EQU &20	;BIT 5
M_BIT6			EQU &40	;BIT 6
M_BIT7			EQU &80	;BIT 7
;=====================================================================
FALSE			equ 0
TRUE			equ 1
;=====================================================================
PROMPT			equ '>'
SWITCH			equ '-'
;=====================================================================
MAX_PPP_PAP_Sz		EQU 64
MAX_PPP_Sz              EQU &400	;
MAX_DomainName		EQU 32
MAX_SERVNAME		EQU 32
MAX_ACNAME		EQU 32
BUFF_START		EQU &E000
MEM_CFG_IOADDR		EQU &7FFF
MEM_CFG_NORMAL		EQU &C0
BASE_DNS_RR		EQU &4000
BASE_SKTBUFF		EQU &4000
MAX_MEMORY		EQU &4000	;Max size of banked memory
;=====================================================================
IPv4_AddrSz		EQU 4
TCPIP_Version           EQU &40	;Version 4 of TCP/IP.
VersMask                EQU &F0
IP_DEFAULT_VERIHL       EQU &45	;IPv4, no options
;=====================================================================
Sz_TIMEOUT		equ 15
;=====================================================================
; For converting seconds to timeout_set units
TICKS_PER_SEC		equ 50
;=====================================================================
NL			equ 10
;=====================================================================
UTIL_PWCR		equ 4
