;=========================================================================
;
; Application Routines (Divide - 16 Bit)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     Mth_Divide
;PURPOSE  Divide HL by DE, result in Reg BC
;Input    Reg HL = Number
;         Reg DE = Divisor
;Output   Reg BC = Number of DE in HL
;         Reg HL = Remainder
;         A = 0 if not divide by zero
;             255 if divide by zero (BC=0)
;Changes  None
;=========================================================================
Mth_Divide
   LD    BC,0
   LD    A,D
   OR    E
   JR    Z,Mth_DIV_ERR  ;Can not divide by Zero
Mth_DIV_LP
   SBC   HL,DE          ;Subtract DE from HL
   JR    C,Mth_DIV_EX   ;Underflow, too much taken
   INC   BC             ;Still more can be taken
   JR    Mth_DIV_LP     ;Do again
Mth_DIV_EX
   ADD   HL,DE          ;Restore remainder
   XOR   A              ;Flag ok
   RET
Mth_DIV_ERR
   LD    A,&FF          ;Flag error
   RET
