;=========================================================================
;
; Application Routines (UTL)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     Multiply
;PURPOSE  Routine to multiply numbers
;Input    Reg HL = Number
;         Reg DE = Multiplier
;Output   Reg HL = HL * DE
;         AF, DE corrupted.
;Changes  None
;=========================================================================
Mth_Multiply
   LD    A,H
   OR    L
   JR    Z,Mth_ZERO_Res  ;HL=0, Zero Answer
   LD    A,D
   OR    E
   JR    Z,Mth_ZERO_Res  ;DE=0, Zero Answer
   PUSH  BC
   LD    B,D             ;BC = multiplier
   LD    C,E
   LD    D,H
   LD    E,L
   LD    HL,0            ;Init HL
Mth_Mul_L1
   ADD   HL,DE
   DEC   BC
   LD    A,B
   OR    C
   JR    NZ,Mth_Mul_L1
   POP   BC
   RET
Mth_ZERO_res
   LD    HL,0
   RET


