;=====================================================================
;
; File        VAR_8Bit.ASM
; Copyright (c) 2010 Ray Palmer
;
; Created by  R. Palmer
; Created on  21-Oct-2013
; Updated on  26-Oct-2013
;
; Notes       1. Z80 is little-Endian format when direct save is
;                used/referenced (e.g LD (xxxx),HL)
;
;=====================================================================
;Name     VIY_GetVar8
;Purpose  To get the value of a variable indexed by Reg IY
;Input    HL = offset to variable
;Output   HL = address of variable 
;         A = Value of the variable
;Notes    None.
;=====================================================================
VIY_GetVar8
   CALL  VIY_CalcAddr
   LD    A,(HL)
   RET
;=====================================================================
;Name     VIX_GetVar8
;Purpose  To get the value of a variable indexed by Reg IX
;Input    HL = offset to variable
;Output   HL = address of variable 
;         A = Value of the variable
;Notes    None.
;=====================================================================
VIX_GetVar8
   CALL  VIX_CalcAddr
   LD    A,(HL)
   RET
;=====================================================================
;Name     VIY_SetVar8
;Purpose  To set the value of a variable indexed by Reg IY
;Input    HL = offset to variable
;         A = Value to save
;Output   HL = address of variable 
;Notes    None.
;=====================================================================
VIY_SetVar8
   CALL  VIY_CalcAddr
   LD    (HL),A
   RET
;=====================================================================
;Name     VHL_SetVar8
;Purpose  To set the value of a variable indexed by Reg IX
;Input    HL = offset to variable
;         A = Value to save
;Output   HL = address of variable 
;Notes    None.
;=====================================================================
VIX_SetVar8
   CALL  VIX_CalcAddr
   LD    (HL),A
   RET

