;=====================================================================
;
; File        VAR_Calc.ASM
; Copyright (c) 2010 Ray Palmer
;
; Created by  R. Palmer
; Created on  25 Jul 2010
; Updated on  29 Jun 2011
;
; Notes       1. Z80 is little-Endian format when direct save is
;                used/referenced (e.g LD (xxxx),HL)
;
;=====================================================================
;=====================================================================
;=====================================================================
;Name     VIY_CalcAddr
;Purpose  To calc the address of a variable indexed by IY
;Input    IY = Address of System variables
;         HL = offset to variable
;Output   HL = address of system variable 
;Notes    None.
;=====================================================================
VIY_CalcAddr
   PUSH  DE
   PUSH  IY
   JR    VA_CalcAddr
;=====================================================================
;Name     VIX_CalcAddr
;Purpose  To calc the address of a variable indexed by IX
;Input    IX = Address of local data
;         HL = offset to variable
;Output   HL = address of system variable 
;Notes    None.
;=====================================================================
VIX_CalcAddr
   PUSH  DE
   PUSH  IX
VA_CalcAddr
   POP   DE	;DE = Base address of data/variables
   ADD   HL,DE	;HL = Address of variable
   POP   DE
   RET

