;=====================================================================
;
; File        VIX_BEG.ASM
; Copyright (c) 2010 Ray Palmer
;
; Created by  R. Palmer
; Created on  25 Jul 2010
; Updated on  26-Oct-2013
;
; Notes       1. Z80 is little-Endian format when direct save is
;                used/referenced (e.g LD (xxxx),HL)
;
;             2. These routines are for Little-Endian handling.
;
;=====================================================================
;
;   Routines to get variables 16/32 bits via Reg IX
;
;=====================================================================
;Name     VIX_LE_GetVarBC
;Purpose  To get the value of a System variable
;Input    HL = offset to variable
;Output   HL = address of variable 
;         BC = Value of the variable
;Notes    None.
;=====================================================================
VIX_LE_GetVarBC
   CALL  VIX_CalcAddr
   JP    VAR_LE_GetValBC
;=====================================================================
;Name     VIX_LE_GetVarDE
;Purpose  To get the value of a System variable
;Input    HL = offset to variable
;Output   HL = address of variable 
;         DE = Value of the variable
;Notes    None.
;=====================================================================
VIX_LE_GetVarDE
   CALL  VIX_CalcAddr
   JP    VAR_LE_GetValDE
;=====================================================================
;Name     VIX_LE_GetVarHL
;Purpose  To set the value of a system variable
;Input    HL = offset to variable
;Output   HL = Value got
;Notes    None.
;=====================================================================
VIX_LE_GetVarHL
   CALL  VIX_CalcAddr
   JP    VAR_LE_GetValHL
;=====================================================================
;Name     VIX_LE_GetVar32
;Purpose  To get the value of a Local variable
;Input    HL = offset to variable
;Output   HL = address of variable 
;         BC/DE = Value of the variable
;Notes    None.
;=====================================================================
VIX_LE_GetVar32
   CALL  VIX_CalcAddr
   JP    VAR_LE_GetVal32


