;=====================================================================
;
; File        VIX_LES.ASM
; Copyright (c) 2010 Ray Palmer
;
; Created by  R. Palmer
; Created on  25 Jul 2010
; Updated on  26-oCT-2013
;
; Notes       1. Z80 is little-Endian format when direct save is
;                used/referenced (e.g LD (xxxx),HL)
;
;             2. These routines are for Little-Endian handling.
;
;=====================================================================
;
;   Routines to set variables 16/32 bits via Reg IX
;
;=====================================================================
;Name     VIX_LE_SetVarBC
;Purpose  To set the value of a Local variable
;Input    HL = offset to variable
;         BC = Value to set
;Output   HL,DE changed 
;Notes    None.
;=====================================================================
VIX_LE_SetVarBC
   CALL  VIX_CalcAddr
   JP    VAR_LE_SetValBC
;=====================================================================
;Name     VIX_LE_SetVarDE
;Purpose  To set the value of a System variable
;Input    HL = offset to variable
;         DE = Value to set
;Output   HL,DE changed 
;Notes    None.
;=====================================================================
VIX_LE_SetVarDE
   CALL  VIX_CalcAddr
   JP    VAR_LE_SetValDE
;=====================================================================
;Name     VIX_LE_SetVar32
;Purpose  To set the value of a system variable
;Input    HL = offset to variable
;         BC/DE = Value to set
;Output   HL,DE changed 
;Notes    None.
;=====================================================================
VIX_LE_SetVar32
   CALL  VIX_CalcAddr
   JP    VAR_LE_SetVal32

