;=====================================================================
;
; File        VIY_BEG.ASM
; Copyright (c) 2010 Ray Palmer
;
; Created by  R. Palmer
; Created on  25 Jul 2010
; Updated on  26-oCT-2013
;
; Notes       1. Z80 is little-Endian format when direct save is
;                used/referenced (e.g LD (xxxx),HL)
;             2. These routines are for Big-Endian handling.
;
;=====================================================================
;
;   Routines to get variables 8/16/32 bits via Reg IY
;
;=====================================================================
;Name     VIY_BE_GetVarBC
;Purpose  To get the value of a System variable
;Input    HL = offset to variable
;Output   HL = address of variable 
;         BC = Value of the variable
;Notes    None.
;=====================================================================
VIY_BE_GetVarBC
   CALL  VIY_CalcAddr
   JP    VAR_BE_GetValBC
;=====================================================================
;Name     VIY_BE_GetVarDE
;Purpose  To get the value of a System variable
;Input    HL = offset to variable
;Output   HL = address of variable 
;         DE = Value of the variable
;Notes    None.
;=====================================================================
VIY_BE_GetVarDE
   CALL  VIY_CalcAddr
   JP    VAR_BE_GetValDE
;=====================================================================
;Name     VIY_BE_GetVarHL
;Purpose  To set the value of a system variable
;Input    HL = offset to variable
;Output   HL = Value got
;Notes    None.
;=====================================================================
VIY_BE_GetVarHL
   CALL  VIY_CalcAddr
   JP    VAR_BE_GetValHL
;=====================================================================
;Name     VIY_BE_GetVar32
;Purpose  To get the value of a Local variable
;Input    HL = offset to variable
;Output   HL = address of variable 
;         BC/DE = Value of the variable
;Notes    None.
;=====================================================================
VIY_BE_GetVar32
   CALL  VIY_CalcAddr
   JP    VAR_BE_GetVal32


