;=====================================================================
;
; File        VIY_BES.ASM
; Copyright (c) 2010 Ray Palmer
;
; Created by  R. Palmer
; Created on  25 Jul 2010
; Updated on  26-oCT-2013
;
; Notes       1. Z80 is little-Endian format when direct save is
;                used/referenced (e.g LD (xxxx),HL)
;             2. These routines are for Big-Endian handling.
;
;=====================================================================
;
;   Routines to set variables 16 bits via Reg IY
;
;=====================================================================
;Name     VIY_BE_SetVarBC
;Purpose  To set the value of a Local variable
;Input    HL = offset to variable
;         BC = Value to set
;Output   HL,DE changed 
;Notes    None.
;=====================================================================
VIY_BE_SetVarBC
   CALL  VHL_CalcAddr
   JP    VAR_BE_SetValBC
;=====================================================================
;Name     VIY_BE_SetVarDE
;Purpose  To set the value of a System variable
;Input    HL = offset to variable
;         DE = Value to set
;Output   HL,DE changed 
;Notes    None.
;=====================================================================
VIY_BE_SetVarDE
   CALL  VIY_CalcAddr
   JP    VAR_BE_SetValDE
;=====================================================================
;Name     VIY_BE_SetVar32
;Purpose  To set the value of a system variable
;Input    HL = offset to variable
;         BC/DE = Value to set
;Output   HL,DE changed 
;Notes    None.
;=====================================================================
VIY_BE_SetVar32
   CALL  VIY_CalcAddr
   JP    VAR_BE_SetVal32
