;=====================================================================
;
; File        lib-varh.ASM
;
; Purpose     To provide a gneral set of routines to handle access to
;             variables indexed by Registers IX and IY.
;
; Copyright (c) 2010 Ray Palmer
;
; Created by  R. Palmer
; Created on  15 Oct 2013
; Updated on  15 Oct 2013
;
; Notes       1. Z80 is little-Endian format when direct save is
;                used/referenced (e.g LD (xxxx),HL)
;
;=====================================================================
;=====================================================================
;Name     VIY_CalcAddr
;Purpose  To calc the address of a variable indexed by Reg IY
;Input    IY = Address of data
;         HL = offset to variable
;Output   HL = address of variable 
;Notes    None.
;=====================================================================
VIY_CalcAddr
   PUSH  DE
   LD    DE,(CPCB_VarsStart)
   JR    VAR_CA_1
;=====================================================================
;Name     VIX_CalcAddr
;Purpose  To calc the address of a variable indexed by Reg IX
;Input    IX = Address of data
;         HL = offset to variable
;Output   HL = address of variable 
;Notes    None.
;=====================================================================
VIX_CalcAddr
   PUSH  DE
   LD    DE,(HTML_VarsStart)
VAR_CA_1
   ADD   HL,DE		;HL = Address of variable
   POP   DE
   RET
