;=====================================================================
;
; Grpahics utility library (grph_bdraw)
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. Kernel.h
;
;=====================================================================
;Name     grph_bdraw
;Purpose  To draw a box using vectors.
;Input    IX = address of box table data
;          A = number of parameters
;Output   screen output
;Uses     All register corrupted
;Notes    1. For a unfilled box the parameters are -
;            a. X coordinate
;            b. Y coordinate
;            c. X length
;            d. Y height
;         2. For a filled box the parameters are -
;            a. X coordinate
;            b. Y coordinate
;            c. length
;            d. height
;            e. XI
;         3. X/Y coordinates are bottom left of drawn box
;=====================================================================
grph_bdraw
   CP    4
   JR    Z,grph_openb
   CP    5
   JR    Z,grph_closedb
   RET
grph_openb
   CALL  grph_movep
   LD    E,(IX+2)
   LD    D,(IX+3)
   LD    HL,0
   CALL  SC_REL_DRWLNE
   LD    DE,0
   LD    H,(IX+0)
   LD    L,(IX+1)
   CALL  SC_REL_DRWLNE
   CALL  grph_movep
   LD    DE,0
   LD    H,(IX+0)
   LD    L,(IX+1)
   CALL  SC_REL_DRWLNE
   LD    E,(IX+2)
   LD    D,(IX+3)
   LD    HL,0
   CALL  SC_REL_DRWLNE
   RET
grph_closedb
   CALL  SC_GET_ORIGIN
   PUSH  DE
   PUSH  HL
   LD    L,(IX+6)
   LD    H,(IX+7)
   LD    E,(IX+8)
   LD    D,(IX+9)
   CALL  SC_SET_ORIGIN
   LD    C,(IX+2)
   LD    B,(IX+3)
   LD    HL,0
grph_closedb_loop
   LD    E,(IX+4)
   LD    D,(IX+5)
   PUSH  BC
   PUSH  HL
   LD    HL,0
   CALL  SC_REL_DRWLNE
   POP   HL
   INC   HL
   PUSH  HL
   LD    DE,0
   CALL  SC_SET_CURSOR
   POP   HL
   POP   BC
   DEC   BC
   LD    A,B
   OR    C
   JR    NZ,grph_closedb_loop
   POP   HL
   POP   DE
   CALL  SC_SET_ORIGIN
   RET
;
grph_movep
   LD    L,(IX+4)
   LD    H,(IX+5)
   LD    E,(IX+6)
   LD    D,(IX+7)
   CALL  SC_REL_MOVE
   RET
