;=====================================================================
;
; Grpahics utility library (grph_gdraw)
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. Kernel.h
;
;=====================================================================
;Name     grph_gdraw
;Purpose  To draw an object using vectors.
;Input    IX = address of shape table
;Output   screen output
;Uses     All register corrupted
;Notes    1. Shape table entry format is as follows-
;             a. OpCode
;             b. X coordinate (word, LSB first)
;             c. Y coordinate (word, LSB first)
;            For colour entry
;             a. OpCode
;             b. Colour byte
;=====================================================================
grph_gdraw
   LD    A,(IX+0)
   OR    A				;End of table?
   RET   Z				;Yes
;
   CP    GDRAW_ABSMVE
   CALL  Z,grph_move
;
   CP    GDRAW_ABSDRW
   CALL  Z,grph_draw
;
   CP    GDRAW_COLOUR
   CALL  Z,grph_colour
;
   CP    GDRAW_ABSPLT
   CALL  Z,grph_plot
;
   INC   IX
   JR    grph_gdraw
;
grph_colour
   INC   IX
   LD    A,(IX+0)
   INC   IX
   CALL  SC_SET_PEN
   XOR   A
   RET
;
grph_move
   CALL  grph_coords
   CALL  SC_SET_CURSOR
   XOR   A
   RET
;
grph_draw
   CALL  grph_coords
   CALL  SC_ABS_DRWLNE
   XOR   A
   RET
;
grph_plot
   CALL  grph_coords
   CALL  SC_ABS_PLTLNE
   XOR   A
   RET
;
grph_coords
   LD    E,(IX+0)
   INC   IX
   LD    D,(IX+0)
   INC   IX
   LD    L,(IX+0)
   INC   IX
   LD    H,(IX+0)
   INC   IX
   RET
