;=====================================================================
;
; Grpahics utility library (grph_prtstring)
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. Kernel.h
;
;=====================================================================
;Name     grph_prtstring
;Purpose  To print a string using graphic OS calls.
;Input    BC = pixel spaces ebwteen chars
;         HL = Y coordinate
;         DE = X coordinate
;         IX = address of string
;Output   string output
;Uses     All register corrupted
;Notes    1. This routine only works for mon-spaced characters.
;=====================================================================
grph_prtstring
   PUSH  BC
   PUSH  DE
   PUCH  HL
   CALL  SC_SET_CURSOR		;set cursor position
   POP   HL
   POP   DE
   POP   BC
   LD    A,(IX+0)
   OR    A				;End of string
   RET   Z				;Yes
   PUSH  BC
   PUSH  DE
   PUCH  HL
   CALL  SC_PRT_CHAR		;display char at position
   POP   HL
   POP   DE
   POP   BC
   EX    DE,HL
   ADD   HL,BC
   EX    DE,HL
   INC   IX
   JR    grph_prtstring
