;=====================================================================
;
; Grpahics utility library (grph_varchar)
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. Kernel.h
; 2. lib-grph.h
;
;=====================================================================
;Name     grph_varchar
;Purpose  To print a character using graphic OS calls with a variable
;         the height (but same width)
;Input    IX = address of parameters
;         A = number of parameters
;Output   string output
;Uses     All register corrupted
;Notes    None
;=====================================================================
grph_varchar
   CP    2
   RET   NZ
   LD    A,(IX+0)
   LD    (grph_height),A
   CALL  KL_ROM_STATUS			;Get current rom state
   PUSH  AF
   LD    A,(IX+2)
   CALL  TXT_GET_CHRPAT			;Get location of char pattern
   LD    DE,grph_patternarray
   LD    BC,8
   LDIR
   POP   AF
   CALL  KL_ROM_RESTORE
;
   LD    IX,grph_patternarray
   LD    D,8
grph_vchr_loop1
   LD    A,(IX+0)
   LD    C,A
   LD    B,8
grph_vchr_loop2
   SLA   C
   CALL  grph_GETCURS
   JR    C,grph_ZERO
   CALL  grph_VERTS
   JR    grph_OUT
grph_ZERO
   CALL  grph_VERT
grph_OUT
   DJNZ  grph_vchr_loop2
   INC   IX
   CALL  grph_OUTH
   DEC   D
   JR    NZ,grph_vchr_loop1
   RET
;
grpg_printblock
   PUSH  HL
   PUSH  DE
   PUSH  BC
   LD    DE,6
   LD    HL,0
   CALL  SC_REL_DRWLNE
   POP   BC
   POP   DE
   POP   HL
   RET
;
grph_printspace
   PUSH  HL
   PUSH  DE
   PUSH  BC
   LD    DE,6
   LD    HL,0
   CALL  SC_REL_MOVE
   POP   BC
   POP   DE
   POP   HL
   RET
;
grph_OUTH
   PUSH  BC
   PUSH  HL
   PUSH  DE
   LD    HL,0
   LD    A,(grph_height)
   LD    B,A
grph_OUTH1
   DEC   HL
   DEC   HL
   DJNZ  grph_OUTH1
   LD    DE,-48			;Go back 8*6 pixels
   CALL  SC_REL_MOVE
   POP   DE
   POP   HL
   POP   BC
   RET
;
grph_getcurs
   PUSH  BC
   PUSH  HL
   PUSH  DE
   PUSH  AF
   CALL  SC_GET_CURSOR
   LD    B,6
grph_getcurs1
   INC   DE
   DJNZ  grph_getcurs1
   LD    (grph_tempx),DE
   LD    (grph_tempy),HL
   POP   AF
   POP   DE
   POP   HL
   POP   BC
   RET
;
grph_restore
   PUSH  BC
   PUSH  DE
   PUSH  HL
   LD    DE,-6
   LD    HL,-2
   CALL  SC_REL_MOVE
   POP   DE
   POP   HL
   POP   BC
   RET
;
grph_next
   PUSH  AF
   PUSH  BC
   PUSH  DE
   PUSH  HL
   LD    DE,(grph_tempx)
   LD    HL,(grph_tempy)
   CALL  SC_SET_CURSOR
   POP   HL
   POP   DE
   POP   BC
   POP   AF
   RET
;
grph_vert
   PUSH  BC
   CALL  grph_getcurs
   LD    A,(grph_height)
   LD    B,A
grph_vert_vloop
   CALL  grph_printblock
   CALL  grph_restore
   DJNZ  grph_vert_vloop
   CALL  grph_next
   POP   BC
   RET
;
grph_verts
   PUSH  BC
   CALL  grph_getcurs
   LD    A,(grph_height)
   LD    B,A
grph_verts_loop
   CALL  grph_printspace
   CALL  grph_restore
   DJNZ  grph_verts_vloop
   CALL  grph_next
   POP   BC
   RET
