;=========================================================================
;
; Standard print library
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. Kernal.h
;
;=========================================================================
;Name     printstring
;Purpose  To display a string.
;Input    HL = address of NUL terminated string.
;Output   HL = address of NUL in string.
;Uses     TBD
;Notes    1. printf ("%s, @Reg_HL)
;=========================================================================
printstring
   push  af
printstring_loop
   ld    a,(hl)
   inc   hl
   or    a
   call  nz,TXT_OUTPUT
   jr    nz,printstring_loop
   pop   af
   ret
;=========================================================================
;Name     printstringimm
;Purpose  Print NUL-terminated string starting at return address
;Input    TOS = address of string to print.
;Output   TBD
;Uses     TBD
;Notes    1. printf ("%s, @TOS)
;=========================================================================
printstringimm
   ex    (sp),hl
   call  printstring
   ex    (sp),hl
   ret
;=========================================================================
;Name     printcrlf
;Purpose  print a new line.
;Input    None.
;Output   None.
;Uses     None.
;Notes    printf ("\n")
;=========================================================================
printcrlf
   CALL  printstringimm
   DEFB  CR,LF,0
   RET
;=========================================================================
;Name     printcrlfmaybe
;Purpose  Same as printcrlf, except do nothing if already at first column
;Input    None.
;Output   None.
;Uses     None.
;Notes    printf ("\n")
;=========================================================================
printcrlfmaybe
   push  af
   push  hl
   push  iy
   call  TXT_GET_CURSOR		;A = roll count
   or    a			;Has screen rolled down a line?
   call  nz,printcrlf		;No (so output CR and LF)
   pop   iy
   pop   hl
   pop   af
   ret
