;=====================================================================
;
; Standard string conversion routines (hexdigit)
; Copyright (c) 2010 Ray Palmer
;
; Requires -
; 1. isdigit.asm
; 2. tolower.asm
;
;=====================================================================
;Name     UTL_hexdigit
;Purpose  This routines converts a hexadecimal character to a
;         numerical value.
;Input    A = character to check.
;Output   A = value (0-15 ok, 16=invalid)
;Uses     Flags corrupted.
;Notes    1. If the character is not a valid hexadecimal character a
;            value of 16 is returned to indicate conversion error.
;=====================================================================
UTL_hexdigit
   CALL  UTL_isdigit		;Is valid numerical digit?
   JR    C,UTL_hexdigit_1	;No (check if hex letter)
   sub   '0'			;convert '0' to '9' to number
   RET
UTL_hexdigit_1
   CALL  UTL_tolower
   CP    'a'			;is char < 'a'?
   JR    C,UTL_hexdigit_2	;Yes (error)
   sub   'a'-10			;A = 10 to 15 for a to f
   LD    B,A
   AND   &f0			;Is A > 15?
   JR    NZ,UTL_hexdigit_2	;Yes (error)
   LD    A,B
   RET
UTL_hexdigit_2
   LD    A,16
   ret

