;=========================================================================
;
; Standard Application Routines
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     URL_LastDot
;Purpose  To goto the last dot char in a string of NUL terminated text.
;In Regs  AF = ??
;         BC = ??
;         DE = ??
;         HL = address of string
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = address of char after last "." in string
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars None
;Uses     TBD
;Call By  TBD
;Calls    NONE
;Notes    TBD
;=========================================================================
URL_LastDot
   LD    C,"."
;=========================================================================
;Name     UTL_LastChar
;Purpose  To goto the last occurence of a char in a string of NUL
;         terminated text.
;In Regs  AF = ??
;         B = ??
;         C = char to locate.
;         DE = ??
;         HL = address of string
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = address of last occurence of char in string
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars None
;Uses     TBD
;Call By  TBD
;Calls    NONE
;Notes    TBD
;=========================================================================
UTL_LastChar
   LD    A,(HL)
   INC   HL
   OR    A			;end of text?
   RET   Z			;Yes
   CP    C			;found a 'dot'?
   JR    NZ,URL_LastDot		;No, do next char in txt
   LD    D,H			;track where found char
   LD    E,L
   JR    URL_LastDot
