;=====================================================================
;
; Standard string conversion routines (readdec16)
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. isdigit.asm
;
;=====================================================================
;Name     UTL_readdec2
;Purpose  Read a decimal in the range 0-65535
;Input    DE = source string of decimal number characters
;Output   HL = result
;         DE = address of first non-digit character.
;Uses     AF corrupted (has invalid digit)
;Notes    1. If string is > '65535' then result is uncertain.
;=====================================================================
UTL_readdec2
   push  bc
   ld    hl,0
;
rddec2_loop
   ld    a,(de)
   call  UTL_isdigit		;Is character a digit?
   jr    c,rddec2_done		;No (end of numerical string)
;
   inc   de
   sub   '0'			; A contains next digit to shift in
   ld    b,h			; BC = Current result
   ld    c,l
   add   hl,hl			; HL = 2 * BC
   add   hl,hl			; HL = 4 * BC
   add   hl,bc			; HL = 5 * BC
   add   hl,hl			; HL = 10 * BC
   ld    b,0
   ld    c,a
   add   hl,bc			; HL = (10 * BC) + A
   JR    rddec2_loop
;
rddec2_done
   pop   bc
   ret
