;=====================================================================
;
; Standard string conversion routines (readdec8)
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. isdigit.asm
;
;=====================================================================
;Name     UTL_readdec
;Purpose  Read a decimal string in the range 0-255
;Input    HL = source string of decimal number characters
;Output   A = value read
;         HL = next charcter after string converted
;Uses     F flag corrupted.
;Notes    1. Only a maximum of 3 digit characters converted.
;         2. If string is > 255 then result is uncertain.
;=====================================================================
UTL_readdec
   push   bc
   LD     B,0			;B = current result.
;
rddec_loop
   ld     a,(HL)
   INC    HL			;Next digit string character
   call   UTL_isdigit		;Valid digit character?
   jr     c,rddec_done		;No (end of string)
;
   sub    '0'			;Convert to digit char to number
   ld     c,a			;D = converted number
   ld     a,b
   add    a,a			;A = E * 2
   add    a,a			;A = E * 4
   add    a,b			;A = E * 5
   add    a,a			;A = E * 10
   add    a,c			;A = (E * 10) + D
   LD     B,A			;Save current result
;
   JR     rddec_loop
;
rddec_done
   LD     A,B
   pop    bc
   ret
