;=====================================================================
;
; Standard string conversion routines (readhex16)
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. hexdigit.asm
;
;=====================================================================
;Name     UTL_readhex16
;Purpose  Read a hexidecimal string in the range 0-FFFF
;Input    DE = source string of decimal number characters
;Output   HL = result
;         DE = address of first non-digit character.
;Uses     AF corrupted.
;Notes    1. If string is > FFFF then result is uncertain.
;=====================================================================
UTL_readhex16
   PUSH  BC
   LD    HL,0
;
rdhex16_loop
   LD    A,(DE)
   call  UTL_hexdigit		;Is character a hex digit?
   CP    16
   JR    Z,rdhex16_done	;No (end of numerical string)
   INC   de
   ADD   HL,HL			;multiply by 2
   ADD   HL,HL			;multiply by 2
   ADD   HL,HL			;multiply by 2
   ADD   HL,HL			;multiply by 2
   LD    B,0
   LD    C,A
   ADD   HL,BC
   JR    rdhex16_loop
;
rdhex16_done
   POP   BC
   RET
