;=====================================================================
;
; Standard string conversion routines (readhex8)
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. hexdigit.asm
;
;=====================================================================
;Name     UTL_readhex8
;Purpose  Read a hexidecimal string in the range 0-FF
;Input    HL = source string of decimal number characters
;Output   A = result
;         HL = address of first non-digit character.
;Uses     AF corrupted.
;Notes    1. If string is > FF then result is uncertain.
;=====================================================================
UTL_readhex8
   push  bc
   LD    B,0
;
rdhex8_loop
   ld    a,(HL)
   inc   HL
   PUSH  BC
   call  UTL_hexdigit
   POP   BC
   cp    16			;Is character a hex digit?
   jr    Z,rdhex8_done		;No (end of numerical string)
   ld    c,a
   ld    a,b
   add   a,a
   add   a,a
   add   a,a
   add   a,a
   add   a,c
   ld    b,a
   jr    rdhex8_loop
;
rdhex8_done
   ld    a,b
   pop   bc
   ret
