;=========================================================================
;
; Standard Application Routines
; Copyright (c) 2010 Ray Palmer
;
; Requires
; 1. tolower.asm
;
;=========================================================================
;Name     UTL_strncmpCI
;Purpose  To compare two strings of n characters (case insensitive)
;In Regs  A = ??
;         B = number of characters
;         DE = address of string 1
;         HL = address of string 2
;         IX = ???
;         IY = ??
;In Vars  N/A
;Out Regs A = 0 if both string are the same
;         B = 0 if both n characters the same. 
;         C = Unchanged.
;         DE = corrupted.
;         HL = corrupted.
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    None.
;Notes    1. This routine is case sensitive.
;=========================================================================
UTL_strncmpCI
   LD    A,(DE)
   CALL  utl_tolower
   LD    C,A
   LD    A,(HL)
   CALL  utl_tolower
   CP    C
   RET   NZ
   INC   HL
   INC   DE
   DJNZ  UTL_strncmpCI
   RET