;=========================================================================
;
; Standard Application Routines (strncpy)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     UTL_strncpy
;Purpose  To copy n characters
;In Regs  A = ??
;         B = max chars to copy
;         C = ??
;         DE = destination location for data
;         HL = address of source text
;         IX = ???
;         IY = ??
;In Vars  None
;Out Regs AF = ??
;         B = 0 if all characters copied
;             (maybe >0 if NUL encountered first)
;         C = ??
;         DE = destination address of where n bytes copied to
;         HL = source address of where n bytes copied from
;         IX = ??
;         IY = ??
;Out Vars None
;Calls    None
;Notes    1. Copy is limited to 256 byte strings.
;         2. The copy will end if source is less then 256 bytes
;=========================================================================
UTL_strncpy
   LD   A,(HL)
   LD   (DE),A
   OR   A
   RET  Z
   INC  HL
   INC  DE
   DJNZ UTL_strncpy
   RET
