;=====================================================================
;
; Standard string conversion routines (writedec8)
; Copyright (c) 2010 Ray Palmer
;
; Requires -
; 1. writedec8.asm
;
;=====================================================================
;Name     UTL_wrdiv16
;Purpose  To insert a digit char.
;Input    BC = address to insert char
;         HL = value to add as char
;         DE = divisor
;Output   BC = BC + 1
;         HL = remainder
;Uses     TBD
;Notes    None
;=====================================================================
UTL_wrdiv16
   PUSH  BC
   CALL  Mth_Divide
   LD    E,C
   POP   BC
   LD    A,(LeadingZeros)
   OR    E
   LD    (LeadingZeros),A
   OR    A
   JR    NZ,UTL_wrdiv16a
   LD    E,&20-'0'
UTL_wrdiv16a
   LD    A,E
   ADD   A,'0'
   LD    (BC),A
   INC   BC
   RET
;=====================================================================
;Name     util_writedec16
;Purpose  To convert an unsigned decimal number in the range 0 to
;         65535 to a string with no leading zeros.
;Input    BC = address to save string
;         HL = value to convert
;         A = 0 if leading zeros are displayed.
;Output   BC += sprintf (BC, "%u", DE) -- without trailing NUL
;Uses     AF corrupted.
;Notes    None
;=====================================================================
UTL_writedec16
   LD    (LeadingZeros),A
   push  bc
   push  de
   LD    DE,10000		;DE = number of 10000's
   CALL  UTL_wrdiv16
   LD    DE,1000		;DE = number of 1000's
   CALL  UTL_wrdiv16
   LD    DE,100			;DE = number of 100's
   CALL  UTL_wrdiv16
   LD    DE,10			;DE = number of 10's
   CALL  UTL_wrdiv16
   LD    A,L
   ADD   A,'0'
   LD    (BC),A
   pop   de
   pop   bc
   ret
LeadingZeros	DEFB	0