;=====================================================================
;
; Standard string conversion routines (writehex8)
; Copyright (c) 2010 Ray Palmer
;
;=====================================================================
;Name     UTL_Hex2Char
;Purpose  To convert a value 0-15 to a hexadecimal character
;Input    A = value to insert
;Output   A = hexadecimal character
;Uses     AF corrupted.
;Notes    None
;=====================================================================
UTL_Hex2Char
   AND   &0f
   cp   10			;Is A > 10
   jr   c,Hex2Char1		;No
   add  a,'a' - '0' - 10	;Yes, adjust for Hex char
Hex2Char1
   add  a,'0'			;offset to numbers
   RET
;=====================================================================
;Name     UTL_inshex8
;Purpose  To insert the hex char into the string.
;Input    HL = address to save string
;         A = value to insert
;Output   TBD
;Uses     AF corrupted.
;Notes    None
;=====================================================================
UTL_inshex8
   CALL  UTL_Hex2Char
   LD    (DE),A
   INC   DE
   RET
;=====================================================================
;Name     UTL_writehex8
;Purpose  To convert an unsigned number in the range 0 to 255 to a
;         hex string with leading zeros.
;Input    HL = address to save string
;         A = value to convert
;Output   HL += sprintf (HL, "%x", A)
;Uses     AF corrupted.
;Notes    None
;=====================================================================
UTL_writehex8
   PUSH  DE
   PUSH  BC
   EX    DE,HL			;DE = address of byte data to convert
   PUSH  AF
   SRL   A
   SRL   A
   SRL   A
   SRL   A
   CALL  UTL_inshex8
   POP   AF
   CALL  UTL_inshex8
   EX    DE,HL
   POP   BC
   POP   DE
   RET
   ld    A,E
   SET   0,C			;force insert of digit char
   CALL  UTL_insdigchr
   pop   de
   pop   bc
   ret