;=====================================================================
;
; CPC Operating System Kernal Re-directions
; Copyright (c) 2010 Ray Palmer
;
;=====================================================================
;
;  Lower Kernel Handler
;
;=====================================================================
KL_FAR_PCHL             equ  &001b
;=====================================================================
;
;  Upper Kernel Handler (OS)
;
;=====================================================================
KL_FIND_COMMAND         equ  &bcd4
KL_TIME_PLEASE          equ  &bd0d
KL_INIT_EVENT           equ  &bcef
KL_NEW_FAST_TICKER      equ  &bce0
KL_DEL_FAST_TICKER      equ  &bce6
KL_DEL_SYNCHRONOUS      equ  &bcf8
KL_ADD_TICKER           equ  &bce9
KL_DEL_TICKER           equ  &bcec
KL_POLL_SYNCHRONOUS     equ  &b921
KL_NEXT_SYNC            equ  &bcfb
KL_DO_SYNC              equ  &bcfe
KL_DONE_SYNC            equ  &bd01
KL_CURR_SELECTION       equ  &b912
KL_ROM_SELECT		EQU  &B90F
KL_ROM_RESTORE		EQU  &B90C
KL_ROM_STATUS		EQU  &B906
;=====================================================================
;
;  Kernel Manager handler
;
;=====================================================================
KM_READ_CHAR            equ  &bb09
KM_SET_TRANSLATE        equ  &bb27
KM_SET_CONTROL          equ  &bb33
KM_INITIALISE           equ  &bb00
KM_SCAN_KEYS            equ  &bdf4
KM_DISARM_BREAK         equ  &bb48
KM_TESTKEY		EQU  &BB1E
KM_WAIT_KEY		EQU  &BB18
KM_WAIT_CHAR		EQU  &BB06
;=====================================================================
;
;  Text Handlers
;
;=====================================================================
TXT_OUTPUT              equ  &bb5a
TXT_WR_CHAR             equ  &bb5d
TXT_WRITE_CHAR		EQU  &BBD3
TXT_GET_CHAR		EQU  &bb60
TXT_GET_CURSOR          equ  &bb78
TXT_SET_CURSOR		EQU  &BB75
TXT_CUR_ENABLE		EQU  &BB7B
TXT_CUR_DISABLE		EQU  &BB7E
TXT_CUR_ON              equ  &bb81
TXT_CUR_OFF             equ  &bb84
TXT_PLACE_CURSOR        equ  &bb8a
TXT_REMOVE_CURSOR       equ  &bb8d
TXT_GET_CHRPAT		EQU  &BBA5
TXT_SET_CHRPAT		EQU  &BBA8
TXT_SET_M_TBLE		EQU  &BBAB
TXT_INITIALISE		EQU  &BB43
TXT_CLR_WIN		EQU  &BB6C
TXT_SET_PEN		EQU  &bb90
TXT_SET_PAPER		EQU  &bb96
;=====================================================================
;
;  Graphic handlers
;
;=====================================================================
GRA_SET_PEN		EQU  &bbde
GRA_SET_PAPER		EQU  &bbe4
;=====================================================================
;
;  Cassette / Disk handlers
;
;=====================================================================
CAS_IO_RESET		EQU  &BC65
CAS_IN_OPEN             equ  &bc77
CAS_IN_CLOSE            equ  &bc7a
CAS_IN_ABANDON          equ  &bc7d
CAS_IN_CHAR             equ  &bc80
CAS_IN_DIRECT           equ  &bc83
CAS_TEST_EOF		EQU  &BC89
CAS_OUT_OPEN            equ  &bc8c
CAS_OUT_CLOSE           equ  &bc8f
CAS_OUT_ABANDON         equ  &bc92
CAS_OUT_CHAR            equ  &bc95
CAS_OUT_DIRECT          equ  &bc98
CAS_CATALOG		EQU  &BC9B
;=====================================================================
;
;  Screen/Window Frame Handlers
;
;=====================================================================
SC_SET_CURSOR		EQU  &BBC0
SC_GET_ORIGIN		EQU  &BBCC
SC_PRT_CHAR		EQU  &BBFC
SC_ABS_DRWLNE		EQU  &BBF6
SC_REL_DRWLNE		EQU  &BBF9
SC_REL_MOVE		EQU  &BBC3
SC_GET_CURSOR		EQU  &BBC6
SC_SET_ORIGIN		EQU  &BBC9
SC_SET_PEN		EQU  &BBDE
SC_ABS_PLTLNE		EQU  &BBEA
SC_SEL_STREAM		EQU  &BBB4
SC_SET_TXTWIN		EQU  &BB66
SC_VDU_ENABLE		EQU  &BB54
SC_SET_POSCOL		EQU  &BB6F
SC_SET_POSROW		EQU  &BB72
SC_GET_GRAHPIC		EQU  &BB63
SC_SET_MODE		EQU  &BC0E
SC_SET_INK		EQU  &bc32
SC_SET_BORDER		EQU  &bc38
