;=====================================================================
;
; keyboard constants
; Copyright (c) 2010 Ray Palmer
;
;=====================================================================
;
;  EQUATES
;
;=====================================================================
TAB_SPACING		equ 8			; Must be a power of 2
;=====================================================================
CTRL_C			equ	3		;Abort keyboard input
CTRL_E			equ	5		;Toggle echo mode
HCR			equ	13 + &a0
HDLE			equ	16 + &a0
HESC			equ	27 + &a0
COPY			equ	&e0
INS			equ	&e1
UP			equ	&f0
DOWN			equ	&f1
LEFT			equ	&f2
RIGHT			equ	&f3
SHIFT_UP		equ	&f4
SHIFT_DOWN		equ	&f5
SHIFT_LEFT		equ	&f6
SHIFT_RIGHT		equ	&f7
CTRL_UP			equ	&f8
CTRL_DOWN		equ	&f9
CTRL_LEFT		equ	&fa
CTRL_RIGHT		equ	&fb
BREAK			equ	&fc
KCUB1			equ	LEFT
KCUD1			equ	DOWN
KCUF1			equ	RIGHT
KCUU1			equ	UP
KHOME			equ	CTRL_LEFT
KICH1			equ	INS
KDCH1			equ	HDLE
KEND			equ	CTRL_RIGHT
KPP			equ	CTRL_UP
KNP			equ	CTRL_DOWN
KQUIT			equ	BREAK
KTOGGLE			equ	COPY
;=====================================================================
;
; Keyboard control codes
;
; A telnet console may expect the following imported symbols -
; NUL, BEL, BS, TAB, LF, CR, ESC, DEL
;
;=====================================================================
SOH			equ	1	; (hijacked for ignore)
STX			equ	2	; Disable cursor
ETX			equ	3	; Enable cursor
VT			equ	11	; Cursor up
FF			equ	12	; Clear screen and home
SO			equ	14	; Set paper
SI			equ	15	; Set ink
DC1			equ	17	; Clear to BOL
DC2			equ	18	; Clear to EOL
DC4			equ	20	; Clear to EOS
CAN			equ	24	; (hijacked for stand-out)
EM			equ	25	; (hijacked for normal)
SUB_			equ	26	; (hijacked for FIXME scroll region)
FS			equ	28	; (hijacked for cursor forward)
GS			equ	29	; (hijacked for FIXME visible bell)
RS			equ	30	; Home
US			equ	31	; Locate
;
; ASCII control codes
;
NUL			equ	0
BEL			equ	7
BS			equ	8
TAB			equ	9
LF			equ	10
CR			equ	13
ESC			equ	27
DEL			equ	127
;