;=====================================================================
; TCP/IP Terminal Control Protocol (TCP) layer Include file
; Copyright (c) 2010 Ray Palmer
;
;=====================================================================
;
;  EQUATES
;
;=====================================================================
;
; Don't renumber these as some bits of code rely on the ordering
; Values match those from wikipedia info, except CLOSE = 11 not 0
;
;=====================================================================
TCP_CLOSED_STATE	equ	0
TCP_LISTEN_STATE	equ	1
TCP_SYNSENT_STATE	equ	2
TCP_SYNRECEIVED_STATE	equ	3
TCP_ESTABLISHED_STATE	equ	4
TCP_FINWAIT1_STATE	equ	5
TCP_FINWAIT2_STATE	equ	6
TCP_CLOSEWAIT_STATE	equ	7
TCP_CLOSING_STATE	equ	8
TCP_LASTACK_STATE	equ	9
TCP_TIMEWAIT_STATE	equ	10
TCP_SINK_STATE		equ	11	; Just throw away packet
;=====================================================================
;
; Reason codes for CLOSUP
;
; Connection terminated bidirectionally
;   - tcp_unbind has already been called
;   - tcp_connect may be called again from upcall
;=====================================================================
TCP_CLOSE_NORMAL	equ	&80
;=====================================================================
; tcp_connect refused
;   - tcp_unbind has already been called
;   - tcp_connect may be called again from upcall
;=====================================================================
TCP_CLOSE_REFUSED	equ	&40
;=====================================================================
; Remote has signalled a reset
;   - tcp_unbind has already been called
;   - tcp_connect may be called again from upcall
;=====================================================================
TCP_CLOSE_RESET		equ	&20
;=====================================================================
; Remote has signalled a close
;   - tcp_close may be called from upcall
;     this will eventually be acknowledged by a TCP_CLOSE_NORMAL
;=====================================================================
TCP_CLOSE_REMOTE	equ	&10
;=====================================================================
; Reason codes for SENTUP
;   We've heard something (after a tcp_listen)
;=====================================================================
TCP_SENT_INIT		equ	15
;=====================================================================
;   We've managed to send something (from SNDBUF)
;=====================================================================
TCP_SENT_NORMAL		equ	16
;=====================================================================
