;===============================================================================
;
; Browser application constants
; Copyright (c) 2010 Ray Palmer
;
;===============================================================================
MAXFILENAMETXT	EQU 13
AMSDOS_BUFFER	EQU &3800
LOGTEXT_LOCN	EQU &4900		;location of catalog in banked memory
;===============================================================================
MEMCFGDEFAULT	EQU &C0
BankStackSz	EQU 16			;max 16 level of return banks
;===============================================================================
DOUBLE_QUOTE	EQU	&22
SINGLE_QUOTE	EQU	&27
SPACE_CHAR	EQU	32
LINEFEED_CHAR	EQU	10
SLASH_CHAR	EQU	'/'
BSLASH_CHR	EQU	'\'
SHTML_CHR	EQU	'<'
EHTML_CHR	EQU	'>'
SSTYL_CHR	EQU	'{'
ESTYL_CHR	EQU	'}'
DSTYL_CHR	EQU	';'
EQUAL_CHR	EQU	'='
DBLEQ_CHR	EQU	'"'
HASH_CHAR	EQU	'#'
DASH_CHR	EQU	'-'
DOT_CHAR	EQU	'.'
COLON_CHR	EQU	':'
COMMA_CHR	EQU	','
STAR_CHR	EQU	'*'
NULL_CHAR	EQU	0
;
KB_BuffSz	EQU	256
KB_SrchSz	EQU	64
KB_PASSWD	EQU	&01		;Bit 0 (hidden input echoed)
KB_MULTILINE	EQU	&80		;Bit 7 (multi-line input)
SysGenBuffer	EQU	MEMORY_BANK2
SysBnkBuffer	EQU	MEMORY_SWAP_ST
LM_Database	EQU	MEMORY_SWAP_ST	;16K of Links Mgr hyperlinks DB
LM_DBEntry	EQU	MEMORY_BANK2	;DB entry for Manager,etc
BinLoadAddr	EQU	MEMORY_SWAP_ST
;===============================================================================
MAX_IN_DIGITS	EQU	10
;===============================================================================
;
;===============================================================================
REQUEST_TYP1	EQU	0		;URL as is, new input
REQUEST_TYP2	EQU	&0001		;URL as is, update existing text
REQUEST_TYP3	EQU	&0100		;Refresh URL, new input
REQUEST_TYP4	EQU	&0101		;Refresh URL, update exiting input
;===============================================================================
;
;  Hyperlinks DB for shown from the HTML data in the main memory.
;
;  Max DB entries = 4096/7 = 585 entries
;
;===============================================================================
DB_HyperLink	EQU	&7000			;4K of hyperlinks data
MAX_DBLINKS	EQU	6
;=========================================================================
;
; Special System Icons chars
;
;=========================================================================
ICON_BLOCK	EQU	0
ICON_PICTURE	EQU	1
ICON_ARROW	EQU	2
ICON_XHAIRS	EQU	3
ICON_BIGDOT	EQU	4
ICON_CIRCLE	EQU	5
ICON_SQUARE	EQU	6
ICON_OBJECT	EQU	7
ICON_RADBOFF	EQU	8
ICON_CHKBRD	EQU	9
ICON_RADBON	EQU	10
ICON_CHKBXOFF	EQU	11
ICON_CHKBXON	EQU	12
ICON_DROPDWN	EQU	13
ICON_BUTTONOFF	EQU	14
ICON_BUTTONON	EQU	15
ICON_MENUOFF	EQU	16
ICON_MENUON	EQU	17
ICON_COMPUTER	EQU	18
ICON_NETWKON	EQU	19
ICON_NETWKOFF	EQU	20
ICON_PPAGE	EQU	21
ICON_NPAGE	EQU	22
ICON_HPAGE	EQU	23
ICON_APPLET	EQU	24
ICON_TIMERV0	EQU	25
ICON_TIMERV1	EQU	26
ICON_TIMERV2	EQU	27
ICON_TIMERV3	EQU	28
ICON_IMAGE	EQU	31		;icon for image handler
;
PRINT_ICONCHR	EQU	B_7		;Flag to show icon
;
;  The indices are aligned with which icons are loaded during the
;  system startup script.
;
SYSTEM_ICONSET	EQU	0	;Standard System Icon
FRAMES_ICONSET	EQU	1	;Standard frames icon
THINBRDR_ICNST	EQU	2	;Thin border icon set
MEDMBRDR_ICNST	EQU	3	;Medium border icon set 
THIKBRDR_ICNST	EQU	4	;Thick border icon set
DBLEBRDR_ICNST	EQU	5	;Bouble border icon set
DOTDBRDR_ICNST	EQU	6	;Dotted border icon set
TRPLBRDR_ICNST	EQU	7	;Triple Border icon set (ridge like)
GROVBRDR_ICNST	EQU	8	;Groove border icon set
DASHBRDR_ICNST	EQU	9	;Dashed border icon set
;
BORDERS_HARD	EQU	0	;bit 7 (off)
BORDERS_SOFT	EQU	B_7	;bit 7 (on)
BORDERS_START	EQU	0	;Offset to  border/frame icons
;=========================================================================
;  Size of URL
;=========================================================================
URL_Size		EQU	128
URL_MaxItems		EQU	32
URL_HistSize		EQU	URL_Size*URL_MaxItems
MaxURLText		EQU	69
DB_MaxLinks		EQU	255			;Max in 4096 bytes
;
URLType_HTTP		EQU	0
URLType_EXE		EQU	1
URLType_BIN		EQU	2
UTLType_UNK		EQU	255
URL_C_NOFILENAME	EQU	&8E
URL_C_HISTITM		EQU	1
;=========================================================================
MaxAppName	EQU	18
MaxAppFileName	EQU	13			;HDOS/AMSDOS filename length
;=========================================================================
;  Window/Stream definitions
;
;  Stream  Details
;   1      Main Menu window columns 1 to Max Cols, rows 1 to 4
;   2      Web Page window  columns 1 to Max Cols, rows 5 to 25
;=========================================================================
BaseCPCOffset	EQU	0
;
; Screen definitions on the default stream for the main menu stream
; (BASIC coordinates)
;
SC_MainMenu	EQU	1
EC_MainMenu	EQU	80		;Max cols (mode 2)
SR_MainMenu	EQU	1
ER_MainMenu	EQU	4
;
; Screen definitions on the default stream for the web-page stream
; (BASIC coordinates)
;
SC_WebPage	EQU	1		;column 1
EC_WebPage	EQU	80		;column 80 (max cols)
SR_WebPage	EQU	5		;row 5
ER_WebPage	EQU	25		;row 25
;=========================================================================
;
;  Screen positional offsets
;
Off_WebPge	EQU	&0005		;offset from top row (0)
Col1Row1	EQU	&0202		;Offset to text in windows
;
ERRMSG_POS	EQU	&0100		;column 1, row 0
;
CursorPOS	EQU	&1A01		;col=26, row=1
MAINMENU_POS	EQU	&0101
URLHDR_POS	EQU	&0102
SUBMENU_POS	EQU	&0103
WPTITLE_POS	EQU	&0104
TIMER_POS	EQU	&1801		;
;
;  Offsets into sub-menu window for data display.
;
DBLINK_POS	EQU	&0605		;col = 4, row = 4
DBLINK2_POS	EQU	&0603		;col = 6, row = 3
DBLINK3_POS	EQU	&0604		;col = 6, row = 4
ACCESS_POS	EQU	&0D03		;col = 13, row = 3
SYSDET_POS	EQU	&0F03		;col = 15, row = 3
MEMCFG_POS	EQU	&0903		;col = 9, row = 3
CATFCI_POS	EQU	&1103		;col = 17, row = 3
CATFFF_POS	EQU	&1303		;col = 19, row = 3
CATFSC_POS	EQU	&0304		;col = 3, row = 4
PAGES_POS	EQU	&0C03		;Col = 12, row = 3
MACU_POS	EQU	&0F05		;Col = 15, Row = 5
MACD_POS	EQU	&0F06		;Col = 15, Row = 6
MACL_POS	EQU	&0F08		;Col = 15, Row = 8
MACR_POS	EQU	&0F07		;Col = 15, Row = 7
MACS_POS	EQU	&0F09		;Col = 15, Row = 9
MACT_POS	EQU	&0F0A		;Col = 15, Row = 10
MACI_POS	EQU	&0F0B		;Col = 15, Row = 11
URLT_POS	EQU	&0A02		;Col = 10, Row = 2
;
MaxWebPgRow	EQU	ER_WebPage-SR_WebPage	;Max rows to show html
SCRNROWSTRT	EQU	ER_MainMenu+1		;start line
SCRNROWEND	EQU	ER_WebPage		;bottom line
;
WEBPAGE_BASELOC	EQU	0
MAXWEBPAGECOLS	EQU	65535
;=========================================================================
MaxErrText	EQU	49
MaxURLPrint	EQU	71
MAXWebTitle	EQU	75
;=========================================================================
Find_Fail	EQU	0
Find_Okay	EQU	1
;=========================================================================
KB_WAITTIME	EQU	&180
KB_CURSWAIT	EQU	10000
;=========================================================================
;
;  Key codes to handle keyboard key presses for error message/menus and
;  general web-page viewing.
;
;=========================================================================
KEY_CURSORS	EQU	254
KEY_ENDLIST	EQU	255
KB_EOL		EQU	1
KB_NOTEOL	EQU	0
KB_DEL		EQU	127
