;===============================================================================
;
; Browser application constants for external routine access
; Copyright (c) 2010 Ray Palmer
;
;===============================================================================
;  CPCB jump vector access
;
;  Address &170 is the base compilation address of CPCB.EXE
;
;  CPCB_DbugTrap  = Generic Trap for emulator
;  CPCB_SysAccess = Routine which on exit restores memory to default
;                   (no longer available)
;  CPCB_CPCAccess = Routine which on exit restores memory to previous.
;
;==============================================================================
App_StartAddr		EQU	&170
;
CPCB_DbugTrap		EQU	App_StartAddr+3
CPCB_CPCAccess		EQU	App_StartAddr+6
CPCB_ExtAccess		EQU	App_StartAddr+9
CPCB_SaveRegs		EQU	App_StartAddr+12
CPCB_GetBnkByte		EQU	App_StartAddr+15
CPCB_GetBnkWord		EQU	App_StartAddr+18
CPCB_SetBnkByte		EQU	App_StartAddr+21
CPCB_SetBnkWord		EQU	App_StartAddr+24
CPCB_GetBnkStr		EQU	App_StartAddr+27
CPCB_CpyMem		EQU	App_StartAddr+30
;
CPCB_StartVars		EQU	App_StartAddr+33
;===============================================================================
;
;  Constants for CPCB routines access via a jump vector.
;  The vector is defined in cpcb-do.inc
;
;  The index into the vector can be any number which is within the range of
;  values shown. Should the value be outside the range shown below the access
;  will not happen.
;
;===============================================================================
;
CPCB_C_OpenDevPth	EQU	0	;FIO_OpenDevPath
;
CPCB_C_OpenAppURL	EQU	1	;URL_OpenAppURL
;
CPCB_C_RemoveCursor	EQU	2	;KB_RemoveCursor
;
CPCB_C_ParseScript	EQU	3	;PAR_ParseAScript
;
CPCB_C_Wait4aKey	EQU	4	;KB_Wait4akey
;
CPCB_C_NewFontEffect	EQU	5	;FNT_NewEffect

CPCB_C_OpenNewObj	EQU	6	;URL_OpenNewObj
;
CPCB_C_DoAppReq		EQU	7	;App_DoAppReq
;
CPCB_C_GetWinInput	EQU	8	;KB_GetWinInput
;
CPCB_C_WinPrint		EQU	9	;WIN_PrintStr
;
CPCB_C_APICE		EQU	10	;API_CommonEntry
;
CPCB_C_ShowPageTitle	EQU	11	;MNU_ShowPageTitle
;
CPCB_C_ScrollFrame	EQU	12	;HTML_ScrollFrame
;
CPCB_C_NonScrollFrame	EQU	13	;HTML_NonScrollFrame
;
CPCB_C_SelectFontByName	EQU	14	;FNT_SelectFontByName
;
CPCB_C_ShowPropFont	EQU	15	;FNT_ShowPropFont
;
CPCB_C_SelectFontByIndx	EQU	16	;FNT_SelectFontByIndx
;
CPCB_C_PicHandler	EQU	17	;IMG_PicHandler
;
CPCB_C_ClearArea	EQU	18	;WIN_ClearArea
;
CPCB_C_PrintChar	EQU	19	;WIN_PrintChar
;
CPCB_C_PrintStr		EQU	20	;WIN_ShowWindwData
;
CPCB_C_DisplayChar	EQU	21	;WIN_DisplayChar
;
CPCB_C_ShowBorder	EQU	22	;WIN_ShowBorder
;
CPCB_C_PrintIcon	EQU	23	;FNT_PrintIcon
;
CPCB_C_setupIcnData	EQU	24	;FNT_setupIcnData
;
CPCB_C_ChkFrmes		EQU	25	;WIN_ChkFrmes
;
CPCB_C_ResetCursor	EQU	26	;FNT_ResetCursor
;
CPCB_C_GetDateByte	EQU	27	;UTL_GetDateByte
;
CPCB_C_ShowWindowItem	EQU	28	;MNU_ShowWindowItem
;
CPCB_C_AddNewApp	EQU	29	;App_AddNewItem
;
CPCB_C_FindApp		EQU	30	;App_FindApp
;
CPCB_C_OpenURLLink	EQU	31	;URL_OpenURLLink
;
CPCB_C_ShowTimer	EQU	32	;FNT_ShowTimer
;
CPCB_C_ShwErrorMsg	EQU	33	;Err_ShowErrorMsg
;
CPCB_C_LoadNewObj	EQU	34	;Err_ShowErrorMsg
;
CPCB_B_MAXINDEX		EQU	35	;invalid index check (must +1 of last)
