;  =================================================
;               DEBUG CODE
;  =================================================
;
;File    debug.asm
;Copyright (c) 2010 Ray Palmer
;
;Created  14-Jul-2004
;
;Updated  22 Apr 2010 - Cutdown for space.
;
;Notes   1.  The display routine are local.
;
;   Function         Call format
;
;   ShowDebugT       CALL ShowDebugT
;                    DEFB Number
;
;   DBUGLock1        CALL DBUGLock1
;
;  =================================================
DEOSTR          EQU 0
;
ShowDebugT
;
;  Main Entry for Trace and Debug
;
     CALL  DBUGSaveRegs
     POP   HL
     LD    (DBRegX),HL
     LD    B,(HL)            ;Get Trace Number
     INC   HL
     PUSH  HL
     PUSH  BC
     LD    A,B
     CALL  PrintHex          ;Trace Number
     LD    A,"-"
     CALL  TXT_OUTPUT
     POP   BC
     POP   HL                ;Get return Address
     PUSH  HL                ;Put it back
     CALL  ShowDebugT_Regs
;  =================================================
DBUG_B
     LD    A,13
     CALL  TXT_OUTPUT
     LD    A,10
     CALL  TXT_OUTPUT
;  =================================================
DBUGRestoreRegs
     LD    BC,(DBRegA)
     PUSH  BC
     POP   AF
     LD    BC,(DBRegBC)
     LD    DE,(DBRegDE)
     LD    HL,(DBRegHL)
     LD    IX,(DbRegIX)
     LD    IY,(DBRegIY)
     RET
;  =================================================
DBUGSaveRegs
     LD    (DBRegBC),BC
     LD    (DBRegDE),DE
     LD    (DBRegHL),HL
     LD    (DBRegIX),IX
     LD    (DBRegIY),IY
     PUSH  AF
     POP   BC
     LD    (DBRegA),BC
     RET
;  =================================================
ShowDebugT_Regs
     LD    HL,(DBRegX)
     CALL  PrintHex2         ;Show Address
     LD    A,":"
     CALL  TXT_OUTPUT
     LD    HL,(DBRegA)
     CALL  DBUG_Z80
     LD    HL,(DBRegBC)
     CALL  DBUG_Z80
     LD    HL,(DBRegDE)
     CALL  DBUG_Z80
     LD    HL,(DBRegHL)
     CALL  DBUG_Z80
     LD    HL,(DBRegIX)
     CALL  DBUG_Z80
     LD    HL,(DBRegIY)
     CALL  PrintHex2
     RET
;  =================================================
DBUG_Z80
     CALL  printhex2
     LD    A,","
     JP    TXT_OUTPUT
;
DBRegA    EQU   &BE84
DBRegBC   EQU   DBRegA+2
DBRegDE   EQU   DBRegBC+2
DBRegHL   EQU   DBRegDE+2
DBRegIX   EQU   DBRegHL+2
DBRegIY   EQU   DBRegIX+2
DBRegSP   EQU   DBRegIY+2
DBRegX    EQU   DBRegSP+2
DBTrapVal EQU   DBRegX+2       ;Value to trap on
DBTrapAdd EQU   DBTrapVal+2    ;Address to trap at
;