;  =================================================
;               DEBUG CODE
;  =================================================
;
;File    debug.asm
;
;Created  14-Jul-2004
;
;Updated  22 Apr 2010 - Cutdown for space.
;
;Notes   1.  The display routines are from the HDOS
;            hd-msg.asm file.
;
;   Function         Call format
;
;   ShowDebugT       CALL ShowDebugT
;                    DEFB Number
;
;  =================================================
;
;-----------------------------------------------------------------
;Name     db_DigitHex
;Purpose  To display a number as a hex digit character.
;Input    A = number
;Output   Screen output of digit.
;Uses     None.
;Notes    None.
;-----------------------------------------------------------------
db_DigitHex
   AND   &F
   cp    10                   ;Is A > 10
   jr    c,db_DigitHex1   ;No
   add   a,'a' - '0' - 10     ;Yes, adjust for Hex char
db_DigitHex1
   add   a,'0'                ;offset to numbers
   JR    db_Char_1
;-----------------------------------------------------------------
;Name     db_Digit
;Purpose  Display a numerical Character (0-9).
;Input    C = Number (0-9) or &F0 for space.
;         B = digit display control flag
;Output   None.
;Changes  None
;-----------------------------------------------------------------
db_Digit
   LD    A,C
;-----------------------------------------------------------------
;Name     db_Digit2
;Purpose  Display a numerical Character (0-9).
;Input    A = Number (0-9) or &F0 for space.
;         B = digit display control flag
;Output   None.
;Changes  None
;-----------------------------------------------------------------
db_Digit2
   ADD   A,&30                ;Convert to '0' to '9' char or ' '
   CP    ' '                  ;Space Char?
   JR    NZ,db_Char2     ;No
   BIT   2,B                  ;Display spaces?
   RET   NZ                   ;No
;-----------------------------------------------------------------
;Name     db_Char2
;Purpose  Display a Single Character via OS calls
;Input    A = Character
;Output   None.
;Changes  None
;-----------------------------------------------------------------
db_Char2
   AND   &7F                  ;Ensure only valid chars displayed
   CP    10                   ;Line feed ?
   JR    Z,db_Char_1     ;Yes
   CP    13                   ;Carriage return ?
   JR    Z,db_Char_1     ;Yes
   CP    31                   ;More than char 31 ?
   JR    NC,db_Char_1    ;yes
   LD    A," "
db_Char_1
   PUSH  BC
   PUSH  HL
   PUSH  DE
   CALL  &bb5a
   POP   DE
   POP   HL
   POP   BC
   RET
;---------------------------------------------------------------
;Name     printhex
;Purpose  Display a 2 digit hex number via OS calls
;Input    A = number
;Output   Text displayed
;Changes  None
;-----------------------------------------------------------------
PrintHex
   PUSH  AF
   RR    A
   RR    A
   RR    A
   RR    A
   CALL  db_DigitHex    ;Output upper hex char
   POP   AF
   JP    db_DigitHex    ;Output lower hex char
;---------------------------------------------------------------
;Name     PrintHex2
;Purpose  Display a 4 digit hex number via OS calls
;Input    HL = number
;Output   Text displayed
;Changes  None
;-----------------------------------------------------------------
PrintHex2
   LD    A,H
   CALL  printhex
   LD    A,L
   JP    printhex
