;===============================================================================
;
; Application Constants for the HTML rendering commands/routines
; Copyright (c) 2010 Ray Palmer
;
;===============================================================================
IMG_BYTEPERCHR		EQU	8
;===============================================================================
HTML_MaxWebPgeRC	EQU	65535
HTML_MAXSTR		EQU	128
;===============================================================================
NumHTMLCommands		EQU	110
HTML_ObjTempSz		EQU	32
;
;  HTML_TblMaxCells = maximum number of table cells for header info
;
HTML_TblMaxCells	EQU	64
;
HTML_List_UnOrd		EQU	1		;Bit 0
HTML_List_Ord		EQU	2		;Bit 1 - Numbers
HTML_List_Ord2		EQU	3		;bits 0 & 1 - Letters
HTML_DD_Ident		EQU	8
;
;  Flags to control text output
;
HTML_F_SysChrs		EQU	0		;Bit 1 - clear (sys fnt only)
HTML_F_FntChrs		EQU	B_2		;Bit 1 - set (use fonts)
HTML_F_FntIcns		EQU	B_7		;Bit 7 - set (show icon)
;
;  Font effects flags/settings
;
FONT_E_INVERSE		EQU	255
FONT_E_STRIKE		EQU	B_4
FONT_E_UNDERLINE	EQU	B_7
;
FONT_E_DELETE		EQU	66
FONT_B_DELETE		EQU	B_3
HTML_I_LineSz		EQU	B_7
HTML_I_TxtBoxSz		EQU	512
;
;  Forms input icon numbers
;
HTML_P_TEXT		EQU	1		;Not Used yet
HTML_P_PASSWD		EQU	2		;Not Used yet
HTML_P_BUTTON_D		EQU	7		;Not Used yet
HTML_P_BUTTON_U		EQU	7		;Not Used yet
HTML_P_CHKBOX_D		EQU	12
HTML_P_CHKBOX_U		EQU	11
HTML_P_RADIO_D		EQU	10
HTML_P_RADIO_U		EQU	8
HTML_P_FILE		EQU	7		;General Object icon
HTML_P_IMAGE		EQU	1
HTML_P_OPTION_D		EQU	14
HTML_P_OPTION_U		EQU	15
HTML_P_GROUP_U		EQU	27		;Group Up
HTML_P_GROUP_D		EQU	26		;Group down
HTML_P_BLOCK		EQU	0
HTML_P_EODB		EQU	255
;
HTML_I_MAXBLKS		EQU	10
HTML_MaxVars		EQU	32
HTML_I_MAXSTR		EQU	20		;max length of text
HTML_I_MAXSTR2		EQU	20		;max length of password text
;
MAX_FRAME_ITEMS		EQU	8
MAX_FRAMES		EQU	MAX_FRAME_ITEMS*2
MAX_USR_FRAMES		EQU	MAX_FRAMES-2
HTML_C_EODB		EQU	0
HTML_StartFrame		EQU	2
HTML_C_FrmeLock		EQU	B_7
HTML_C_FrmeScroll	EQU	B_6
HTML_C_FrmePosn		EQU	B_5
HTML_C_FrmeFree		EQU	B_4
;
HTML_C_PlainText	EQU	B_7
HTML_C_UseFonts		EQU	B_1
;
HTML_C_FindURL		EQU	&00
HTML_C_FindTxtNew	EQU	B_0
HTML_C_FindTxtNxt	EQU	B_1
;
HTML_S_Unk		EQU	0
HTML_S_Java		EQU	1		;Java script
HTML_S_Simple		EQU	2		;Custom script for CPC
;
HTML_C_FrameRows	EQU	&3700
HTML_C_FrameCols	EQU	&3780
;
;  <head>/<body> constants
;  the value for head_xxxxx is same for <html>
;
FLAGS_HEAD		EQU	&90
FLAGS_HEADS		EQU	&80
FLAGS_HEADE		EQU	&10
FLAGS_HEADB		EQU	&8010
FLAGS_HEADR		EQU	&6F
;
FLAGS_BODY		EQU	&09
FLAGS_BODYS		EQU	&08
FLAGS_BODYE		EQU	&01
FLAGS_BODYB		EQU	&0801
FLAGS_BODYR		EQU	&F6
;