;=========================================================================
;
; Application Routines (HTML rendering commands for the CPC Browser)
; Copyright (c) 2010 Ray Palmer
;
; Notes
;
; 1. The rendering of the current command does not expect that the same
;    command to be recursed. This may lead to an infinte loop if
;    attempted.
;
; 2. Where a command changes the font (e.g normal to italic) the original
;    command will have no way of reverting the font back to what it was if
;    the corresponding end command is not encountered.
;
;=========================================================================
;
;  HTML ROM routines/command handler locations
;
;=========================================================================
ROM_BaseAddress		EQU	&C000+15
;
HTM_ROM_ShowFile	EQU	0
HTM_ROM_Init		EQU	3
HTM_FindHyperLink	EQU	6
HTM_FindText		EQU	9
HTM_ROM_ViewHTML	EQU	12
HTM_FindURLLabel	EQU	15
HTM_FindFormItem	EQU	18
HTM_ActionFormItem	EQU	21
HTM_CalcFrameCPC	EQU	24
HTM_FindFrameIcon	EQU	27
HTM_ShowChar		EQU	30
HTM_FindAppIcon		EQU	33
;
