;=========================================================================
;
; external application for CPCB
; Copyright (c) 2010 Ray Palmer
;
;=====================================================================
;Name     Start_App
;Purpose  To connect the CPC to a network via the TCP/IP socket API
;         functions.
;In Regs  AF = ??
;         B = ??
;         C = ??
;         D = ??
;         E = ??
;         H = ??
;         L = ??
;         IX = ??
;         IY = ??
;In Vars  None
;Out Regs AF = ??
;         B = ??
;         C = ??
;         D = ??
;         E = ??
;         H = ??
;         L = ??
;         IX = ??
;         IY = ??
;Out Vars TCPIP_State = updated to reflect new status
;                       (Var in CPCB.EXE)
;Call By  CPCB
;Calls    CONNCT_SetupRSX
;         CONNCT_CallRSXCmd
;         CONNCT_Himem
;         CONNCT_InitRes
;         CONNCT_GetDrivers
;Notes    1. This application will perform the same process as the
;            basic program used to establish the device connection to
;            host services.
;         2. The top of memory is contained at &AE5E/&AE7B (6128/464).
;            With HDOS/CPCIP Top of Memory after reset is &9A6E.
;         3. After initialisation of TCP/IP Top of memory is &82C4.
;=====================================================================
   LD    HL,CONNCT_DEVMGR
   CALL  CONNCT_SetupRSX	;Device Drivers rom installed?
   RET   NC			;No
;
   LD    HL,CONNCT_TCPIPINIT
   CALL  CONNCT_SetupRSX	;TCP/IP ROM Missing ?
   RET   NC			;Yes
;
;  Call TCP/IP Initialisation routine.
;
   CALL  CONNCT_Himem
   LD    HL,CONNCT_MaxBuff
   LD    (RSX_PARAMETERS),HL
   LD    HL,1
   LD    (RSX_PARAMETERS+2),HL
   LD    HL,(CONNCT_HIMEM)
   LD    (RSX_PARAMETERS+4),HL
   LD    IX,RSX_PARAMETERS
   LD    A,3
   CALL  CONNCT_CallRSXCmd
;
   CALL  CONNCT_InitRes		;get Status of TCP/IP Initialisation
   OR    A			;Was enough memory available
   RET   Z			;No
;
   CALL  CONNCT_GetDrivers	;Install TCP/IP comms drivers
;
   LD    HL,TCPIP_CFGLEN
   LD    (RSX_PARAMETERS+2),HL
   LD    HL,CONNCT_TXTBUFF	;location of loaded config script.
   LD    (RSX_PARAMETERS),HL
   LD    HL,CONNCT_TCPIPLOAD
   CALL  CONNCT_SetupRSX
   LD    IX,RSX_PARAMETERS
   LD    A,2
   CALL  CONNCT_CallRSXCmd	;load and config comms device.
;
   LD    HL,CONNCT_TCPIPON
   CALL  CONNCT_SetupRSX
   LD    IX,RSX_PARAMETERS
   LD    A,0
   CALL  CONNCT_CallRSXCmd	;start TCP/IP ticker event to handle packets
;
   LD    DE,TCPIP_State
   CALL  VIY_CalcAddr
   LD    A,1
   LD    (HL),A			;flag TCP/IP is now running.
   RET