;=========================================================================
;
; Application Routines (System Configuration handler)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
Filename_Cursor		defb	"cursor.seq",0
FileExe_Cursor		defb	"savecurs.exe",0
;
Filename_urls		defb	"urls.seq",0
FileExe_urls		defb	"saveurls.exe",0
;
Filename_Apps		defb	"apps.seq",0
FileExe_Apps		defb	"saveapps.exe",0
;
Filename_Locs		defb	"locs.seq",0
FileExe_locs		defb	"savelocs.exe",0
;
Filename_Lnks		defb	"links.seq",0
FileExe_lnks		defb	"savelnks.exe",0
;
;=========================================================================
;Name     CFG_LinkSave
;Purpose  To save the current DB of links for other sessions.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. The filename for the saved links DB is 'links.txt'
;=========================================================================
CFG_LinkSave
   LD    DE,Filename_Lnks
   CALL  FIO_ReqFName
;=========================================================================
;Name     CFG_SaveCfg
;Purpose  To save the session links to media.
;In Regs  AF = ??
;         BC = ??
;         DE = ??
;         HL = address of filename text
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = TBD
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars FileOpState = status of file handling.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
CFG_SaveCfg
   EX    DE,HL
   LD    HL,FileExe_lnks
   JP    App_StartCfgApp
;=========================================================================
;Name     FIO_SaveCursor
;Purpose  To save the cursor configuration.
;In Regs  AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars FileOpState = status of file handling.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
CFG_SaveCursor
   LD    DE,Filename_Cursor
   LD    HL,FileExe_Cursor
   JP    App_StartCfgApp
;=========================================================================
;Name     CFG_SaveURLs
;Purpose  To save the saved session links.
;In Regs  AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars FileOpState = status of file handling.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
CFG_SaveURLs
   LD    DE,Filename_urls
   LD    HL,FileExe_urls
   JP    App_StartCfgApp
;=========================================================================
;Name     FIO_SaveApps
;Purpose  To save the applications/handler db which are not disabled.
;In Regs  AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars FileOpState = status of file handling.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
CFG_SaveApps
   LD    DE,Filename_apps
   LD    HL,FileExe_apps
   JP    App_StartCfgApp
;=========================================================================
;Name     FIO_SaveLocs
;Purpose  To save the locations configuration data.
;In Regs  AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars FileOpState = status of file handling.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
CFG_SaveLocs
   LD    DE,Filename_locs
   LD    HL,FileExe_locs
   JP    App_StartCfgApp

