;===============================================================================
;
; Browser application Data (Menus/Web-Page)
; Copyright (c) 2010 Ray Palmer
;
; Notes -
;
; 1. All row and column values for windowed data are for the CPC screen which
;    start from 1 and are for the absolute screen on the CPC and not for any
;    window defined on it.
;
;===============================================================================
MainMenu
;
;  Main Menu data displayed in a menu window at line 1
;
	DEFM	"Page Link Options Info"
	DEFB	0
;
;  Keys for any actions
;
MainMenuKeys
	DEFB	KEY_P
	DEFW	MNU_PageMenu		;Trigger to display Page menu
	DEFB	0
	DEFB	KEY_L
	DEFW	MNU_LinksMenu		;Trigger to display Link menu
	DEFB	0
	DEFB	KEY_O
	DEFW	MNU_OptionsMenu		;Trigger to display Options menu
	DEFB	0
	DEFB	KEY_I
	DEFW	MNU_InformationMenu	;Trigger to display Information menu
	DEFB	0
	DEFB	KEY_SPACE
	DEFW	CursorSelect		;Trigger to select hyperlink
	DEFB	0
	DEFB	KEY_S
	DEFW	URL_SaveHyperLink	;Trigger to save hyperlinked item
	DEFB	0
	DEFB	KEY_COMMA
	DEFW	URL_OpenPrevURL		;Trigger action to prev. Hist. URL
	DEFB	0
	DEFB	KEY_FSTOP
	DEFW	URL_OpenNextURL		;Trigger action to next Hist. URL
	DEFB	0
	DEFB	KEY_H
	DEFW	URL_OpenHomePage	;Trigger action to load home page.
	DEFB	0
	DEFB	KEY_U
	DEFW	MNU_EditCurrURL		;Trigger action to edit current URL.
	DEFB	0
	DEFB	KEY_CURSORS		;Cursor keys
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_Page
;
;  Menu data display in menu window
;
	DEFM	"Open Close Refresh Save View Find findNxt"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_O
	DEFW	MNU_PageOpen		;Handle Open new URL via line 2
	DEFB	0
	DEFB	KEY_C
	DEFW	MNU_BrowserExit		;Handle browser exit
	DEFB	0
	DEFB	KEY_R
	DEFW	MNU_PageRefresh		;Handle web-page refresh
	DEFB	0
	DEFB	KEY_S
	DEFW	MNU_PageSave		;Handle web-page source save
	DEFB	0
	DEFB	KEY_V
	DEFW	MNU_PageViewSource	;Handle wbe-page source view
	DEFB	0
	DEFB	KEY_F
	DEFW	MNU_PageFind		;Handle find text in web-page
	DEFB	0
	DEFB	KEY_N
	DEFW	MNU_PageFindNext	;Handle find next instance
	DEFB	0
	DEFB	KEY_ESC
	DEFW	MNU_ClrSubMenu
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_Link
;
;  Menu data display in menu window
;
	DEFM	"Open Save Load"
	DEFM	0
;
;  Keys for any actions
;
	DEFB	KEY_O
	DEFW	MNU_LinkOpen		;Handle open links manager window
	DEFB	0
	DEFB	KEY_S
	DEFW	CFG_LinkSave		;Handle save links data to media
	DEFB	0
	DEFB	KEY_L
	DEFW	MNU_LinkLoad		;Handle load links data from media
	DEFB	0
	DEFB	KEY_ESC
	DEFW	MNU_ClrSubMenu
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_Option
;
;  Menu data displayed in menu window
;
	DEFM	"Manage Access Update Reload"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_M
	DEFW	MNU_OptionManage	;Handle Options Manage window
	DEFB	0
	DEFB	KEY_A
	DEFW	MNU_OptionAccess	;Handle Options Access window
	DEFB	0
	DEFB	KEY_U
	DEFW	MNU_OptionUpdate	;Handle save options data to media
	DEFB	0
	DEFB	KEY_R
	DEFW	MNU_OptionReload	;Handle load options data from media
	DEFB	0
	DEFB	KEY_ESC
	DEFW	MNU_ClrSubMenu
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_Help
;
;  Menu data display in menu window
;
	DEFM	" Version History"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_V
	DEFW	MNU_HelpVersion		;Handle Help version window
	DEFB	0
	DEFB	KEY_H
	DEFW	MNU_HelpHistory		;Handle Help history window
	DEFB	0
	DEFB	KEY_ESC
	DEFW	MNU_ClrSubMenu
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_Link_Open
;
;  Menu data display in a new stream window
;
	DEFB	4			;Start colum, end column
SubMenu_Link_Opn1
	DEFB	60
	DEFB	6,16			;start row, end row
;
	DEFM	"Links Mgr (I,R,N,U,T,Sp,CU,CD)"
	DEFB	10
	DEFM	"Name:"
	DEFB	10
	DEFM	"URL :"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_I
	DEFW	MNU_LnkOpnInsert	;handle insert new link
	DEFB	0
	DEFB	KEY_R
	DEFW	MNU_LnkOpnRemove	;handle remove tagged link
	DEFB	0
	DEFB	KEY_N
	DEFW	MNU_LnkOpnEditName	;handle edit name of link
	DEFB	0
	DEFB	KEY_U
	DEFW	MNU_LnkOpnEditURL	;handle edit URL of link
	DEFB	0
	DEFB	KEY_T
	DEFW	MNU_LnkOpnTag		;handle action to tag a link
	DEFB	0
	DEFB	KEY_SPACE
	DEFW	MNU_LnkOpnOpen		;handle action to open a tagged link
	DEFB	0
	DEFB	KEY_CU
	DEFW	MNU_LnkOpnPrev		;handle action to move up list
	DEFB	0
	DEFB	KEY_CD
	DEFW	MNU_LnkOpnNext		;handle action to move down list
	DEFB	0
	DEFB	KEY_ESC
	DEFW	0
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_OptionManage
;
;  Menu data display in a window
;
	DEFB	4,25			;Start colum, end column
	DEFB	6,12			;start row, end row
;
	DEFM	"Browser"
	DEFB	10
	DEFM	"G - General"
	DEFB	10
	DEFM	"A - Applications"
	DEFB	10
	DEFM	"X - Advanced"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_G
	DEFW	MNU_OptManGeneral	;handle option open general settings
	DEFB	0
	DEFB	KEY_A
	DEFW	MNU_OptManApps		;handle option open apps settings
	DEFB	0
	DEFB	KEY_X
	DEFW	MNU_OptManAdv		;handle option open advance settings
	DEFB	0
	DEFB	KEY_ESC
	DEFW	0
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_OptManageGen
;
;  Menu data display in a window
;
	DEFB	4			;Start colum
SubMenu_OptMgeGen1
	DEFB	60			;end column
;
	DEFB	6,13			;start row, end row
;
	DEFM	"General"
	DEFB	10
	DEFM	"Home URL :"
	DEFB	10
	DEFM	"Start URL:"
	DEFB	10
	DEFM	"Download :"
	DEFB	10
	DEFM	"Cache :"
	DEFB	10
	DEFM	"Apps :"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_H
	DEFW	MNU_NewHomeURL		;handle edit home page url
	DEFB	0
	DEFB	KEY_S
	DEFW	MNU_NewStarupURL	;handle edit start up url
	DEFB	0
	DEFB	KEY_D
	DEFW	MNU_NewDownload		;handle edit download URL
	DEFB	0
	DEFB	KEY_C
	DEFW	MNU_NewCache		;handle edit download URL
	DEFB	0
	DEFB	KEY_ESC
	DEFW	0
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_OptManageApp
;
;  Menu data display in a window
;
	DEFB	4			;Start colum, end column
SubMenu_OptManageApp1
	DEFB	40
	DEFB	6,16			;start row, end row
;
	DEFM	"Applications"
	DEFB	10
	DEFM	"Name:"
	DEFB	10
	DEFM	"File:"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_I
	DEFW	MNU_OptManAppIns	;handle option to install app
	DEFB	0
	DEFB	KEY_R
	DEFW	MNU_OptManAppRem	;handle remove tagged app
	DEFB	0
	DEFB	KEY_D
	DEFW	MNU_OptManAppStop	;handle Disable app
	DEFB	0
	DEFB	KEY_E
	DEFW	MNU_OptManAppStart	;handle Enable app
	DEFB	0
	DEFB	KEY_K
	DEFW	MNU_OptManAppInput	;handle keyboard input
	DEFB	0
	DEFB	KEY_CU
	DEFW	MNU_OptManAppPrev	;handle action to previous app
	DEFB	0
	DEFB	KEY_CD
	DEFW	MNU_OptManAppNext	;handle option to next app
	DEFB	0
	DEFB	KEY_SPACE
	DEFW	App_StartApp		;handle option to execute the app
	DEFB	0
	DEFB	KEY_ESC
	DEFW	0
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_OptManageAdv
;
;  Menu data display in a window
;
	DEFB	4,30			;Start colum, end column
	DEFB	7,18			;start row, end row
;
	DEFM	"Advanced"
	DEFB	10
	DEFM	"Wrap Lock:"
	DEFB	10
	DEFM	"Page Lock:"
	DEFB	10
	DEFM	"Cursor Up:"
	DEFB	10
	DEFM	"Cursor Down:"
	DEFB	10
	DEFM	"Cursor Left:"
	DEFB	10
	DEFM	"Cursor Right:"
	DEFB	10
	DEFM	"Cur.Select:"
	DEFB	10
	DEFM	"Cur.Speed:"
	DEFB	10
	DEFM	"Cur.Icon:"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_W
	DEFW	MNU_OptManAdvWrap	;handle option wrap lock
	DEFB	0
	DEFB	KEY_P
	DEFW	MNU_OptManAdvPage	;handle option page lock
	DEFB	0
	DEFB	KEY_U
	DEFW	MNU_OptManAdvCU		;handle define cursor up key
	DEFB	0
	DEFB	KEY_D
	DEFW	MNU_OptManAdvCD		;handle define cursor down key
	DEFB	0
	DEFB	KEY_L
	DEFW	MNU_OptManAdvCR		;handle define cursor right key
	DEFB	0
	DEFB	KEY_R
	DEFW	MNU_OptManAdvCL		;handle define cursor left key
	DEFB	0
	DEFB	KEY_SPACE
	DEFW	MNU_OptManAdvCS		;handle define cursor select key
	DEFB	0
	DEFB	KEY_T
	DEFW	MNU_OptManAdvCT		;handle define cursor tracking
	DEFB	0
	DEFB	KEY_I
	DEFW	MNU_OptManAdvCI		;handle define cursor tracking
	DEFB	0
	DEFB	KEY_K
	DEFW	MNU_OptManAdvKeep	;handle save cursor settings
	DEFB	0
	DEFB	KEY_B
	DEFW	MNU_OptManAdvRset	;handle reset cursor settings
	DEFB	0
	DEFB	KEY_ESC
	DEFW	0
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SubMenu_OptionAccess
;
	DEFB	4,25			;Start colum, end column
	DEFB	7,15			;start row, end row
;
	DEFM	"Access Settings"
	DEFB	10
	DEFM	"Log URLs:"
	DEFB	10
	DEFM	"Log Files:"
	DEFB	10
	DEFM	"Reboot:"
	DEFB	10
	DEFM	"Apps:"
	DEFB	10
	DEFM	"Mode:"
	DEFB	0
;
;  Keys for any actions
;
	DEFB	KEY_U
	DEFW	MNU_OptAccessURL	;handle log URL history
	DEFB	0
	DEFB	KEY_F
	DEFW	MNU_OptAccessFile	;handle log file access
	DEFB	0
	DEFB	KEY_E
	DEFW	MNU_OptAccessExit	;handle exit type
	DEFB	0
	DEFB	KEY_A
	DEFW	MNU_OptAppsCtrl		;handle Apps Insert type
	DEFB	0
	DEFB	KEY_M
	DEFW	MNU_OptAppsMode		;handle Screen mode
	DEFB	0
	DEFB	KEY_ESC
	DEFW	0
	DEFB	0
	DEFB	KEY_ENDLIST
;===============================================================================
SelectFileData
;
	DEFB	4,35			;Start colum, end column
	DEFB	7,20			;start row, end row
;
	DEFM	"Select File "
	DEFB	10
	DEFM	" Current File :"
	DEFB	10, 10
	DEFB	0
;
	DEFB	KEY_RETURN		;Alternate select by RETURN
	DEFW	FIO_SelectThisFile
      	DEFB	0
;
	DEFB	KEY_D			;device select
	DEFW	0
	DEFB	0
;
	DEFB	KEY_F			;filter select
	DEFW	FIO_SelFilter
	DEFB	0
;
	DEFB	KEY_ESC
	DEFW	0
	DEFB	0
SelFile_CU
	DEFB	KEY_CU
	DEFW	FIO_SelectPrevFile
	DEFB	0
SelFile_CD
	DEFB	KEY_CD
	DEFW	FIO_SelectNextFile
	DEFB	0
SelFile_Select
	DEFB	KEY_SPACE
	DEFW	FIO_SelectThisFile
	DEFB	0
;
	DEFB	KEY_ENDLIST		;end of cursor keys
;