;===============================================================================
;
; Browser application Data
; Copyright (c) 2010 Ray Palmer
;
;===============================================================================
;	Browser Version.
;===============================================================================
CPCB_Vers	DEFB	01,00		;Version 1.0
		DEFB	14		;Day (01)
		DEFB	02		;Month (Feb)
		DEFW	2014		;Year (2014)
;===============================================================================
CPCB_versApp
		DEFB	"CPCBVers.wbe",0
CPCB_HistApp
		DEFB	"CPCBHist.wbe",0
;===============================================================================
;	filename of script to load setup system via internal parser method.
;===============================================================================
Sys_scriptname		defm	"sysstrt.seq",0
;===============================================================================
DefFontName		defb	"arial",0
;===============================================================================
;  HTML Error and Warning Messages
;===============================================================================
GenErrMsgText		DEFM	"** Error"
			DEFB	13,10,0
;
host_nosystemmsg	defm	"Err: No network"
			defb	13,10,0
;
OpenURLError		defb	"Err: URL failed (hit ESC)"
			defb	0
			DEFB	KEY_ESC
			DEFW	Err_HandleESC
			DEFB	0
			DEFB	KEY_ENDLIST
;
OpenAppError		defb	"Err: Not executable (hit ESC)"
			defb	0
			DEFB	KEY_ESC
			DEFW	Err_HandleESC
			DEFB	0
			DEFB	KEY_ENDLIST
;
GeneralAppError		defb	"Err: App failed (hit ESC)"
			defb	0
			DEFB	KEY_ESC
			DEFW	Err_HandleESC
			DEFB	0
			DEFB	KEY_ENDLIST
;
GeneralError_Msg	DEFM	"Err: not implemented (hit ESC)"
			DEFB	0
			DEFB	KEY_ESC
			DEFW	Err_HandleESC
			DEFB	0
			DEFB	KEY_ENDLIST
;
FindError_Msg		defb	"Err: Find failed (hit ESC)"
			defb	0
			DEFB	KEY_ESC
			DEFW	Err_HandleESC
			DEFB	0
			DEFB	KEY_ENDLIST
PressESC_Msg		defb	"ESC to conitnue"
			defb	0
			DEFB	KEY_ESC
			DEFW	Err_HandleESC
			DEFB	0
			DEFB	KEY_ENDLIST
;===============================================================================
;  Miscelleanous
;===============================================================================
PageOpenReqTxt	DEFM	"-Enter URL below-"
		DEFB	0
		DEFB	KEY_ENDLIST
;
FilenameReqTxt	DEFM	"-Enter filename below-"
		DEFB	0
		DEFB	KEY_ENDLIST
;
PageFindReqTxt	DEFM	"-Enter find text below-"
		DEFB	0
		DEFB	KEY_ENDLIST
;
URLNameReqTxt	DEFM	"-Enter URL name below-"
		DEFB	0
		DEFB	KEY_ENDLIST
;
GeneralRequest	DEFM	"-Enter additional below -"
		DEFB	0
		DEFB	KEY_ENDLIST
;===============================================================================
URL_httpTxt	DEFM	"http://"		;internet reference via HTTP
		DEFB	0
URL_fileTxt	DEFM	"file://"		;Local reference
		DEFB	0
;===============================================================================
str_yes		DEFM	"Yes"
		DEFB	0
str_no		DEFM	"No "
		DEFB	0
str_Reboot	DEFM	"Reboot"
		DEFB	0
str_Exit	DEFM	"Exit  "
		DEFB	0
;===============================================================================
;  File extension type lookup
;   Format is
;     xxx,a
;   Where xxx is the full extension
;         a is the file type
;           0 = HTML
;           1 = Text (General text)
;           2 = Text Script
;           4 = Executable
;           5 = Binary (if unable to determine from extension)
;           3 = Text (if unable to determine from extension)
;         128 = wildcard/any other type
;
FExtTypes	DEFB	"$$$",FILE_TEXT  ;Temp filename extension
		DEFB	"txt",FILE_TEXT  ;Text file
		DEFB	"seq",FILE_SCRPT ;Script file
;
		DEFB	"htm",FILE_HTML  ;HTML file
		DEFB	"jav",FILE_TEXT  ;Java script
		DEFB	"css",FILE_TEXT  ;CSS file
;
		DEFB	"wbe",FILE_EXE   ;Web-browser executable file
		DEFB	"wbl",FILE_BIN   ;Web-browser library file
		DEFB	"bin",FILE_BIN   ;Binary file
;
		DEFB	"csb",FILE_BIN   ;CPC screen binary image
		DEFB	"cst",FILE_TEXT  ;CPC screen text image
;
		DEFB	"icn",FILE_BIN   ;Icon file
		DEFB	"fnt",FILE_BIN   ;Font file
;
		DEFB	"***",FILE_UNK   ;Unknown (Must be last entry)
		DEFB	0
;
DefNetFilename	DEFB	"File-",0
;
FileFilter	DEFB	"*.htm",0
;===============================================================================
ROM_HTMLRSX	DEFM	"HTM","L"+&80
;===============================================================================
;
;   Variables for cursor management.
;
;===============================================================================
CursorKeys
CursorKey_ESC	DEFB	KEY_ESC
		DEFW	CursorESC
		DEFB	0
CursorKey_LSHFT	DEFB	KET_LSHFT
		DEFW	MoveCursorSHFT
		DEFB	0
CursorKey_RSHFT	DEFB	KEY_RSHFT
		DEFW	MoveCursorSHFT
		DEFB	0
CursorKey_TAB	DEFB	KEY_TAB
		DEFW	MoveCursorTAB
		DEFB	0
CursorKeys_Move
CursorKey_Up	DEFB	KEY_CU
		DEFW	MoveCursorUp
		DEFB	0
CursorKey_Down	DEFB	KEY_CD
		DEFW	MoveCursorDown
		DEFB	0
CursorKey_Left	DEFB	KEY_CL
		DEFW	MoveCursorLeft
		DEFB	0
CursorKey_Right	DEFB	KEY_CR
		DEFW	MoveCursorRight
		DEFB	0
CursorKey_Select  DEFB	KEY_SPACE
		DEFW	CursorSelect
		DEFB	0
		DEFB	KEY_ENDLIST			;end of cursor keys
ScrollCursorKeys
ScrollKey_Up	DEFB	KEY_CU
		DEFW	Scroll_UP
		DEFB	0
ScrollKey_Down	DEFB	KEY_CD
		DEFW	Scroll_Down
		DEFB	0
ScrollKey_Left	DEFB	KEY_CL
		DEFW	Scroll_Left
		DEFB	0
ScrollKey_Right	DEFB	KEY_CR
		DEFW	Scroll_Right
		DEFB	0
ScrollKey_Select	DEFB	KEY_SPACE
		DEFW	0				;do nothing
		DEFB	0
		DEFB	KEY_ENDLIST			;end of cursor keys
;===============================================================================
;
;   data for external apps access.
;   Also used for HTML ROM access
;
;===============================================================================
SysAcc_Vector
		DEFW	FIO_OpenDevPath		;(0)
		DEFW	URL_OpenAppURL		;(1)
		DEFW	KB_RemoveCursor		;(2)
		DEFW	PAR_CfgSys		;(3)
		DEFW	KB_Wait4akey		;(4)
		DEFW	FNT_NewEffect		;(5)
                DEFW	URL_OpenNewObj		;(6)
                DEFW	App_DoAppReq		;(7)
                DEFW	KB_GetWinInput		;(8)
                DEFW	WIN_PrintStr		;(9)
                DEFW	API_CommonEntry		;(10)
                DEFW	MNU_ShowPageTitle	;(11)
                DEFW	WIN_ScrollFrame		;(12)
                DEFW	WIN_NonScrollFrame	;(13)
                DEFW	FNT_SelectFontByName	;(14)
		DEFW	UTL_Trap		;(15)
		DEFW	FNT_SelectFontByIndx	;(16)
		DEFW	IMG_PicHandler		;(17)
		DEFW	WIN_ClearArea		;(18)
		DEFW	WIN_PrintChar		;(19)
		DEFW	WIN_ShowWindwData	;(20)
		DEFW	WIN_DisplayChar		;(21)
		DEFW	WIN_ShowBorder		;(22)
		DEFW	FNT_PrintIcon		;(23)
		DEFW	FNT_setupIcnData	;(24)
		DEFW	WIN_ChkFrmes		;(25)
		DEFW	KB_ResetCursorIcon	;(26)
		DEFW	UTL_GetDateByte		;(27)
		DEFW	MNU_ShowWindowItem	;(28)
		DEFW	App_AddNewItem		;(29)
		DEFW	App_FindApp		;(30)
		DEFW	URL_OpenURLLink		;(31)
		DEFW	FNT_ShowTimer		;(32)
		DEFW	Err_ShowErrorMsg	;(33)
		DEFW	URL_LoadNewObj		;(34)
;
SysAcc_VectorE
		DEFW	0			;end of local accesses
;

