;=========================================================================
;
; Application Routines (URL)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     Err_HandleESC
;Purpose  To handle the escape key when pressed for the error handler.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ???
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
Err_HandleESC
;=========================================================================
;Name     Err_ClrErrTxt
;Purpose  To clear the error/message space in the main menu area.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ???
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
Err_ClrErrTxt
   CALL  WIN_ShowMainBorder
   JP    MNU_PageRefresh
;=========================================================================
;Name     GeneralError
;Purpose  To display a general error (for dev use only)
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
GeneralError
   LD    HL,GeneralError_Msg
;=========================================================================
;Name     Err_ShowErrorMsg
;Purpose  To show the error message in the Main Menu area
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = address of error message text
;         IX = ???
;         IY = ??
;In Vars  ErrMsg_Cntrl = Error message display control
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars ErrMsg_Loc = location of message displayed
;         ErrMsg_WaitKey = ID of key to wait for.
;Uses     TBD
;Call By  TBD
;Calls    WIN_ShowText
;Notes    1. Error message text is shown in the default system font
;            defined by the characters 32 to 127.
;         2. Format of error handler text is -
;              "text for message",0
;              KeyID, KeyID, KeyID, 255
;            if no keyID's are required then first KeyID must be 255
;=========================================================================
Err_ShowErrorMsg
   LD    A,(ErrMsg_Cntrl)
   BIT   7,A				;Error message disabled?
   RET   NZ				;Yes
   EX    DE,HL 				;Save Location Error message text
   LD    HL,ERRMSG_POS
   LD    B,MaxErrText
   CALL  WIN_ShowText2
   EX    DE,HL
   INC   HL
   CALL  KB_Wait4akey
   JP    Err_ClrErrTxt			;Clear any existing text
