;=========================================================================
;
; Application Routines (Font handler)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     FNT_NewEffect
;Purpose  To apply and effect to the current font.
;In Regs  A = font effect (each bit in the value indicates which scan line
;                          is xor'ed).
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_NewEffect
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_NewEffect
FNT_DoExtRoutine
   JP    SYS_RunCode2		;execute routine in file2.bin
;=========================================================================
;Name     FNT_SelectFontByName
;Purpose  To download the fonts data into the common fonts store in the 
;         lower memory.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = address of font's name
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_SelectFontByName
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_SelectFontByName
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_SelectFontByName
;Purpose  To download the fonts data into the common fonts store in the 
;         lower memory.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = address of font's name
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_SelectFontByIndx
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_SelectFontByIndex
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_UploadFont
;Purpose  To upload the fonts data into the common fonts store.
;In Regs  A = Font set to save to.
;         BC = ??
;         DE = ??
;         HL = name of font
;         IX = ??
;         IY = ??
;In Vars  NumFonts = font number of the font to save to.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_UploadFont
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_UploadFont
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_UploadIcon
;Purpose  To upload the Icons data into the common icons store.
;In Regs  A = Icons set to save to.
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  NumFonts = font number of the font to save to.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_UploadIcon
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_UploadIcon
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_InitHandler
;Purpose  To initialise the Font's handler variables
;In Regs  A = Screen mode.
;         B = Border icon set
;         C = frames icon set
;         DE = ??
;         HL = Address of OS character definitions
;         IX = ??
;         IY = ??
;In Vars  None
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_InitHandler
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_InitHandler
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_PrintIcon
;Purpose  To display the icon character on the screen.
;In Regs  A = Icon Number
;         B = ??
;         C = Icon set number.
;         DE = Stream Start position (AMSTRAD coordinates)
;         HL = Cursor position in the stream.
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. FIX ME FOR COLOURS OF ICON (20140206).
;=========================================================================
FNT_PrintIcon
   PUSH  AF
   LD    A,(Icon_ColIdx)
   LD    B,A
   POP   AF
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_ShowIconChar
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_WR_CHAR
;Purpose  To display a character in the current selected font.
;In Regs  A = Current character to show.
;         BC = Offset to display character
;              if B/C = 0 then position is absolute
;              B = column offset
;              C = row offset
;         D = Colours - foregound (L)/background (U)
;         E = Font to use (255=Force normal, 0=current selection)
;         H = stream column
;         L = stream column
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         D = 1 mean char displayed else 0
;         E = ??
;         H = updated stream column
;         L = updated stream row
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. This routine may be used to replace the normal AMSDOS system
;            routines TXT_WR_CHAR (&bb5d) and TXT_PRINT_CHAR (&bb5a).
;         2. FIX ME FOR COLOURS OF CHARACTER (20140206).
;=========================================================================
FNT_WR_CHAR
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_ShowFontChar
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_setupIcnData
;Purpose  To setup an icon with data.
;In Regs  A = Icon Number
;         B = ??
;         C = Icon set number.
;         DE = Stream Start position (AMSTRAD coordinates)
;         HL = Cursor position in the stream.
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_setupIcnData
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,Ext_setupIcnData
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_SetFrameIcnSet
;Purpose  To setup the frame configuration.
;In Regs  A = Icon set for frames
;         B = Colours for frames
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_SetFrameIcnSet
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,EXT_SetFrameIcnSet
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_SetBrdrIcnSet
;Purpose  To setup the borders configuration.
;In Regs  A = Icon set for frames
;         B = Colours for frames
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FNT_SetBrdrIcnSet
   CALL  SYS_SaveRegs		;Save registers (AF/BC/DE/HL)
   LD    HL,EXT_SetFrameIcnSet
   JR    FNT_DoExtRoutine
;=========================================================================
;Name     FNT_ShowTimer
;Purpose  To display one of the many timer icons in a small animated way
;         similar to more complex systems.
;In Regs  A = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. Can make changes to customise the timer icon shown.
;         2. FIX ME FOR COLOURS OF ICON (20140206).
;=========================================================================
FNT_ShowTimer
   PUSH  AF
   PUSH  HL
   LD    HL,CPCB_Timer
   BIT   7,(HL)			;Timer display enabled?
   JR    NZ,FNT_ShowTimer3	;No
   PUSH  BC
   PUSH  DE
   LD    A,(Icon_ColIdx)
   LD    E,A
   LD    A,28			;Null icon to remove timer
   LD    B,(HL)
   BIT   6,B			;Display Block icon?
   JR    NZ,FNT_ShowTimer1	;Yes
   LD    A,B
   CP    9			;At end of animation?
   JR    NZ,FNT_ShowTimer0	;No
   LD    (HL),255		;reset to start of icons.
   LD    E,0
   XOR   A
FNT_ShowTimer0
   ADD   A,21			;Offset to anim icons set.
   INC   (HL)			;next icon on re-rentry
FNT_ShowTimer1
   LD    C,1			;use the main system icons set
   LD    B,E
   LD    HL,TIMER_POS
   LD    DE,0			;no adjustments to screen location
   CALL  SYS_SaveRegs
   LD    HL,Ext_ShowIconChar	;Display Icon
   CALL  SYS_RunCode2		;call banked memory icon handler
   LD    HL,CPCB_Timer
   BIT   6,(HL)			;Display Block icon?
   JR    Z,FNT_ShowTimer2	;No
   SET   7,(HL)			;Disable timer display
FNT_ShowTimer2
   POP   DE
   POP   BC
FNT_ShowTimer3
   POP   HL
   POP   AF
   RET
;