;=========================================================================
;
; Application Routines (Menu)
; Copyright (c) 2010 Ray Palmer
;
;=========================================================================
;Name     MNU_MainMenuFrame
;Purpose  To the entire main menu frame.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. Assume the window frame for AMSDOS is defined and hence
;            defined for the OS to clear as required.
;=========================================================================
MNU_MainMenuFrame
   LD    A,(Stream_MainMenu)
   CALL  WIN_ClearStream
   CALL  MNU_ShowMainMenu		;Display Main menu
   CALL  MNU_ShowURL			;Show the URL line
   JP    WIN_ShowMainBorder		;Display main menu border
;=========================================================================
;Name     MNU_ShowPosXY
;Purpose  To show the cursor position for the cursor X/Y
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. Only for development use only.
;=========================================================================
MNU_ShowPosXY
   LD    DE,(Cursor_IRow)
   LD    A,E
   LD    HL,TMP_string
   CALL  UTL_writedec		;convert number to decimal string
   LD    DE,(Cursor_ICol)
   JR    MNU_ShwOffsetXY2
;=========================================================================
;Name     MNU_ShowOffsetXY
;Purpose  To show the cursor position for the cursor X/Y
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    WIN_ShowText
;Notes    1. Only for development use only.
;=========================================================================
MNU_ShowOffsetXY
   LD    DE,(Cursor_OffRow)
   LD    A,E
   LD    HL,TMP_string
   CALL  UTL_writedec		;convert number to decimal string
   LD    DE,(Cursor_OffCol)
;
MNU_ShwOffsetXY2
   LD    (HL),SLASH_CHAR
   INC   HL
   LD    A,E
   CALL  UTL_writedec		;convert number to decimal string
   LD    (HL),SPACE_CHAR
   INC   HL
   LD    (HL),NULL_CHAR
   LD    DE,TMP_string		;Address of string to show
   LD    HL,CursorPOS		;location to show text
   JP    WIN_ShowText2
;=========================================================================
;Name     MNU_ShowMainMenu
;Purpose  To display the main menu at line 1.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    WIN_ShowText
;Notes    TBD
;=========================================================================
MNU_ShowMainMenu
   LD    HL,MAINMENU_POS
   LD    DE,MainMenu
   JP    WIN_ShowText2			;display main menu on line 1
;=========================================================================
;Name     MNU_ShowSubMenu
;Purpose  To display the main menu items upon selection on line 3.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = address of sub menu text
;         IX = ??
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars MenuEscape = updated
;Uses     TBD
;Call By  TBD
;Calls    WIN_ShowText
;Notes    TBD
;=========================================================================
MNU_ShowMainMenuOptions
   EX    DE,HL
   LD    HL,SUBMENU_POS
   CALL  WIN_ShowText2		;Display 1st level sub-menu options
   EX    DE,HL
   INC   HL			;point to keys to handle
   CALL  KB_Wait4akey		;wait and process key presses.
;=========================================================================
;Name     MNU_ClrSubMenu
;Purpose  To clear the sub-menu line.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ClrSubMenu
   LD    HL,SUBMENU_POS
;=========================================================================
;Name     MNU_ClrTheLine
;Purpose  To clear a line of content
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = start location of the line
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ClrTheLine
   LD    C,SPACE_CHAR
MNU_ClrTheLine1
   PUSH  BC
   LD    D,&10				;Inks for main menu area
   LD    E,255				;Use normal font (by force)
   LD    A,C
   LD    BC,0				;no offset to screen location.
   CALL  FNT_WR_CHAR			;Show it on screen in the stream
   POP   BC
   LD    A,(Scrn_MaxCol)
   DEC   A
   CP    H				;At end of line?
   JR    NZ,MNU_ClrTheLine1		;No
   RET
;=========================================================================
;Name     MNU_ShowIcon
;Purpose  To display an icon in the main menu area from the system icon
;         set.
;In Regs  A = icon number
;         B = ??
;         C = ??
;         DE = ??
;         HL = column/row for the icon
;         IX = ??
;         IY = ??
;In Vars  None
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         H = input column + 2
;         L = input row
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FNT_PrintIcon
;Notes    TBD
;=========================================================================
MNU_ShowIcon
   PUSH  HL
   LD    DE,0			;no adjustments to screen location
   LD    C,0			;use the main system icons set
   LD    B,&21			;Setup colours
   CALL  FNT_PrintIcon
   POP   HL
   INC   H
   INC   H
   RET
;=========================================================================
;Name     MNU_ClearURLLine
;Purpose  To clear the URL line.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  None
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    WIN_ShowText
;Notes    TBD
;=========================================================================
MNU_ClearURLLine
   LD    HL,URLHDR_POS
   PUSH  HL
   CALL  MNU_ClrTheLine
   POP   HL
   LD    A,ICON_PPAGE
   CALL  MNU_ShowIcon			;display previous page icon
   LD    A,ICON_HPAGE
   CALL  MNU_ShowIcon			;display home page icon
   LD    A,ICON_NPAGE
   CALL  MNU_ShowIcon			;display next page icon
   LD    (URL_Position),HL
   RET
;=========================================================================
;Name     MNU_ShowURL
;Purpose  To display the URL line on line 2
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  URL_ObjStrtTxt = URL text
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    WIN_ShowText
;Notes    TBD
;=========================================================================
MNU_ShowURL
   CALL  MNU_ClearURLLine		;display "< H > " text
   LD    DE,URL_ObjStrtTxt
   JR    MNU_Shwpgetitle1		;show URL data
;=========================================================================
;Name     MNU_ShowPageTitle
;Purpose  To display the web page title on line 4
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  KB_Buffer = Page title from HTML data.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    WIN_ShowText
;Notes    TBD
;=========================================================================
MNU_ShowPageTitle
   LD    HL,WPTITLE_POS
   LD    DE,KB_Buffer
MNU_Shwpgetitle1
   JP    WIN_ShowText2		;Display title
;=========================================================================
;Name     MNU_ClearTitle
;Purpose  To clear the web page title on line 4
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ClearTitle
   LD    HL,WPTITLE_POS
   LD    A,(Scrn_MaxCol)
   LD    B,A
   DEC   B
MNU_ClearTitle1
   PUSH  BC
   LD    E,255				;Use normal font (by force)
   LD    A,(Menu_ColIdx)
   LD    D,A				;Inks for main menu area
   LD    A,SPACE_CHAR
   CALL  FNT_WR_CHAR			;Show it on screen in the stream
   POP   BC
   INC   H
   DJNZ  MNU_ClearTitle1
   RET
;=========================================================================
;Name     MNU_ReqInputTxt
;Purpose  To request for user input text using the URL line.
;In Regs  A = ??
;         B = 0 means dont refresh URL with previous text
;             1 mean refresh URL with previous text
;         C = 0 mean no existing input
;             1 mean update existing input
;         DE = ??
;         HL = Address of prompt text displayed on line 1
;         IX = ??
;         IY = ??
;In Vars  Stream_MainMenu = window stream ID
;         KB_Buffer = has existing text to modify
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer = user input.
;         KB_Offset = updated
;Uses     TBD
;Call By  MNU_EditCurrURL
;         MNU_NewDownload
;         MNU_NewCache
;         MNU_NewStarupURL
;Calls    MNU_ClearURLLine
;         KB_GetWinInput
;         Err_ClrErrTxt
;         MNU_ShowURL
;Notes    TBD
;=========================================================================
MNU_ReqInputTxt
   PUSH  BC
   LD    A,H
   OR    L				;Message prompt?
   CALL  NZ,Err_ShowErrorMsg		;Display prompt
   CALL  MNU_ClearURLLine		;clear URL line for echo back
   POP   BC
   LD    HL,KB_Buffer
   CALL  UTL_strlen
   LD    E,A
   LD    D,0
   LD    (KB_Offset),DE
;
   LD    D,ER_MainMenu-1
   LD    A,(Scrn_MaxCol)
   DEC   A
   LD    E,A
   LD    (KB_MaxInpRC),DE		;setup input max Row/col
   LD    D,0
   DEC   A
   LD    E,A
   LD    (KB_printlen),DE		;save max print length
;
   LD    HL,(URL_Position)
   LD    DE,KB_Buffer
;
   PUSH  BC
   CALL  KB_GetWinInput			;Get input via keyboard
   CALL  Err_ClrErrTxt
   POP   BC
   LD    A,B
   OR    A				;Resfresh URL?
   RET   Z				;No
   JP    MNU_ShowURL			;re-display original URL
;=========================================================================
;Name     MNU_HandleKeys
;Purpose  To handle the keys for sub-window menus displayed after another
;         window was displayed on the web-page.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    KB_Test4aKey
;         KB_WaitRelease
;         KB_DoHandler
;         WIN_ClearWindow
;Notes    TBD
;=========================================================================
MNU_HandleKeys
   LD    HL,(MenuWinKeyLoc)		;Get location of keys data
   CALL  KB_Test4akey			;Wait for a menu specific key
   CP    KEY_ENDLIST			;No key pressed ?
   JR    Z,MNU_HandleKeys		;Yes (try again)
   CALL  KB_WaitRelease
   CALL  WIN_ClearWindow
   LD    A,(KB_KeyTested)
   CP    KEY_ESC
   RET   Z
   JP    KB_DoHandler			;execute key handler
;=========================================================================
;Name     MNU_ShowAccessDetails
;Purpose  To display the details of the Access option's settings.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  LogURLs = current log URLs flag status
;         LogFiles = current log files flag status
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ShowAccessDetails
   LD    DE,ACCESS_POS
   CALL  MNU_AdjustLocn
;
   LD    A,(LogURLs)
   CALL  MNU_ShowYesNo
;
   LD    A,(LogFiles)
   CALL  MNU_ShowYesNo
;
   LD    A,(SysExit)
   LD    HL,str_Reboot
   OR    A
   JR    NZ,MNU_ShowAccessDetails3
   LD    HL,str_Exit
MNU_ShowAccessDetails3
   CALL  MNU_ShowTheValue
;
   LD    A,(App_CtrlFlg)
   AND   128
   CALL  MNU_ShowYesNo
;
   LD    A,(Scrn_Mode)
   CALL  MNU_ShowKeyValue
   RET
;=========================================================================
;Name     MNU_ShowYesNo
;Purpose  To display either Yes or No text
;In Regs  A = 0=No else Yes
;         BC = ??
;         DE = Screen location
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  None
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars None
;Uses     TBD
;Call By  TBD
;Calls    MNU_ShowTheValue
;Notes    TBD
;=========================================================================
MNU_ShowYesNo
   LD    HL,str_yes
   OR    A
   JR    NZ,MNU_ShowAccessDetails4
   LD    HL,str_No
MNU_ShowAccessDetails4
   JP    MNU_ShowTheValue
;=========================================================================
;Name     MNU_ShowSysDetails
;Purpose  To display the details of the Advanced option's settings.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  WrapLock = current wrap lock flag status
;         PageLock = current page lock flag status
;         CursorKey_Up = current cursor Up key
;         CursorKey_Down = current cursor Down key
;         CursorKey_Left = current cursor Left key
;         CursorKey_Right = current cursor Right key
;         CursorKey_Select = current cursor Select key
;         Cursor_Speed = current speed of the cursor.
;         Cursor_Icon = Icon of the cursor.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ShowSysDetails
   LD    DE,SYSDET_POS
   CALL  MNU_AdjustLocn
   LD    A,(WrapLock)
   CALL  MNU_ShowYNValue
   LD    A,(PageLock)
   CALL  MNU_ShowYNValue
   LD    A,(CursorKey_Up)
   CALL  MNU_ShowKeyValue
   LD    A,(CursorKey_Down)
   CALL  MNU_ShowKeyValue
   LD    A,(CursorKey_Left)
   CALL  MNU_ShowKeyValue
   LD    A,(CursorKey_Right)
   CALL  MNU_ShowKeyValue
   LD    A,(CursorKey_Select)
   CALL  MNU_ShowKeyValue
   PUSH  DE
   LD    HL,(Cursor_Speed)
   LD    DE,10
   CALL  Mth_Divide			;Divide speed by 10
   LD    A,C
   POP   DE
   CALL  MNU_ShowKeyValue
   LD    A,(Cursor_Icon)
   CALL  MNU_ShowKeyValue
   RET
;=========================================================================
;Name     MNU_ShowYNValue
;Purpose  To display the Yes/No text in a window.
;In Regs  A = Boolean value to show
;         BC = ??
;         DE = Rol/Column to show text (E=Row/D=Column)
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ShowYNValue
   LD    HL,str_yes
   OR    A
   JR    NZ,MNU_ShowTheValue
   LD    HL,str_No
   JR    MNU_ShowTheValue
;=========================================================================
;Name     MNU_ShowKeyValue
;Purpose  To display the value of cursor key number.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ShowKeyValue
   PUSH  DE
   LD    HL,KB_Buffer
   CALL  UTL_writedec
   LD    (HL),0
   POP   DE
   LD    HL,KB_Buffer
;=========================================================================
;Name     MNU_ShowTheValue
;Purpose  To display the text in a window.
;In Regs  A = ??
;         BC = ??
;         DE = Rol/Column to show text (E=Row/D=Column)
;         HL = address of text to show
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ShowTheValue
   PUSH  DE
   CALL  WIN_ShowWindwData
   POP   DE
   INC   E
   RET
;=========================================================================
;Name     MNU_Request3chrs
;Purpose  To request from the user a 3 digit number.
;In Regs  A = ??
;         B = ??
;         C = ??
;         DE = Position to input data
;         HL = Position offset (=0 if none)
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = converted input.
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer = corrupted with user input.
;         KB_KeyTested = corrupted
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. There are no checks to ensure that the user input does not
;            exceed the required 3 digits for a number, so the number 1234
;            can be entered and when converted the result is a number
;            which is not what was entered.
;=========================================================================
MNU_Request3chrs
   PUSH  HL
   CALL  MNU_AdjustLocn
   POP   HL
   ADD   HL,DE
   XOR   A
   LD    (KB_KeyTested),A
   LD    C,4
;=========================================================================
;Name     MNU_RequestKey
;Purpose  To request from the user a digit number.
;In Regs  A = ??
;         B = ??
;         C = length of the text to enter
;         DE = ??
;         H = Row of item to update
;         L = Column of item to update
;         IX = ??
;         IY = ??
;In Vars  Stream_Submenu = web-page window stream number
;Out Regs AF = converted input.
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer = corrupted with user input.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. There are no checks to ensure that the user input does not
;            exceed the required n digits for a number.
;=========================================================================
MNU_RequestKey
   LD    DE,KB_Buffer
   LD    B,MAX_IN_DIGITS
   XOR   A
MNU_ReqstKey1
   LD    (DE),A
   INC   DE
   DJNZ  MNU_ReqstKey1
;
   LD    (KB_printlen),BC		;Setup max print length
   PUSH  HL
   ADD   HL,BC
   LD    (KB_MaxInpRC),HL		;setup row/column for multiline
   POP   HL
   LD    DE,KB_Buffer
   LD    A,(Stream_Submenu)
   LD    B,A
   LD    C,0
   CALL  KB_GetWinInput
   LD    HL,KB_Buffer
   JP    UTL_readdec
;=========================================================================
;Name     MNU_EditCurrURL
;Purpose  To edit the current URL
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    URL_OpenNewURL
;         MNU_ReqInputTxt
;Notes    TBD
;=========================================================================
MNU_EditCurrURL
   LD    HL,URL_ObjStrtTxt
   LD    DE,KB_Buffer
   LD    BC,URL_Size
   LDIR
   LD    HL,0
   LD    BC,REQUEST_TYP2
   CALL  MNU_ReqInputTxt		;Update the current URL
   LD    HL,KB_Buffer
   LD    A,(HL)
   OR    A				;Is URL non-empty?
   JP    NZ,URL_OpenNewURL		;Yes (open it)
   RET
;=========================================================================
;Name     MNU_ShowCfgData
;Purpose  To display the current memory configuration data.
;In Regs  A = ??
;         B = number of blocks
;         DE = Addres of bytes to convert
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_ShowCfgData
   LD    HL,KB_Buffer
   LD    A,(DE)
   INC   DE
   CALL  UTL_writehex8			;Convert number to hexadecimal
   LD    (HL),SPACE_CHAR		;add space after hex chars
   INC   HL
   LD    (HL),SPACE_CHAR
   INC   HL
   PUSH  HL
   LD    HL,0
   LD    DE,16
MNU_ShowCfgData1
   ADD   HL,DE
   DJNZ  MNU_ShowCfgData1
   POP   BC
   LD    DE,1000
   CALL  MNU_ShowCfgDat2
   LD    DE,100
   CALL  MNU_ShowCfgDat2
   LD    DE,10
   CALL  MNU_ShowCfgDat2
   LD    A,L
   ADD   A,'0'
   LD    (BC),A
   INC   BC
   LD    A,'K'
   LD    (BC),A
   INC   BC
   XOR   A
   LD    (BC),A
   RET
;=========================================================================
MNU_ShowCfgDat2
   PUSH  BC
   CALL  Mth_Divide
   LD    A,C
   POP   BC
   ADD   A,'0'
   LD    (BC),A
   INC   BC
   RET
;=========================================================================
;
;   START OF MENU HANDLERS
;
;   MENU 'PAGE'
;
;=========================================================================
;Name     MNU_PageMenu
;Purpose  To display the "Page" options.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_PageMenu
   LD    HL,SubMenu_Page
   JP    MNU_ShowMainMenuOptions
;=========================================================================
;Name     MNU_PageOpen
;Purpose  To handle open url request from the menus.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer = contains the URL entered by the user.
;Uses     TBD
;Call By  TBD
;Calls    URL_OpenNewURL
;Notes    1. If there is no input then the select file action is
;            performed.
;         2. Where the input ends in a '/' the select file action is
;            performed.
;         3. The use of a device to select from with no other input
;            will cause the select file action to be performed. For
;            example file //\0,Partition,Password,key/
;=========================================================================
MNU_PageOpen
   LD    A,FILE_TEXT
   LD    (FIO_Ctrl),A
;
   LD    HL,FileFilter
   LD    DE,KB_SrchTxt
   CALL  UTL_strcpy		;setup default selection filter
;
   CALL  FIO_SelectFile		;Display catalog and select
;
   LD    A,(KB_KeyTested)
   CP    KEY_ESC		;Escaped pressed?
   JP    Z,MNU_ShowURL		;request cancelled
;
   LD    HL,KB_Buffer
   LD    A,(HL)
   CP    NUL			;item selected?
   JR    NZ,MNU_PageOpn1	;Yes
   CALL  MNU_PageRefresh
   JP    MNU_ShowURL
;
MNU_PageOpn1
   CALL  WIN_ClearWebPage
   CALL  KB_ResetCursor		;Setup cursor vars in browser vars
   LD    HL,KB_Buffer
   JP    URL_OpenNewURL		;No (open a new URL)
;=========================================================================
;Name     MNU_BrowserExit
;Purpose  To handle close browser application.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_BrowserExit
   XOR   A
   LD    (BrowserState),A		;Flag browser to exit.
   RET
;=========================================================================
;Name     MNU_PageRefresh
;Purpose  To handle refresh web-page option.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  HTML_RenderState = current state of HTML display
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars HTML_RenderState = updated state of HTML display
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. The web-page area is cleared then the displayed HTML data is
;            restarted from the beginning. So if the refresh occurs when
;            scolled at the end the refresh is the same as scroll back to
;            top very quickly.
;=========================================================================
MNU_PageRefresh
   CALL  UTL_FlagRefresh
   XOR   A
;
;  clear all scroll offsets in each frame.
;
MNU_PgeRefresh1
   INC   A
   LD    (WindowFrameID),A
   PUSH  AF
   CALL  WIN_CalcFrmeDB
   POP   AF
   BIT   0,(HL)			;end of DB?
   RET   Z			;Yes
   LD    BC,S_HTMLFramRo
   ADD   HL,BC
   LD    (HL),0			;reset offsets
   INC   HL
   LD    (HL),0
   INC   HL
   LD    (HL),0
   INC   HL
   LD    (HL),0
   JR    MNU_PgeRefresh1
;=========================================================================
;Name     MNU_PageSave
;Purpose  To handle save web-page option.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FIO_SaveFile
;         MNU_ReqItem
;Notes    1. The save page will only save a single HTML frame and not all
;            frames that make up a HTML complete page.
;=========================================================================
MNU_PageSave
   LD    HL,FilenameReqTxt
   LD    BC,REQUEST_TYP3
   CALL  MNU_ReqInputTxt
   LD    HL,KB_Buffer
   LD    A,(HL)
   CP    NUL				;Is entered line empty?
   RET   Z				;Yes (do nothing)
   LD    HL,KB_Buffer
   JP    FIO_SaveHTML			;Save to file.
;=========================================================================
;Name     MNU_PageViewSource
;Purpose  To handle view web-page source option.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. NEED TO FIX TO USE NEW ROUTINE!
;=========================================================================
MNU_PageViewSource
   XOR   A
   CALL  Mem_SwapInHTML
   LD    HL,(BaseHTMLLoc)
   LD    A,(HL)
   OR    A				;Any HTML loaded?
   JP    Z,Mem_SwapInMain		;No
   CP    SHTML_CHR			;Start of HTML?
   JP    NZ,Mem_SwapInMain		;No (normal text file)
   JP    HTML_ViewSrce			;View source
;=========================================================================
;Name     MNU_PageFind
;Purpose  To handle find text in web-page option.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars HTML_FCurrPos = current start position
;         KB_SrchTxt = search text
;Uses     TBD
;Call By  TBD
;Calls    MNU_ReqItem
;         UTL_strncpy
;         Mem_SwapInHTML
;         Mem_SwapInMain
;         HTML_FindText (External - HTML ROM routine)
;         Err_ShowErrorMsg
;         Err_ClrErrTxt
;         MNU_ClearURLLine
;         MNU_ShowURL
;Notes    TBD
;=========================================================================
MNU_PageFind
   LD    HL,PageFindReqTxt
   LD    BC,REQUEST_TYP3
   CALL  MNU_ReqInputTxt		;enter find text
   LD    HL,KB_Buffer
   LD    DE,KB_SrchTxt
   LD    B,KB_SrchSz
   CALL  UTL_strncpy			;Setup copy of search text
   LD    A,1
   JR    MNU_PageFindNext1
;=========================================================================
;Name     MNU_PageFindNext
;Purpose  To handle find text again in web-page option.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  KB_SrchTxt = search text
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars HTML_FCurrPos = address of found text or unchanged if not
;Uses     TBD
;Call By  TBD
;Calls    Mem_SwapInHTML
;         Mem_SwapInMain
;         HTML_FindText (External - HTML ROM routine)
;         Err_ShowErrorMsg
;         Err_ClrErrTxt
;         MNU_ClearURLLine
;         MNU_ShowURL
;Notes    TBD
;=========================================================================
MNU_PageFindNext
   LD    A,2
MNU_PageFindNext1
   LD    (URL_LblType),A		;Flag search normal text
   LD    HL,KB_SrchTxt
   LD    A,(HL)
   CP    NUL				;Is entered line empty?
   JR    Z,MNU_PageFindEx		;Yes (do nothing)
;
   LD    A,(Window_Addr+2)
   CALL  Mem_SwapInHTML			;Swap in RAM bank of HTML
   LD    A,(SysBnkBuffer)
   OR    A				;HTML data loadded?
   JR    Z,MNU_PageFindError		;No
   LD    A,(URL_LblType)
   LD    B,A				;B = search type
   LD    DE,KB_SrchTxt			;Location of text to find
   LD    HL,FindResult
   LD    (HL),A				;Clear Find Result
   CALL  HTML_FindText			;Call external find routine
   LD    A,(FindResult)
   OR    A					;Did we find the text?
   JR    NZ,MNU_PageFindEx		;Yes
   LD    HL,FindError_Msg
MNU_PageFindError
   CALL  Err_ShowErrorMsg		;Show find error (wait for esc)
   CALL  Err_ClrErrTxt			;remove error message text
MNU_PageFindEx
   CALL  MNU_ClearURLLine
   CALL  MNU_ShowURL			;Re-display URL
   LD    A,(FindResult)
   OR    A				;Did we find it?
   CALL  NZ,MNU_PageRefresh		;Yes (setup refresh to show it)
   JP    Mem_SwapInMain
;=========================================================================
;
;   MENU 'LINKS'
;
;=========================================================================
;Name     MNU_LinksMenu
;Purpose  To display the "Links" options.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_LinksMenu
   LD    HL,SubMenu_Link
   JP    MNU_ShowMainMenuOptions
;=========================================================================
;
;   MENU 'OPTIONS'
;
;=========================================================================
;Name     MNU_OptionsMenu
;Purpose  To display the "Options" options on the Line 3 in the menu
;         window.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptionsMenu
   LD    HL,SubMenu_Option
   JP    MNU_ShowMainMenuOptions
;=========================================================================
;Name     MNU_OptionUpdate
;Purpose  To update the scripts for a new configuration setting.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CFG_SaveLocs
;         CFG_SaveCursor
;         CFG_SaveURLs
;         CFG_SaveApps
;Notes    TBD
;=========================================================================
MNU_OptionUpdate
   CALL  CFG_SaveLocs			;Save Location's configuration
   CALL  CFG_SaveCursor			;Save cursor configuration
   CALL  CFG_SaveURLs			;Save updated session links
   JP    CFG_SaveApps			;Save Applications/Handlers
;=========================================================================
;Name     MNU_OptionReload
;Purpose  To reload the system configuration from the scripts and restart
;         the browser.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptionReload
   LD    HL,Filename_Locs
   CALL  PAR_CfgSys			;execute the Locs config script.
;
   LD    HL,Filename_Cursor
   CALL  PAR_CfgSys			;execute the cursor config script.
;
   LD    A,(AppsBank)
   CALL  Mem_ClearBank			;clears existing applications
   XOR   A
   LD    (LastAppIndex),A
   LD    HL,Filename_Apps
   CALL  PAR_CfgSys			;execute the Apps config script.
;
   LD    HL,Filename_URLs
   CALL  PAR_CfgSys			;Execute the Home/StartUp script.
;
   JP    KB_SetupCursor			;Install the cursor config
;=========================================================================
;Name     MNU_OptionManage
;Purpose  To display the main window to manage the system configuration.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptionManage
   LD    A,(Stream_WebPage)
   CALL  WIN_ClearStream
   LD    HL,SubMenu_OptionManage
   CALL  MNU_ShowWindowItems		;Display new window and data
   CALL  MNU_HandleKeys
   LD    A,(KB_KeyTested)
   CP    KEY_ESC			;cancel menu options key?
   JP    NZ,MNU_OptionManage		;No
   RET
;=========================================================================
;Name     MNU_OptManGeneral
;Purpose  To display the window to manage the general configuration.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManGeneral
   LD    HL,SubMenu_OptManageGen
   CALL  MNU_ShowWindowItems		;Setup/show General Settings
;
   CALL  MEM_SwapInCfg
   LD    DE,PAGES_POS			;Column 12, Row 2
   CALL  MNU_AdjustLocn
   LD    HL,CFG_HomePage
   CALL  MNU_ShowTheValue		;Display home URL
   LD    HL,CFG_StartUp
   CALL  MNU_ShowTheValue		;Display startup URL
   LD    HL,CFG_SaveLocn
   CALL  MNU_ShowTheValue		;Display download location
   LD    HL,CFG_CacheLocn
   CALL  MNU_ShowTheValue		;Display cache location
   LD    HL,CFG_AppLocn
   CALL  MNU_ShowTheValue		;Display App location
   CALL  Mem_SwapInMain
;
   LD    HL,(MenuWinKeyLoc)
   CALL  KB_Wait4akey			;execute any key pressed
   LD    A,(KB_KeyTested)
   CP    KEY_ESC			;cancel menu options key?
   JP    NZ,MNU_OptManGeneral		;No
   CALL  WIN_ClearWindow
   XOR   A
   LD    (KB_KeyTested),A
   JP    Mem_SwapInMain
;=========================================================================
;Name     MNU_NewHomeURL
;Purpose  To update the HOME page URL.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_NewHomeURL
   LD    DE,CFG_HomePage
   JR    MNU_GetNewURL
;=========================================================================
;Name     MNU_NewStarupURL
;Purpose  To update the default start up page URL.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. The startup page URL is used when no URL is passed to the
;            browser on startup.
;=========================================================================
MNU_NewStarupURL
   LD    DE,CFG_StartUp
   JR    MNU_GetNewURL
;=========================================================================
;Name     MNU_NewCache
;Purpose  To update the cache location.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_NewCache
   LD    DE,CFG_CacheLocn
   JR    MNU_GetNewURL
;=========================================================================
;Name     MNU_NewDownload
;Purpose  To update the download location.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_NewDownload
   LD    DE,CFG_SaveLocn
MNU_GetNewURL
   PUSH  DE
   CALL  MEM_SwapInCFG
   EX    DE,HL
   LD    DE,KB_Buffer
   LD    BC,URL_Size
   LDIR				;Download URL to alter
;
   LD    HL,0
   LD    BC,REQUEST_TYP4
   CALL  MNU_ReqInputTxt	;display and alter URL
   POP   DE
   LD    HL,KB_Buffer
   LD    BC,URL_Size
   LDIR				;upload new URL
;
   XOR   A
   LD    (KB_KeyTested),A	;clear last input
   JP    Mem_SwapInMain
;=========================================================================
;Name     MNU_OptManApps
;Purpose  To display the applications manager.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManApps
   LD    HL,SubMenu_OptManageApp
   CALL  MNU_ShowWindowItems
   XOR   A
   LD    (App_ID),A
   LD    (StartAppIndex),A
MNU_OptManApps1
;
   LD    A,(App_ID)
   CALL  App_ShowAppDetails		;show app Name/filename
;
   LD    A,(StartAppIndex)
   CALL  App_ShowAppNames		;show app names
;
   LD    HL,(MenuWinKeyLoc)
   CALL  KB_Wait4akey			;execute any key pressed
   LD    A,(KB_KeyTested)
   CP    KEY_ESC			;cancel menu options key?
   JR    NZ,MNU_OptManApps1		;No
;
   CALL  WIN_ClearWindow
   XOR   A
   LD    (KB_KeyTested),A
   RET
;=========================================================================
;Name     MNU_OptManAppPrev
;Purpose  To cursor up to the previous application DB entry.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAppPrev
   XOR   A
   LD    (KB_KeyTested),A
   LD    A,(App_ID)
   LD    C,A
   OR    A				;At start of DB?
   JR    Z,MNU_OptManAppPrev1		;Yes
   DEC   A
   LD    (App_ID),A
MNU_OptManAppPrev1
   LD    A,(StartAppIndex)
   OR    A				;List items at DB start?
   RET   Z				;Yes
   CP    C				;At top of viewed items?
   RET   NZ				;No
   DEC   A
   LD    (StartAppIndex),A
   RET
;=========================================================================
;Name     MNU_OptManAppNext
;Purpose  To cursor down to the next application DB entry.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAppNext
   XOR   A
   LD    (KB_KeyTested),A
   LD    A,(LastAppIndex)
   LD    C,A
   LD    A,(App_ID)
   CP    C				;At end of DB?
   RET   Z
   INC   A
   LD    (App_ID),A
   LD    B,A
   LD    A,(StartAppIndex)
   ADD   A,5
   CP    B				;current at bottom?
   RET   NZ				;No
   CP    C				;list shows last 5?
   RET   NC				;Yes
   SUB   A,4
   LD    (StartAppIndex),A
   RET
;=========================================================================
;Name     MNU_OptManAppIns
;Purpose  To execute an install script to install the details of an
;         application to make it available to the browser.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FIO_LoadScrpt
;         FIO_RequestFile
;Notes    1. FIX ME
;=========================================================================
MNU_OptManAppIns
   XOR   A
   LD    (KB_KeyTested),A
   CALL  FIO_RequestFile
   RET   Z				;Yes (do nothing)
   LD    DE,SysGenBuffer
   LD    (FileLoadAddr),DE
   CALL  FIO_LoadObject			;Load script to &8000
   LD    (PAR_ScriptEnd),HL
   JP    PAR_ParseScript		;execute install
;=========================================================================
;Name     MNU_OptManAppRem
;Purpose  To tag the application entry as not being accessible and to
;         not aloow for the application to be saved.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAppRem
   XOR   A
   LD    (KB_KeyTested),A
   JP    App_DeleteApp			;Tag App is not available at all
;=========================================================================
;Name     MNU_OptManAppInput
;Purpose  To toggle input type on handler.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAppInput
   XOR   A
   LD    (KB_KeyTested),A
   JP    App_ToggleInput		;toggle handler input.
;=========================================================================
;Name     MNU_OptManAppStop
;Purpose  To disable the application from being started.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAppStop
   XOR   A
   LD    (KB_KeyTested),A
   JP    App_StopAppAccess		;Tag App is is disabled.
;=========================================================================
;Name     MNU_OptManAppStart
;Purpose  To enable the application to be startable.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAppStart
   XOR   A
   LD    (KB_KeyTested),A
   JP    App_StartAppAccess		;Tag App is enabled.
;=========================================================================
;Name     MNU_OptManAdv
;Purpose  To display the options manager's advanced settings.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars MenuWinKeyLoc = corrupted.
;         KB_KeyTested = corrupted.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdv
   LD    HL,SubMenu_OptManageAdv
   CALL  MNU_ShowWindowItems
MNU_OptManAdv1
   CALL  MNU_ShowSysDetails
   LD    HL,(MenuWinKeyLoc)
   CALL  KB_Wait4akey			;execute any key pressed
   LD    A,(KB_KeyTested)
   CP    KEY_ESC				;cancel menu options key?
   JP    NZ,MNU_OptManAdv1		;No
   CALL  WIN_ClearWindow
   XOR   A
   LD    (KB_KeyTested),A
   RET
;=========================================================================
;Name     MNU_OptManAdvWrap
;Purpose  To toggle the state of the wrap lock flag to control the
;         wrapping of text once the max limit of page text is encountered.
;         If the flag is enabled then all text can only appear on one
;         line of the HTML page until a CR/LF is encountered in preserved
;         text or the <BR> in a HTML text (the <BR> in tables have no
;         affect)
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  WrapLock = Current Wrap state.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars WrapLock = state toggled.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvWrap
   LD    A,(WrapLock)
   XOR   1
   LD    (WrapLock),A
   XOR   A
   LD    (KB_KeyTested),A
   RET
;=========================================================================
;Name     MNU_OptManAdvPage
;Purpose  To toggle the state of the page lock flag to deny users from
;         scrolling a page beyond the screen or the enable the user to
;         scroll pages.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  PageLock = current page lock state.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars PageLock = page lock state toggled.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvPage
   LD    A,(PageLock)
   XOR   2
   LD    (PageLock),A
   XOR   A
   LD    (KB_KeyTested),A
   RET
;=========================================================================
;Name     MNU_OptManAdvCU
;Purpose  To adjust the cursor up key.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_KeyTested = cleared
;         KB_Buffer = corrupted with user input.
;         CursorKey_Up = updated with new key value
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvCU
   LD    DE,SYSDET_POS
   LD    HL,&0203
   CALL  MNU_Request3chrs
   LD    (CursorKey_Up),A
   RET
;=========================================================================
;Name     MNU_OptManAdvCD
;Purpose  To adjust the cursor down key.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_KeyTested = cleared
;         KB_Buffer = corrupted with user input.
;         CursorKey_Down = updated with new key value
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvCD
   LD    DE,SYSDET_POS
   LD    HL,&0204
   CALL  MNU_Request3chrs
   LD    (CursorKey_Down),A
   RET
;=========================================================================
;Name     MNU_OptManAdvCR
;Purpose  To adjust the cursor right key.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_KeyTested = cleared
;         KB_Buffer = corrupted with user input.
;         CursorKey_Right = updated with new key value
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvCR
   LD    DE,SYSDET_POS
   LD    HL,&0206
   CALL  MNU_Request3chrs
   LD    (CursorKey_Right),A
   RET
;=========================================================================
;Name     MNU_OptManAdvCL
;Purpose  To adjust the cursor left key.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_KeyTested = cleared
;         KB_Buffer = corrupted with user input.
;         CursorKey_Left = updated with new key value
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvCL
   LD    DE,SYSDET_POS
   LD    HL,&0205
   CALL  MNU_Request3chrs
   LD    (CursorKey_Left),A
   RET
;=========================================================================
;Name     MNU_OptManAdvCS
;Purpose  To adjust the cursor select key.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_KeyTested = cleared
;         KB_Buffer = corrupted with user input.
;         CursorKey_Select = updated with new key value
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvCS
   LD    DE,SYSDET_POS
   LD    HL,&0207
   CALL  MNU_Request3chrs
   LD    (CursorKey_Select),A
   RET
;=========================================================================
;Name     MNU_OptManAdvCT
;Purpose  To adjust the cursor tracking speed
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_KeyTested = cleared
;         KB_Buffer = corrupted with user input.
;         Cursor_Speed = updated with new key value
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvCT
   LD    DE,SYSDET_POS
   LD    HL,&0208
   CALL  MNU_Request3chrs
   CALL  UTL_MulABy10
   LD    (Cursor_Speed),HL
   RET
;=========================================================================
;Name     MNU_OptManAdvCI
;Purpose  To select the icon for the cursor
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_KeyTested = cleared
;         KB_Buffer = corrupted with user input.
;         Cursor_Icon = updated with new icon value
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvCI
   LD    DE,SYSDET_POS
   LD    HL,&0209
   CALL  MNU_Request3chrs
   JP    KB_SetupCursorIcon
;=========================================================================
;Name     MNU_OptManAdvKeep
;Purpose  To save the changed cursor settings into the configuration bank
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvKeep
   CALL  MEM_SwapinCFG
;
   LD    A,(CursorKey_Up)
   LD    (CFG_CurKey_Up),A
;
   LD    A,(CursorKey_Down)
   LD    (CFG_CurKey_Down),A
;
   LD    A,(CursorKey_Left)
   LD    (CFG_CurKey_Left),A

   LD    A,(CursorKey_Right)
   LD    (CFG_CurKey_Right),A
;
   LD    A,(CursorKey_Select)
   LD    (CFG_CurKey_Select),A
;
   LD    A,(Cursor_Icon)
   LD    (CFG_Cursor_Icon),A
;
   LD    A,(Cursor_IcnSet)
   LD    (CFG_Cursor_IcnSet),A
;
   JP  MEM_SwapinMain
;=========================================================================
;Name     MNU_OptManAdvRset
;Purpose  To reset the changed cursor settings from the configuration bank
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptManAdvRset
   CALL  MEM_SwapinCFG
;
   LD    A,(CFG_CurKey_Up)
   LD    (CursorKey_Up),A
;
   LD    A,(CFG_CurKey_Down)
   LD    (CursorKey_Down),A
;
   LD    A,(CFG_CurKey_Left)
   LD    (CursorKey_Left),A
;
   LD    A,(CFG_CurKey_Right)
   LD    (CursorKey_Right),A
;
   LD    A,(CFG_CurKey_Select)
   LD    (CursorKey_Select),A
;
   LD    A,(CFG_Cursor_Icon)
   LD    (Cursor_Icon),A
;
   LD    A,(CFG_Cursor_IcnSet)
   LD    (Cursor_IcnSet),A
;
   JP  MEM_SwapinMain
;=========================================================================
;Name     MNU_OptionAccess
;Purpose  To display the window to manage the system access settings.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptionAccess
   LD    HL,SubMenu_OptionAccess
   CALL  MNU_ShowWindowItems
MNU_OptionAccess1
   CALL  MNU_ShowAccessDetails
   LD    HL,(MenuWinKeyLoc)
   CALL  KB_Wait4akey			;execute any key pressed
   LD    A,(KB_KeyTested)
   CP    KEY_ESC				;cancel menu options key?
   JP    NZ,MNU_OptionAccess1		;No
   CALL  WIN_ClearWindow
   RET
;=========================================================================
;Name     MNU_OptAccessURL
;Purpose  To adjust the URL access controls flag.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  LogURLs = current state of logging URLs.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars LogURLs = toggled state of logging URLs.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptAccessURL
   LD    A,(LogURLs)
   XOR   4
   LD    (LogURLs),A
   XOR   A
   LD    (KB_KeyTested),A
   RET
;=========================================================================
;Name     MNU_OptAccessFile
;Purpose  To adjust the File access controls flag.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  LogFiles = current state of logging Files.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars LogFiles = toggled state of logging Files.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptAccessFile
   LD    A,(LogFiles)
   XOR   8
   LD    (LogFiles),A
   XOR   A
   LD    (KB_KeyTested),A
   RET
;=========================================================================
;Name     MNU_OptAccessExit
;Purpose  To adjust the exit controls flag.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  SysExit = current state of exit.
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars SysExit = toggled state of exit.
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptAccessExit
   LD    A,(SysExit)
   XOR   16
   LD    (SysExit),A
   XOR   A
   LD    (KB_KeyTested),A
   RET
;=========================================================================
;Name     MNU_OptAppsCtrl
;Purpose  To adjust the Apps control flag
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  App_CtrlFlg = current state of apps insertion
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars App_CtrlFlg = updated state of apps insertion
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptAppsCtrl
   LD    A,(App_CtrlFlg)
   XOR   128
   LD    (App_CtrlFlg),A
   RET
;=========================================================================
;Name     MNU_OptAppsMode
;Purpose  To Toggle the mode between 1 and 2
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  HTML_DispStatus = current state of screen refresh
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars HTML_DispStatus = Update state of screen refresh
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_OptAppsMode
   LD    A,(HTML_DispStatus)
   OR    1
   LD    (HTML_DispStatus),A
   LD    A,(SCrn_Mode)
   CP    1
   JR    Z,MNU_OptAppsMode1
   LD    A,1
   LD    (Scrn_Mode),A
   RET
MNU_OptAppsMode1
   LD    A,2
   LD    (Scrn_Mode),A
   RET
;=========================================================================
;
;   MENU 'INFORMATION'
;
;=========================================================================
;Name     MNU_InformationMenu
;Purpose  To display the "Information" options.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_InformationMenu
   LD    HL,SubMenu_Help
   JP    MNU_ShowMainMenuOptions
;=========================================================================
;Name     MNU_HelpVersion
;Purpose  To display the current version of the browser.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_HelpVersion
   LD    HL,CPCB_versApp
   JP    App_StartCfgApp
;=========================================================================
;Name     MNU_HelpHistory
;Purpose  To display the current history of the browser.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
MNU_HelpHistory
   LD    HL,CPCB_HistApp
   JP    App_StartCfgApp
