;=========================================================================
;
; Browser Application Routines (Font)
; Copyright (c) 2010 Ray Palmer
;
; The First 32 user def characters are used for icons
; The next 96 user def characters are specific to fonts
;
;=========================================================================
ICN_HORIZONTALBAR	EQU	1
ICN_VERTICALBAR		EQU	2
ICN_CORNERLEFTTOP	EQU	7
ICN_CORNERLEFTBOT	EQU	9
ICN_CORNERRIGHTTOP	EQU	8
ICN_CORNERRIGHTBOT	EQU	10
ICN_HORIZONTALSLID	EQU	15
ICN_VERTICALLSLID	EQU	16
ICN_SCROLLLEFT		EQU	18
ICN_SCROLLRIGHT		EQU	17
ICN_SCROLLUP		EQU	19
ICN_SCROLLDOWN		EQU	20
;=========================================================================
;Name     FRME_VerticalBar
;Purpose  To display the | symbol to mark a side of a window
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
FRME_VerticalBar
   LD    A,ICN_VERTICALBAR
;=========================================================================
;Name     FRME_ShowBorderIcon
;Purpose  To display the system icon symbol
;In Regs  A = Icon Number
;         B = ??
;         C = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FNT_ShowIconChar (file2-font.asm)
;Notes    1. FIXME FOR COLOURS (20140215)
;=========================================================================
FRME_ShowBorderIcon
   PUSH  HL
   DEFB  &06			;LD B,xx
FRME_IconColr
   DEFB  &23			;setup colours for frame/border
   LD    DE,0			;No offsets
   DEFB  &0E			;LD C,xx
FRME_IconSet
   DEFB  0
   CALL  FNT_ShowIconChar
   POP   HL
   RET
;=========================================================================
;Name     FRME_HorizontalBar
;Purpose  To display the - symbol to mark the top/bottom of a window
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_HorizontalBar
   LD    A,ICN_HORIZONTALBAR
   JR    FRME_ShowBorderIcon
;=========================================================================
;Name     FRME_CornerRightBottom
;Purpose  To display the plus symbol to mark a corner of a window
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_CornerRightBottom
   LD    B,ICN_CORNERRIGHTBOT
   JR    FRME_ShowCornerIcon
;=========================================================================
;Name     FRME_CornerLeftBottom
;Purpose  To display the plus symbol to mark a corner of a window
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_CornerLeftBottom
   LD    B,ICN_CORNERLEFTBOT
   JR    FRME_ShowCornerIcon
;=========================================================================
;Name     FRME_CornerRightTop
;Purpose  To display the plus symbol to mark a corner of a window
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_CornerRightTop
   LD    B,ICN_CORNERRIGHTTOP
   JR    FRME_ShowCornerIcon
;=========================================================================
;Name     FRME_CornerLeftTop
;Purpose  To display the plus symbol to mark a corner of a window
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_CornerLeftTop
   LD    B,ICN_CORNERLEFTTOP
FRME_ShowCornerIcon
   LD    A,(FRME_FrameType)
   AND   128
   BIT   7,A			;Hard corner?
   JR    Z,FRME_ShowCornerIcon1	;Yes
   LD    A,4			;soft corner offset
FRME_ShowCornerIcon1
   ADD   A,B			;calc offset to icon to display
   JR    FRME_ShowBorderIcon
;=========================================================================
;Name     FRME_ScrollLeftIcon
;Purpose  To display the scoll horizontal left (HL) icon
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H + 1
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_ScrollLeftIcon
   LD    A,ICN_SCROLLLEFT
   JR    FRME_ShowBorderIcon
;=========================================================================
;Name     FRME_ScrollRightIcon
;Purpose  To display the scoll horizontal right (HR) icon
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = Row in L + 1, Column in H
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_ScrollRightIcon
   LD    A,ICN_SCROLLRight
   JR    FRME_ShowBorderIcon
;=========================================================================
;Name     FRME_ScrollUpIcon
;Purpose  To display the scoll vertical up (VU) icon
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H + 1
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_ScrollUpIcon
   LD    A,ICN_SCROLLUP
   JR    FRME_ShowBorderIcon
;=========================================================================
;Name     FRME_ScrollDownIcon
;Purpose  To display the scoll vertical down (VD) icon
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = Row in L + 1, Column in H
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_ScrollDownIcon
   LD    A,ICN_SCROLLDOWN
   JR    FRME_ShowBorderIcon
;=========================================================================
;Name     FRME_ScrollVSliderIcn
;Purpose  To display the window vertical slider icon
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_ScrollVSliderIcn
   LD    A,ICN_VERTICALLSLID
   JR    FRME_ShowBorderIcon
;=========================================================================
;Name     FRME_ScrollHSliderIcn
;Purpose  To display the window horizontal slider icon
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShowBorderIcon
;Notes    TBD
;=========================================================================
FRME_ScrollHSliderIcn
   LD    A,ICN_HORIZONTALSLID
   JR    FRME_ShowBorderIcon
;=========================================================================
;Name     FRME_HorizontalBars
;Purpose  To display the horizontal frame border
;In Regs  A = ??
;         B = number icons before end
;         C = ??
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         H = H + n columns
;         L = unchanged.
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_HorizontalBar
;Notes    TBD
;=========================================================================
FRME_HorizontalBars
   LD    A,(FRME_EndCol)
   SUB   A,B
   LD    C,A				;Setup end column
FRME_ShwFramDashes
   INC   H				;next column
   LD    A,C				;Get End column to stop at
   CP    H				;At end column?
   RET   Z				;Yes
   PUSH  BC
   CALL  FRME_HorizontalBar		;Display frame horizontal border
   POP   BC
   JR    FRME_ShwFramDashes
;=========================================================================
;Name     FRME_FrameLeftCol
;Purpose  To display the left portion of the frame border
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = Row in L
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = Row in L + n, Column in H
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ShwFrameBars
;Notes    TBD
;=========================================================================
FRME_FrameLeftCol
   LD    HL,(FRME_StartRow)		;L = Start row, H = Start Column
   LD    B,0				;stop at bottom corner
;=========================================================================
;Name     FRME_VeritcalBars
;Purpose  To display the vertical frame border
;In Regs  A = ??
;         B = number icons before end
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = Row in L + n, Column in H
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_VeritcalBar
;Notes    TBD
;=========================================================================
FRME_VeritcalBars
   LD    A,(FRME_EndRow)
   SUB   A,B
   LD    C,A				;setup which row to stop at
FRME_ShwFramBars
   INC   L				;next row
   LD    A,C				;Get end row to stop at
   CP    L				;At end row?
   RET   Z				;Yes
   PUSH  BC
   CALL  FRME_VerticalBar		;Display left border bars
   POP   BC
   JR    FRME_ShwFramBars
;=========================================================================
;Name     FRME_FrameTopRow
;Purpose  To display the top portion of the frame border
;In Regs  A = ??
;         B = number rows
;         DE = ??
;         HL = Row in L, Column in H
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = Row in L + n, Column in H
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_CornerLeftTop
;         FRME_CornerRightTop
;         FRME_HorizontalBars
;Notes    TBD
;=========================================================================
FRME_FrameTopRow
   LD    HL,(FRME_StartRow)		;L = Start row, H = Start column
   CALL  FRME_CornerLeftTop
   LD    B,0
   CALL  FRME_HorizontalBars
   JP    FRME_CornerRightTop
;=========================================================================
;Name     FRME_FrameRightCol
;Purpose  To display the right portion of the frame border
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = Row in L + n, Column in H
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_ScrollUpIcon
;         FRME_ScrollVSliderIcn
;         FRME_VeritcalBars
;         FRME_ScrollDownIcon
;Notes    TBD
;=========================================================================
FRME_FrameRightCol
   LD    HL,(FRME_StartRow)		;L = Start row
   LD    A,(FRME_EndCol)
   LD    H,A				;H = End column
;
   LD    A,(FRME_FrameType)
   BIT   0,A				;Scrolling frame/border?
   JR    Z,FRME_FramRightCol		;No
;
;  Display right scrollable border of window
;
   INC   L				;next row
   CALL  FRME_ScrollUpIcon		;Display scroll up icon
   INC   L
   CALL  FRME_ScrollVSliderIcn	;Display slider icon
   LD    B,1				;Account for icon
   CALL  FRME_VeritcalBars		;Display right frame border
   JP    FRME_ScrollDownIcon		;Display scroll down icon
;
FRME_FramRightCol
;
;  Display right border of non-scrollable window
;
   LD    B,0
   JP    FRME_VeritcalBars		;Display left border
;=========================================================================
;Name     FRME_FrameBottomRow
;Purpose  To display the bottom portion of the frame border
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    FRME_CornerLeftBottom
;         FRME_ScrollLeftIcon
;         FRME_ScrollHSliderIcn
;         FRME_HorizontalBars
;         FRME_ScrollRightIcon
;         FRME_CornerRightBottom
;Notes    TBD
;=========================================================================
FRME_FrameBottomRow
   LD    HL,(FRME_EndRow)		;L = bottom row
   LD    A,(FRME_StartCol)
   LD    H,A				;H = start column
   CALL  FRME_CornerLeftBottom
;
   LD    A,(FRME_FrameType)
   BIT   0,A				;Scrolling frame/border?
   JR    Z,FRME_FramBottomRow		;No
;
;  Display bottom scrollable border of window
;
   INC   H				;Next column
   CALL  FRME_ScrollLeftIcon
   INC   H
   CALL  FRME_ScrollHSliderIcn		;Display slider icon
   LD    B,1				;stop at scroll right icon
   CALL  FRME_HorizontalBars		;display bottom frame border
   CALL  FRME_ScrollRightIcon
   INC   H
   JR    FRME_FramBottomRow1
;
FRME_FramBottomRow
;
;  Display bottom border of window
;
   LD    B,0
   CALL  FRME_HorizontalBars		;display bottom frame border
FRME_FramBottomRow1
   JP    FRME_CornerRightBottom
;=========================================================================
;Name     FRME_DisplayBorder
;Purpose  To display a border.
;In Regs  A = Frame Type
;               Bit Description
;                7  Corner type (0=hard, 1 = Rounded)
;               6-1 Unused
;                0  Scroll type (0=Non-scrollable, 1=scrollable)
;         B = frame/border icons start within the icon set.
;         C = Icon Set number
;         D = End Column (from 0)
;         E = End Row (from 0)
;         H = Start Column (from 0)
;         L = Start Row (from 0)
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars FNT_StartRow = start column/Row
;         FNT_EndRow = End Column/Row
;         FNT_FrameIconSt = Frames Icons Start
;         FNT_IconSet = Icons set from which frame is to be drawn from
;Uses     All registers
;Call By  CPCB.EXE (via cpcb_win.asm)
;Calls    TBD
;Notes    1. The order of the icons is the same for all borders.
;         2. The input start and end coordinates are the absolute values
;            corresponding to the screen, so the range of the coordinates
;            are (0,0) to (24,79)
;=========================================================================
FRME_DisplayBorder
   LD    A,(FRME_BrdrColrs)
   LD    (FRME_IconColr),a
   XOR   A
   LD    (FRME_FrameType),A	;Display border (non-scroll frame)
   LD    B,A
   JR    FRME_DisplyFB
;=========================================================================
;Name     FRME_DisplayFrame
;Purpose  To display a frame or border.
;In Regs  A = Frame Type
;               Bit Description
;                7  Corner type (0=hard, 1 = Rounded)
;               6-1 Unused
;                0  Scroll type (0=Non-scrollable, 1=scrollable)
;         B = frame/border icons start within the icon set.
;         C = Icon set number
;         D = End Column (from 0)
;         E = End Row (from 0)
;         H = Start Column (from 0)
;         L = Start Row (from 0)
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars FNT_StartRow = start column/Row
;         FNT_EndRow = End Column/Row
;         FNT_FrameIconSt = Frames Icons Start
;         FNT_IconSet = Icons set from which frame is to be drawn from
;Uses     All registers
;Call By  CPCB.EXE (via cpcb_win.asm)
;Calls    TBD
;Notes    1. The order of the icons is the same for all borders.
;         2. The input start and end coordinates are the absolute values
;            corresponding to the screen, so the range of the coordinates
;            are (0,0) to (24,79)
;=========================================================================
FRME_DisplayFrame
   LD    (FRME_FrameType),A
   LD    A,(FRME_FramColrs)
   LD    (FRME_IconColr),a
FRME_DisplyFB
   LD    A,C
   LD    (FRME_IconSet),A		;Patch routine LD C,xxx
   LD    (FRME_StartRow),HL		;Save start row/column
   LD    (FRME_EndRow),DE		;save end row/column
   LD    A,B
   LD    (FRME_FrameIconSt),A
;
   CALL  FRME_FrameTopRow		;display top row
   CALL  FRME_FrameLeftCol		;display left column
   CALL  FRME_FrameRightCol		;display right column
   JP    FRME_FrameBottomRow		;display bottom row
;=========================================================================
FRME_StartRow		DEFB	0
FRME_StartCol		DEFB	0
FRME_EndRow		DEFB	0
FRME_EndCol		DEFB	0
FRME_FrameIconSt	DEFB	0
FRME_FrameType		DEFB	0	;0=non-scrollable else scrollable
;
FRME_BrdrColrs		DEFB	0
FRME_FramColrs		DEFB	0
