;=========================================================================
;
; Application Routines (accessing CPCB routines)
; Copyright (c) 2010 Ray Palmer
;
; Notes
;
;=========================================================================
;Name     CPCB_AdjustRow
;Purpose  To adjust the row so that it is below the main menu area.
;         BC = ??
;         DE = ??
;         HL = absolute Screen position offset into the web-page
;               H = Row/L = Column
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         H = H + adjustment row
;         L = no change
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    None
;Notes    TBD
;=========================================================================
CPCB_AdjustRow
   PUSH  AF
   LD    A,5
   ADD   A,L		;Adjust screen row to be in web-page window
   LD    L,A
   POP   AF
   RET
;=========================================================================
;Name     CPCB_TrapCode
;Purpose  To trap a routine
;In Regs  A = ??
;         BC = ??
;         DE = destination location for data
;         HL = address of source text
;         IX = ???
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  Any routine to enable WinAPE (or equivalent tool) to trap
;         routines.
;Calls    Hard coded routine into the CPC Browser after the initial
;         jump routine.
;Notes    1. The hardcoded routine in CPC Browser simply returns.
;=========================================================================
CPCB_TrapCode
   JP    CPCB_DbugTrap		;DEBUG
;=========================================================================
;Name     CPCB_ShowTimer
;Purpose  Access the CPCB routine to display one of the timer symbol icons
;         show the system is busy.
;In Regs  A = ??
;         B = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_ShowTimer)
;Notes    TBD
;=========================================================================
CPCB_ShowTimer
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_ShowTimer
   RET
;=========================================================================
;Name     CPCB_OpenNewObj
;Purpose  Access the CPCB routine to load a HTML object
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = address of URL text
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_OpenNewObj)
;Notes    TBD
;=========================================================================
CPCB_OpenNewObj
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_OpenNewObj
   LD    A,(FileOpState)
   OR    A			;Object access error ?
   RET
;=========================================================================
;Name     CPCB_OpenURLLink
;Purpose  Access the CPCB routine to download an object
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = address of URL text
;         IX = ??
;         IY = ??
;In Vars  URL_Object setup
;                    URL_ObjStrtTxt = URL to opwn
;         KB_Buffer has file location and name to download to.
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_OpenURLLink)
;Notes    TBD
;=========================================================================
CPCB_OpenURLLink
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_OpenURLLink
   RET
;=========================================================================
;Name     CPCB_FontEffect
;Purpose  Access the CPCB routine to change a fonts effect.
;In Regs  A = Bit's to XOR
;         B = 0 means init to zero
;             >0 bits to set/clear.
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_NewFontEffect)
;Notes    TBD
;=========================================================================
CPCB_FontEffect
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_NewFontEffect
   RET
;=========================================================================
;Name     CPCB_GetWinInput
;Purpose  Access the CPCB routine to get input via a window
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_GetWinInput)
;Notes    TBD
;=========================================================================
CPCB_GetWinInput
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_GetWinInput
   RET
;=========================================================================
;Name     CPCB_WinPrint
;Purpose  Access the CPCB routine to get print text in a window
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_WinPrint)
;Notes    TBD
;=========================================================================
CPCB_WinPrint
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_WinPrint
   RET
;=========================================================================
;Name     CPCB_ShowPageTitle
;Purpose  Access the CPCB routine to display the web-page title.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  HTML_CmdTemp = address of text location.
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_ShowPageTitle)
;Notes    TBD
;=========================================================================
CPCB_ShowPageTitle
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_ShowPageTitle
   RET
;=========================================================================
;Name     CPCB_ScrollFrame
;Purpose  Access the CPCB routine to display the web-page title.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  Window_FrameV = frame info to display on screen.
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (WIN_ScrollFrame)
;Notes    TBD
;=========================================================================
CPCB_ScrollFrame
   LD    HL,Off_WebPge			;Offset for frame display
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_ScrollFrame
   RET
;=========================================================================
;Name     CPCB_NonScrollFrame
;Purpose  Access the CPCB routine to display the web-page title.
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  Window_FrameV = frame info to display on screen.
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (WIN_NonScrollFrame)
;Notes    TBD
;=========================================================================
CPCB_NonScrollFrame
   LD    HL,Off_WebPge			;Offset for frame display
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_NonScrollFrame
   RET
;=========================================================================
;Name     CPCB_ShowBorder
;Purpose  Access the CPCB routine to display a border.
;In Regs  A = Icon set number for the border
;         B = Start Icon
;         C = Corner type (0=Hard, 1=Soft)
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars BorderIconStrt
;         BorderCorner
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (WIN_ShowBorder)
;Notes    TBD
;=========================================================================
CPCB_ShowBorder
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_ShowBorder
   RET
;=========================================================================
;Name     CPCB_DisplayChar
;Purpose  Access the CPCB routine to display a character on the web-page
;         at the current screen row/column using the current selected font.
;In Regs  A = current character to display.
;         BC = ??
;         DE = ??
;         HL = Screen position offset into the web-page
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_AdjustRow
;         CPCB_CPCAccess
;         CPCB Routine (CPCB_C_DisplayChar)
;Notes    TBD
;=========================================================================
CPCB_DisplayChar
   CALL  CPCB_AdjustRow
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_DisplayChar
   RET
;=========================================================================
;Name     CPCB_DisplayIcon
;Purpose  Access the CPCB routine to display an icon on the web-page
;         at the current screen row/column using the current selected font.
;In Regs  A = Icon Number
;         B = ??
;         C = Icon set number.
;         DE = ??
;         HL = Cursor position in the frame (H=Column,L=Row)
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_PrintIcon)
;Notes    TBD
;=========================================================================
CPCB_DisplayIcon
   LD    E,A
   LD    A,(Icon_ColIdx)
   LD    B,A
   LD    A,E
   LD    DE,5			;screen offsets for icon into web-page
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_PrintIcon
   RET
;=========================================================================
;Name     CPCB_ResetCursor
;Purpose  Access the CPCB routine to reset cursor background after screen
;         refresh.
;In Regs  A = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_ResetCursor)
;Notes    TBD
;=========================================================================
CPCB_ResetCursor
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_ResetCursor
   RET
;=========================================================================
;Name     CPCB_RemoveCursor
;Purpose  Access the CPCB routine to restore the cursor background.
;In Regs  A = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_RemoveCursor)
;Notes    TBD
;=========================================================================
CPCB_RemoveCursor
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_RemoveCursor
   RET
;=========================================================================
;Name     CPCB_SetupIcnData
;Purpose  Access the CPCB routine to setup an icon char with image data
;In Regs  A = ??
;         B = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_SetupIcnData)
;Notes    TBD
;=========================================================================
CPCB_SetupIcnData
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_SetupIcnData
   RET
;=========================================================================
;Name     CPCB_ClearArea
;Purpose  Access the CPCB routine to clear an area of the CPC screen
;         which is only within the viewable web-page area.
;In Regs  A = ??
;         B = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_ClearArea)
;Notes    TBD
;=========================================================================
CPCB_ClearArea
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_ClearArea
   LD    A,(Stream_WebPage)
   JP    SC_SEL_STREAM			;Select stream for web-page
;=========================================================================
;Name     CPCB_DoAppReq
;Purpose  Access the CPCB routine to display execute an application.
;In Regs  A = ??
;         B = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  App_ObjName = address of source text
;         App_ID = application ID
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_DoAppReq)
;Notes    TBD
;=========================================================================
CPCB_DoAppReq
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_DoAppReq
   RET
;=========================================================================
;Name     CPCB_AddNewApp
;Purpose  Access the CPCB routine to display add an application.
;In Regs  A = ??
;         B = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  App_Object = setup with application information.
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_AddNewApp)
;Notes    TBD
;=========================================================================
CPCB_AddNewApp
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_AddNewApp
   RET
;=========================================================================
;Name     CPCB_FindApp
;Purpose  Access the CPCB routine to Find an application.
;In Regs  A = ??
;         B = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  App_Object = setup with application information.
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_FindApp)
;Notes    TBD
;=========================================================================
CPCB_FindApp
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_FindApp
   RET
;=========================================================================
;Name     CPCB_ChkFrmes
;Purpose  Access the CPCB routine to check the visibility of frames loaded
;         up from a main HTML file.
;In Regs  A = ??
;         B = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_ChkFrmes)
;Notes    TBD
;=========================================================================
CPCB_ChkFrmes
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_ChkFrmes
   RET
;=========================================================================
;Name     ShwErrorMsg
;Purpose  Access the CPCB routine to display an error/info message.
;In Regs  A = ??
;         B = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         B = ??
;         C = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    CPCB_CPCAccess
;         CPCB Routine (CPCB_C_ShwErrorMsg)
;Notes    TBD
;=========================================================================
CPCB_ShwErrorMsg
   CALL  CPCB_CPCAccess
   DEFB  CPCB_C_ShwErrorMsg
   RET
;