;===============================================================================
;
; Browser application Data (HTML)
; Copyright (c) 2010 Ray Palmer
;
;===============================================================================
;  Standard Fonts by Name
;
;===============================================================================
FONT_System		DEFM	"normal"	;Standard Normal (default)
			DEFB	0
FONT_Italic		DEFM	"italic"	;Italic font (Fixed spaced)
			DEFB	0
FONT_small		DEFM	"small"		;small font (Fixed spaced)
			DEFB	0
FONT_teletype		DEFM	"teletype"	;teletype font (Fixed spaced)
			DEFB	0
FONT_big		DEFM	"big"		;big font (Fixed spaced)
			DEFB	0
FONT_Sub		DEFM	"subscript"	;subscript font (Fixed spaced)
			DEFB	0
FONT_Sup		DEFM	"Super"		;super font (Fixed spaced)
			DEFB	0
;
FONT_Symbols		DEFM	"symbols"	;List of Font Symbols
			DEFB	0
;===============================================================================
;
;  Alignment type constants
;
;===============================================================================
HTM_ALIGNUNK		EQU	0
HTM_ALIGNLEFT		EQU	1
HTM_ALIGNRIGHT		EQU	2
HTM_ALIGNCENTER		EQU	3
HTM_ALIGNJUST		EQU	4
HTM_ALIGNTOP		EQU	5
HTM_ALIGNBOTTOM		EQU	6
;===============================================================================
;
;	Parameter label name types
;
;  All HTML parameter labels must be in lower case
;
;
HTM_ParamTypes
;===============================================================================
HTM_P_align		EQU	0
			DEFB	"alig","n"+128
;===============================================================================
HTM_P_alignL		EQU	1
			DEFB	"lef","t"+128
;===============================================================================
HTM_P_alignR		EQU	2
			DEFB	"righ","t"+128
;===============================================================================
HTM_P_alignC		EQU	3
			DEFB	"cente","r"+128
;===============================================================================
HTM_P_alignJ		EQU	4
			DEFB	"justif","y"+128
;===============================================================================
HTM_P_alignT		EQU	5
			DEFB	"to","p"+128
;===============================================================================
HTM_P_alignB		EQU	6
			DEFB	"botto","m"+128
;===============================================================================
HTM_P_rows		EQU	7
			DEFB	"row","s"+128
;===============================================================================
HTM_P_cols		EQU	8
			DEFB	"col","s"+128
;===============================================================================
HTM_P_width		EQU	9
			DEFB	"widt","h"+128
;===============================================================================
HTM_P_span		EQU	10
			DEFB	"spa","n"+128
;===============================================================================
HTM_P_nowrap		EQU	11
			DEFB	"nowra","p"+128
;===============================================================================
HTM_P_href		EQU	12
			DEFB	"hre","f"+128
;===============================================================================
HTM_P_id		EQU	13
HTM_P_idV		DEFB	"i","d"+128
;===============================================================================
HTM_P_name		EQU	14
HTM_P_nameV		DEFB	"nam","e"+128
;===============================================================================
HTM_P_rowspan		EQU	15
			DEFB	"rowspa","n"+128
;===============================================================================
HTM_P_value		EQU	16
			DEFB	"valu","e"+128
;===============================================================================
HTM_P_colspan		EQU	17
			DEFB	"colspa","n"+128
;===============================================================================
HTM_P_onclick		EQU	18
			DEFB	"onclic","k"+128
;===============================================================================
HTM_P_ondblclk		EQU	19
			DEFB	"ondblclic","k"+128
;===============================================================================
HTM_P_tabindex		EQU	20
			DEFB	"tabinde","x"+128
;===============================================================================
HTM_P_type		EQU	21
			DEFB	"typ","e"+128
;===============================================================================
HTM_P_multiple		EQU	22
			DEFB	"multipl","e"+128
;===============================================================================
HTM_P_selected		EQU	23
			DEFB	"selecte","d"+128
;===============================================================================
HTM_P_checked		EQU	24
			DEFB	"checke","d"+128
;===============================================================================
HTM_P_src		EQU	25
			DEFB	"sr","c"+128
;===============================================================================
HTM_P_frameborder	EQU	26
			DEFB	"frameborde","r"+128
;===============================================================================
HTM_P_border		EQU	27
			DEFB	"borde","r"+128
;===============================================================================
;
;	Forms type names
;
;   Constants For forms types
;
;===============================================================================
HTML_I_FORM		EQU	15		;also is mask
HTML_I_BUTTONC		EQU	13
HTML_I_OPTION		EQU	12
HTML_I_OPTGRP		EQU	11
HTML_I_SELECT		EQU	10
HTML_I_TXTBOX		EQU	9
;===============================================================================
HTML_I_Chkbox		EQU	0
HTM_P_Chkbox		EQU	28
			defb	"checkbo","x"+128
;===============================================================================
HTML_I_Radio		EQU	1
HTM_P_Radio		EQU	29
			defb	"radi","o"+128
;===============================================================================
HTML_I_Text		EQU	2
HTM_P_Text		EQU	30
			defb	"tex","t"+128
;===============================================================================
HTML_I_Password		EQU	3
HTM_P_Password		EQU	31
			defb	"passwor","d"+128
;===============================================================================
HTML_I_Submit		EQU	4
HTM_P_Submit		EQU	32
HTM_C_SUBMIT		defb	"submi","t"+128
;===============================================================================
HTML_I_Reset		EQU	5
HTM_P_Reset		EQU	33
HTM_C_RESET		defb	"rese","t"+128
;===============================================================================
HTML_I_File		EQU	6
HTM_P_File		EQU	34
			defb	"fil","e"+128
;===============================================================================
HTML_I_Image		EQU	7
HTM_P_Image		EQU	35
			defb	"imag","e"+128
;===============================================================================
HTML_I_Button		EQU	8
HTM_P_Button		EQU	36
			defb	"butto","n"+128
;===============================================================================
HTM_P_Hidden		EQU	37
			defb	"hidde","n"+128
;===============================================================================
HTM_P_class		EQU	38
			defb	"clas","s"+128
;===============================================================================
HTM_P_clear		EQU	39
			defb	"clea","r"+128
;===============================================================================
HTM_P_method		EQU	40
			defb	"metho","d"+128
;===============================================================================
HTM_P_action		EQU	41
			defb	"actio","n"+128
;===============================================================================
HTM_P_enctype		EQU	42
			defb	"enctyp","e"+128
;===============================================================================
HTM_P_style		EQU	43
			defb	"styl","e"+128
;===============================================================================
;
;	Style command string constants
;
;===============================================================================
HTM_P_thin		EQU	44
			defb	"thi","n"+128
HTM_P_thick		EQU	45
			defb	"thic","k"+128
HTM_P_medium		EQU	46
			defb	"mediu","m"+128
;
HTM_P_btsolid		EQU	47
			defb	"soli","d"+128
HTM_P_btdble		EQU	48
			defb	"doubl","e"+128
HTM_P_btdottd		EQU	49
			defb	"dotte","d"+128
HTM_P_btdashd		EQU	50
			defb	"dashe","d"+128
HTM_P_btgroov		EQU	51
			defb	"groov","e"+128
HTM_P_btridg		EQU	52
			defb	"ridg","e"+128
HTM_P_btinset		EQU	53
			defb	"inse","t"+128
HTM_P_btoutset		EQU	54
			defb	"outse","t"+128
;===============================================================================
HTM_P_Label2		EQU	55
			defb	"labe","l"+128
;===============================================================================
HTM_P_BadParam		EQU	255
			DEFB	128		;end of params type strings
;===============================================================================
;
;  HTM_SC_ClearP
;
;===============================================================================
HTM_ClearParams
;
HTM_ClrPNone		EQU	0
			DEFB	"Non","e"+128
HTM_ClrPLeft		EQU	1
			DEFB	"lef","t"+128
HTM_ClrPRight		EQU	2
			DEFB	"Righ","t"+128
HTM_ClrPAll		EQU	3
			DEFB	"Al","l"+128
			DEFB	128		;end of params type strings
;===============================================================================
;
;  HTML Commands
;
;===============================================================================
HTML_Commands
HTM_P_label
		defb	"label "		;(0) Label command
		defb	B_7+B_5
		defw	html_cmd_Label
		defb	0
;===============================================================================
		defb	"html"			;(1) start of a HTML document
		defb	B_7+B_6+B_5
		defw	HTML_cmd_html
		defb	0
;===============================================================================
		defb	"!doctype"		;(2) doctype tag
		defb	B_7+B_5
		defw	html_cmd_doctype
		defb	0
;===============================================================================
		defb	"head"			;(3) start of header information
		defb	B_7+B_6+B_5
		defw	html_cmd_head
		defb	0
;===============================================================================
HTML_C_body
		defb	"body"			;(4) start of body of html
		defb	B_7+B_6+B_5
		defw	html_cmd_body
		defb	0
;===============================================================================
		defb	"title"			;(5) defines title of web page
		defb	B_7+B_6+B_5
		defw	html_cmd_title
		defb	0
;===============================================================================
HTML_C_pre
		defb	"pre"			;(6) preserve format text
		defb	B_7+B_6+B_5
		defw	html_cmd_pre
		defb	0
;===============================================================================
		defb	"table"			;(7) start of table definition
		defb	B_7+B_6+B_5
		defw	html_cmd_table
		defb	0
;===============================================================================
		defb	"thead"			;(8) table head command
		defb	B_7+B_6+B_5
		defw	html_cmd_thead
		defb	0
;===============================================================================
		defb	"tfoot"			;(9) table footer command
		defb	B_7+B_6+B_5
		defw	html_cmd_tfoot
		defb	0
;===============================================================================
		defb	"tbody"			;(10) table body command
		defb	B_7+B_5
		defw	html_cmd_tbody
		defb	0
;===============================================================================
HTML_C_caption
		defb	"caption"		;(11) define table caption
		defb	B_7+B_6+B_5
		defw	html_cmd_caption
		defb	0
;===============================================================================
		defb	"colgroup"		;(12) table colgroup command
		defb	B_7+B_6+B_5
		defw	html_cmd_colgroup
		defb	0
;===============================================================================
		defb	"col"			;(13) table col command
		defb	B_7+B_5
		defw	html_cmd_col
		defb	0
;===============================================================================
		defb	"th"			;(14) define table header
		defb	B_7+B_5
		defw	html_cmd_th
		defb	0
;===============================================================================
		defb	"tr"			;(15) start of table row
		defb	B_7+B_5
		defw	html_cmd_tr
		defb	0
;===============================================================================
		defb	"td"			;(16) define table data
		defb	B_7+B_5
		defw	html_cmd_td
		defb	0
;===============================================================================
		defb	"em"			;(17) emphasis.
		defb	B_7+B_6+b_5
		defw	html_cmd_Em
		defb	0
;===============================================================================
		defb	"strong"		;(18) strong.
		defb	B_7+B_6
		defw	html_cmd_Strong
		defb	0
;===============================================================================
		defb	"cite"			;(19) cite
		defb	B_7+B_6+B_5
		defw	html_cmd_Cite
		defb	0
;===============================================================================
		defb	"code"			;(20) code
		defb	B_7+B_6
		defw	html_cmd_Code
		defb	0
;===============================================================================
		defb	"samp"			;(21) samp
		defb	B_7+B_6
		defw	html_cmd_Samp
		defb	0
;===============================================================================
		defb	"kbd"			;(22) kbd
		defb	B_7
		defw	html_cmd_Kbd
		defb	0
;===============================================================================
		defb	"abbr"			;(23) abbreviation
		defb	B_7
		defw	html_cmd_Abbr
		defb	0
;===============================================================================
		defb	"acronym"		;(24) acronym
		defb	B_7
		defw	html_cmd_Acronym
		defb	0
;===============================================================================
		defb	"var"			;(25) var
		defb	B_7
		defw	html_cmd_Var
		defb	0
;===============================================================================
		defb	"blockquote"		;(26) block quote
		defb	B_7+B_6
		defw	html_cmd_blockquote
		defb	0
;===============================================================================
		defb	"q"			;(27) Quote command
		defb	B_7+B_6
		defw	html_cmd_quote
		defb	0
;===============================================================================
		defb	"sub"			;(28) sub-script command
		defb	B_7+B_6
		defw	html_cmd_Sub
		defb	0
;===============================================================================
		defb	"sup"			;(29) Super-script command
		defb	B_7+B_6
		defw	html_cmd_Sup
		defb	0
;===============================================================================
		defb	"ins"			;(30) insert text command
		defb	B_7+B_6
		defw	html_cmd_Ins
		defb	0
;===============================================================================
		defb	"del"			;(31) delete text command
		defb	B_7+B_6
		defw	html_cmd_Del
		defb	0
;===============================================================================
		defb	"style"			;(32) style command
		defb	B_7+B_6+B_5
		defw	html_cmd_Style
		defb	0
;===============================================================================
		defb	"link"			;(33) link command
		defb	B_7+B_6
		defw	html_cmd_link
		defb	0
;===============================================================================
		defb	"base"			;(34) base command
		defb	B_7+B_6
		defw	html_cmd_base
		defb	0
;===============================================================================
HTML_C_img
		defb	"img"			;(35) image command
		defb	B_7+B_6+B_5
		defw	html_cmd_img
		defb	0
;===============================================================================
		defb	"map"			;(36) map command
		defb	B_7+B_6
		defw	html_cmd_Map
		defb	0
;===============================================================================
		defb	"area"			;(37) area command
		defb	B_7+B_6
		defw	html_cmd_Area
		defb	0
;===============================================================================
		defb	"param"			;(38) param command
		defb	B_7+B_6
		defw	html_cmd_Param
		defb	0
;===============================================================================
		defb	"input"			;(39) input command
		defb	B_7+B_6+B_5
		defw	html_cmd_input
		defb	0
;===============================================================================
		defb	"object"		;(40) object command
		defb	B_7+B_6+B_5
		defw	html_cmd_object
		defb	0
;===============================================================================
		defb	"applet"		;(41) object command
		defb	B_7+B_6+B_5
		defw	html_cmd_applet
		defb	0
;===============================================================================
		defb	"iframe"		;(42) iframe command
		defb	B_7+B_6
		defw	html_cmd_Iframe
		defb	0
;===============================================================================
		defb	"frame"			;(43) frame command
		defb	B_7+B_6+B_5
		defw	html_cmd_frame
		defb	0
;===============================================================================
		defb	"frameset"		;(44) frameset command
		defb	B_7+B_6+B_5
		defw	html_cmd_frameset
		defb	0
;===============================================================================
HTML_C_NoFrames
		defb	"noframes"		;(45) noframes command
		defb	B_7+B_6+B_5
		defw	html_cmd_noframes
		defb	0
;===============================================================================
		defb	"li"			;(46) list item command
		defb	B_7+B_6+B_5
		defw	html_cmd_li
		defb	0
;===============================================================================
		defb	"ul"			;(47) un-order lists
		defb	B_7+B_6+B_5
		defw	html_cmd_ul
		defb	0
;===============================================================================
		defb	"ol"			;(48) order lists
		defb	B_7+B_6+B_5
		defw	html_cmd_ol
		defb	0
;===============================================================================
		defb	"dl"			;(49) defintion lists
		defb	B_7+B_6+B_5
		defw	html_cmd_dl
		defb	0
;===============================================================================
		defb	"dt"			;(50) definition term
		defb	B_7+B_6+b_5
		defw	html_cmd_dt
		defb	0
;===============================================================================
		defb	"dd"			;(51) definition description
		defb	B_7+B_6+B_5
		defw	html_cmd_dd
		defb	0
;===============================================================================
		defb	"dir"			;(52) dir command
		defb	B_7+B_6
		defw	html_cmd_Dir
		defb	0
;===============================================================================
		defb	"menu"			;(53) menu command
		defb	B_7+B_6
		defw	html_cmd_Menu
		defb	0
;===============================================================================
		defb	"h1"			;(54) H1 heading command
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_H1
		defb	0
;===============================================================================
		defb	"h2"			;(55) H2 heading command
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_H2
		defb	0
;===============================================================================
		defb	"h3"			;(56) H3 heading command
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_H3
		defb	0
;===============================================================================
		defb	"h4"			;(57) H4 heading command
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_H4
		defb	0
;===============================================================================
		defb	"h5"			;(58) H5 heading command
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_H5
		defb	0
;===============================================================================
		defb	"h6"			;(59) H6 heading command
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_H6
		defb	0
;===============================================================================
		defb	"font"			;(60) font command
		defb	B_7+B_6
		defw	html_cmd_font
		defb	0
;===============================================================================
		defb	"hr"			;(61) horizontal ruling command
		defb	B_7+B_6+B_5
		defw	html_cmd_hr
		defb	0
;===============================================================================
HTML_C_br
		defb	"br"			;(62) break line
		defb	B_7+B_6+B_5
		defw	html_cmd_br
		defb	0
;===============================================================================
HTML_C_script
		defb	"script"		;(63) script command
		defb	B_7+B_6+b_5
		defw	html_cmd_script
		defb	0
;===============================================================================
		defb	"meta"			;(64) meta command
		defb	B_7+B_6
		defw	html_cmd_Meta
		defb	0
;===============================================================================
		defb	"div"			;(65) div command
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_div
		defb	0
;===============================================================================
		defb	"span"			;(66) span command
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_span
		defb	0
;===============================================================================
		defb	"address"		;(67) address command
		defb	B_7+B_6
		defw	html_cmd_Address
		defb	0
;===============================================================================
		defb	"strike"		;(68) strike font command
		defb	B_7+B_6+B_5
		defw	html_cmd_strike
		defb	0
;===============================================================================
;	Commands for HTML Input
;===============================================================================
		defb	"form"			;(69)
		defb	B_7+B_6+B_5
		defw	html_cmd_form
		defb	0
;===============================================================================
		defb	"input"			;(70)
		defb	B_7+B_6+B_5
		defw	html_cmd_input
		defb	0
;===============================================================================
		defb	"button"		;(71)
		defb	B_7+B_6+B_5
		defw	html_cmd_button
		defb	0
;===============================================================================
		defb	"textarea"		;(72)
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_textarea
		defb	0
;===============================================================================
		defb	"select"		;(73)
		defb	B_7+B_6+B_5
		defw	html_cmd_select
		defb	0
;===============================================================================
		defb	"option"		;(74)
		defb	B_7+B_6+B_5
		defw	html_cmd_option
		defb	0
;===============================================================================
		defb	"optgroup"		;(75)
		defb	B_7+B_6+B_5
		defw	html_cmd_optgroup
		defb	0
;===============================================================================
		defb	"isindex"		;(76)
		defb	B_7+B_5
		defw	0
		defb	0
;===============================================================================
		defb	"fieldset"		;(77)
		defb	B_7+B_5
		defw	0
		defb	0
;===============================================================================
		defb	"legend"		;(78)
		defb	B_7+B_5
		defw	0
		defb	0
;===============================================================================
		defb	"tt"			;(79) teletype font command
		defb	B_7+B_6+B_5
		defw	html_cmd_tt
		defb	0
;===============================================================================
		defb	"small"			;(80) small font command
		defb	B_7+B_6+B_5
		defw	html_cmd_small
		defb	0
;===============================================================================
		defb	"big"			;(81) big font
		defb	B_7+B_6
		defw	html_cmd_big
		defb	0
;===============================================================================
; The commands following here are to occur after the above so that
; the search finds them (these are for single letter commands).
;===============================================================================
		defb	"p"			;(82) new paragraph
		defb	B_7+B_6+B_5+B_1
		defw	html_cmd_p
		defb	0
;===============================================================================
		defb	"b"			;(83) bold font command
		defb	B_7+B_6+B_5
		defw	html_cmd_b
		defb	0
;===============================================================================
		defb	"i"			;(84) italic font command
		defb	B_7+B_6+B_5
		defw	html_cmd_i
		defb	0
;===============================================================================
		defb	"u"			;(85) italic font command
		defb	B_7+B_6+B_5
		defw	html_cmd_u
		defb	0
;===============================================================================
		defb	"a"			;(86) start of 'a href', etc
		defb	B_7+B_6+B_5
		defw	HTML_cmd_a
		defb	0
;===============================================================================
		defb	0
;===============================================================================
;
;  Error Message(s)
;
;===============================================================================
Netwrk_Msg	defb	"No Network, Press ESC"
		defb	0
		DEFB	KEY_ESC
		DEFW	&FFFF		;trigger to handle ESC key
		DEFB	0
		DEFB	KEY_ENDLIST
