;===============================================================================
;
; Browser application Data (Style Commands)
; Copyright (c) 2010 Ray Palmer
;
;===============================================================================
STYLE_CssTyp		DEFM	"text/"
STYLE_Css		DEFM	"css"
;===============================================================================
;
;  Style commands
;
;  Style commands can be associated with any HTML element/command.
;  The html data controls which command is allowed to use styles.
;  See the format description below for flag settings.
;  Do not set bit 1 on the byte after the style command text.
;
;  The command listed below are the ones which the browser can handle.
;  All other command which are encountered are not handled with no effect to
;  the style format.
;
;===============================================================================
HTM_StyleCmds
;
HTM_SC_fontsize		EQU	0
			DEFM	"font-size"
			DEFB	B_7+B_5
			DEFW	0
			DEFB	0
;
HTM_SC_fontvar		EQU	1
			DEFM	"font-variant"
			DEFB	B_7+B_5
			DEFW	STY_FontEffect
			DEFB	0
;
HTM_SC_fontfamily	EQU	2
			DEFM	"font-family"
			DEFB	B_7+B_5
			DEFW	0
			DEFB	0
;
HTM_SC_font		EQU	3
			DEFM	"font"
			DEFB	B_7+B_5
			DEFW	STY_FontSelect
			DEFB	0
;
HTM_SC_border		EQU	4
			DEFM	"border"
			DEFB	B_7+B_5
			DEFW	STY_BorderType
			DEFB	0
;
HTM_SC_borderw		EQU	5
			DEFM	"border-width"
			DEFB	B_7+B_5
			DEFW	STY_BorderWidth
			DEFB	0
;
HTM_SC_borderwr		EQU	6
			DEFM	"border-width-right"
			DEFB	B_7+B_5
			DEFW	STY_BorderWidth
			DEFB	0
;
HTM_SC_borderwl		EQU	7
			DEFM	"border-width-left"
			DEFB	B_7+B_5
			DEFW	STY_BorderWidth
			DEFB	0
;
HTM_SC_borderwt		EQU	8
			DEFM	"border-width-top"
			DEFB	B_7+B_5
			DEFW	STY_BorderWidth
			DEFB	0
;
HTM_SC_borderwb		EQU	9
			DEFM	"border-width-bottom"
			DEFB	B_7+B_5
			DEFW	STY_BorderWidth
			DEFB	0
;
HTM_SC_borders		EQU	10
			DEFM	"border-style"
			DEFB	B_7+B_5
			DEFW	STY_BorderStyle
			DEFB	0
;
HTM_SC_fontstyle	EQU	11
			DEFM	"font-style"
			DEFB	B_7+B_5
			DEFW	0
			DEFB	0
;
HTM_SC_wrdspce		EQU	12
			DEFM	"word-spacing"
			DEFB	B_7+B_5
			DEFW	0
			DEFB	0
;
HTM_SC_ltrspce		EQU	13
			DEFM	"letter-spacing"
			DEFB	B_7+B_5
			DEFW	0
			DEFB	0
;
HTM_SC_testtrns		EQU	14
			DEFM	"text-transform"
			DEFB	B_7+B_5
			DEFW	0
			DEFB	0
;
HTM_SC_nlineb		EQU	15
			DEFM	"newlineb"		;newline before
			DEFB	B_7+B_5
			DEFW	STY_newlineb
			DEFB	0
;
HTM_SC_nlinea		EQU	16
			DEFM	"newlinea"		;newline after
			DEFB	B_7+B_5
			DEFW	STY_newlinea
			DEFB	0
;
			DEFB	128		;end of params type strings
;