;=========================================================================
;Name     App_CalcAddr
;Purpose  To calculate the table entry address
;In Regs  A = Application Id
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  N/A
;Out Regs AF = ??
;         BC = corrupted.
;         DE = ??
;         HL = address of table entry
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    None
;Notes    1. The Apps configuration memory bank has been swapped in.
;=========================================================================
App_CalcAddr
   LD    HL,SysBnkBuffer
   LD    BC,S_AppEntSize
App_CalcAppAddr1
   OR    A
   RET   Z
   ADD   HL,BC
   DEC   A
   JR    App_CalcAppAddr1
;=========================================================================
;Name     APP_GetStatus2a
;Purpose  To get status of type of Application entry
;In Regs  A = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  App_State = Status of application/handler
;Out Regs AF = ??
;         BC = ??
;         D = ??
;         E = Char to display
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars TBD
;Uses     TBD
;Call By  TBD
;Calls    None
;Notes    NOne
;=========================================================================
APP_GetStatus2a
   LD    E,'-'
   BIT   1,A				;entry available
   RET   Z				;No
   LD    E,'A'
   BIT   5,A				;Application?
   RET   Z				;No
   LD    E,'H'				;show entry handler
   RET
;=========================================================================
;Name     BuildScrptCmd
;Purpose  To create the script command
;In Regs  AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer has command
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    1. FIX ME
;=========================================================================
BuildScrptCmd
   CALL  App_CalcAddr
   LD    DE,SysGenBuffer
   LD    BC,S_AppEntSize
   LDIR					;download App structure
   LD    A,(SysGenBuffer)
   BIT   1,A				;Entry available to access?
   RET   Z				;No
   LD    DE,KB_Buffer
   LD    HL,Script_App
   LD    BC,3
   LDIR					;Insert 'app' command
   LD    A,32
   LD    (DE),A
   INC   DE
   LD    A,(SysGenBuffer+S_AppsState)
   CALL  APP_GetStatus2a		;app or handler char
   LD    A,E
   LD    (DE),A
   INC   DE
   LD    A,','
   LD    (DE),A
   INC   DE
   LD    HL,SysGenBuffer+S_AppsName
   LD    B,MaxAppName
   CALL  UTL_strncpy			;Copy app name
   LD    A,','
   LD    (DE),A
   INC   DE
   LD    HL,SysGenBuffer+S_AppsFileName
   LD    B,MaxAppFileName
   CALL  UTL_strncpy			;insert app filename
   LD    A,13
   LD    (DE),A				;insert carriage return
   INC   DE
   LD    A,10
   LD    (DE),A				;insert linefeed
   INC   DE
   XOR   A
   LD    (DE),A				;insert terminator
   RET