;=========================================================================
;Name     BuildScriptCmd
;Purpose  To create the script command
;In Regs  AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = ??
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer has command
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
BuildScriptCmd
   PUSH  BC
   PUSH  HL
;
   LD    HL,KB_Buffer
   CALL  VIY_CalcAddr
   EX    DE,HL
   LD    HL,Script_Cmd
   PUSH  HL
   CALL  UTL_strlen
   LD    C,A
   LD    B,0
   POP   HL
   LDIR					;insert script command
;
   POP   HL
   POP   BC
   PUSH  BC
;
   INC   DE
   LD    A,B
   LD    (DE),A				;insert cursor type
   INC   DE
   LD    A,SPACE_CHAR
   LD    (DE),A				;insert a space
   INC   DE
   LD    A,B
   CP    't'				;cursor tracking setting?
   JR    NZ,BuildScriptCmd1		;No
   PUSH  DE
   LD    DE,10
   CALL  Mth_Divide			;divide by 10
   LD    A,C
   POP   DE
BuildScriptCmd1
   EX    DE,HL
   CALL  UTL_writedec			;insert decimal string
   EX    DE,HL
;
   POP   BC
   LD    A,B
   CP    "i"
   JR    NZ,BuildScriptCmd2
   LD    A,C
   EX    DE,HL
   CALL  UTL_writedec			;insert decimal string
   EX    DE,HL
;
BuildScriptCmd2
   LD    A,13
   LD    (DE),A				;insert carriage return
   INC   DE
   LD    A,10
   LD    (DE),A				;insert linefeed
   INC   DE
   XOR   A
   LD    (DE),A				;insert terminator
   RET
;=========================================================================
;Name     GetCursorValue
;Purpose  To get the value of a byte from banked memory.
;In Regs  AF = Configuration memory byte
;         BC = ??
;         DE = ??
;         HL = Address in the banked memory
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         D = ??
;         E = Byte value at address in the banked memory.
;         HL = value at address in the banked memory (H = 0)
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer has command
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
GetCursorValue
   LD    A,(Item_Bank)
   CALL  CPCB_GetBnkByte
   LD    L,E
   LD    H,0
   RET
;=========================================================================
;Name     GetCursorValue
;Purpose  To get the value of a byte from banked memory.
;In Regs  AF = Configuration memory byte
;         BC = ??
;         DE = ??
;         HL = Address in the banked memory
;         IX = ??
;         IY = ??
;In Vars  TBD
;Out Regs AF = ??
;         BC = ??
;         DE = value at address in the banked memory
;         HL = ??
;         IX = ??
;         IY = ??
;Out Vars KB_Buffer has command
;Uses     TBD
;Call By  TBD
;Calls    TBD
;Notes    TBD
;=========================================================================
GetCursorWord
   LD    A,(Item_Bank)
   CALL  CPCB_GetBnkWord
   RET